CREATE USER 'SNMPMON'@'%';
CREATE USER 'SNMPMON'@'localhost';
update mysql.user set plugin = 'mysql_native_password' where User='SNMPMON';
FLUSH PRIVILEGES;

GRANT ALL PRIVILEGES ON * . * TO 'SNMPMON'@'%' WITH GRANT OPTION MAX_QUERIES_PER_HOUR 0 MAX_CONNECTIONS_PER_HOUR 0 MAX_UPDATES_PER_HOUR 0 MAX_USER_CONNECTIONS 0 ;
GRANT ALL PRIVILEGES ON * . * TO 'SNMPMON'@'localhost' WITH GRANT OPTION MAX_QUERIES_PER_HOUR 0 MAX_CONNECTIONS_PER_HOUR 0 MAX_UPDATES_PER_HOUR 0 MAX_USER_CONNECTIONS 0 ;

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL';

CREATE SCHEMA IF NOT EXISTS `snmpmon` DEFAULT CHARACTER SET utf8 ;
USE `snmpmon` ;

-- -----------------------------------------------------
-- Table `snmpmon`.`devices`
-- -----------------------------------------------------
CREATE  TABLE IF NOT EXISTS `snmpmon`.`devices` (
  `device_id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT ,
  `enabled` TINYINT(1) NOT NULL DEFAULT '1' ,
  `hostname` VARCHAR(32) NULL DEFAULT NULL ,
  `community` VARCHAR(32) NULL DEFAULT NULL ,
  `description` VARCHAR(32) NULL DEFAULT NULL ,
  `location` VARCHAR(32) NULL DEFAULT NULL ,
  `product` VARCHAR(32) NULL DEFAULT NULL ,
  `firmware` VARCHAR(32) NULL DEFAULT NULL ,
  `mac` VARCHAR(17) NULL DEFAULT NULL ,
  `last_rx` INT(10) UNSIGNED NULL DEFAULT NULL ,
  `last_tx` INT(10) UNSIGNED NULL DEFAULT NULL ,
  `last_connect` INT(10) UNSIGNED NULL DEFAULT NULL ,
  `cfg_update_time` DATETIME NULL DEFAULT NULL ,
  `last_status` TINYINT(2) UNSIGNED NULL DEFAULT NULL ,
  `last_level` TINYINT(4) NULL DEFAULT NULL ,
  PRIMARY KEY (`device_id`) )
ENGINE = MyISAM
AUTO_INCREMENT = 85396
DEFAULT CHARACTER SET = utf8
PACK_KEYS = 0;


-- -----------------------------------------------------
-- Table `snmpmon`.`fails`
-- -----------------------------------------------------
CREATE  TABLE IF NOT EXISTS `snmpmon`.`fails` (
  `device_id` INT(10) UNSIGNED NOT NULL DEFAULT '0' ,
  `time` DATETIME NULL DEFAULT NULL ,
  INDEX `device_id` (`device_id` ASC) )
ENGINE = MyISAM
DEFAULT CHARACTER SET = utf8;


DROP TABLE IF EXISTS `snmpmon`.`selection`;
-- -----------------------------------------------------
-- Table `snmpmon`.`selection`
-- -----------------------------------------------------
CREATE  TABLE IF NOT EXISTS `snmpmon`.`selection` (
  `id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT ,
  `device_id` INT(10) UNSIGNED NOT NULL ,
  `time` DATETIME NOT NULL ,
  `session_id` VARCHAR(45) NOT NULL ,
  PRIMARY KEY (`id`) )
ENGINE = MyISAM
AUTO_INCREMENT = 107
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `snmpmon`.`stats`
-- -----------------------------------------------------
CREATE  TABLE IF NOT EXISTS `snmpmon`.`stats` (
  `stat_id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT ,
  `device_id` INT(10) UNSIGNED NOT NULL DEFAULT '0' ,
  `time` DATETIME NULL DEFAULT NULL ,
  `latency` INT(10) UNSIGNED NULL DEFAULT NULL ,
  `rx` INT(10) UNSIGNED NULL DEFAULT NULL ,
  `tx` INT(10) UNSIGNED NULL DEFAULT NULL ,
  `rx_diff` INT(10) UNSIGNED NULL DEFAULT NULL ,
  `tx_diff` INT(10) UNSIGNED NULL DEFAULT NULL ,
  `status` TINYINT(2) UNSIGNED NULL DEFAULT NULL ,
  `plmn` INT(10) UNSIGNED NULL DEFAULT NULL ,
  `cell` INT(10) UNSIGNED NULL DEFAULT NULL ,
  `channel` SMALLINT(5) UNSIGNED NULL DEFAULT NULL ,
  `level` TINYINT(4) NULL DEFAULT NULL ,
  `channel_n1` SMALLINT(5) UNSIGNED NULL DEFAULT NULL ,
  `level_n1` TINYINT(4) NULL DEFAULT NULL ,
  `channel_n2` SMALLINT(5) UNSIGNED NULL DEFAULT NULL ,
  `level_n2` TINYINT(4) NULL DEFAULT NULL ,
  `channel_n3` SMALLINT(5) UNSIGNED NULL DEFAULT NULL ,
  `level_n3` TINYINT(4) NULL DEFAULT NULL ,
  `channel_n4` SMALLINT(5) UNSIGNED NULL DEFAULT NULL ,
  `level_n4` TINYINT(4) NULL DEFAULT NULL ,
  `channel_n5` SMALLINT(5) UNSIGNED NULL DEFAULT NULL ,
  `level_n5` TINYINT(4) NULL DEFAULT NULL ,
  `uptime` INT(10) UNSIGNED NULL DEFAULT NULL ,
  `connect` INT(10) UNSIGNED NULL DEFAULT NULL ,
  `disconnect` INT(10) UNSIGNED NULL DEFAULT NULL ,
  `alt` TINYINT(1) UNSIGNED NULL DEFAULT NULL ,
  PRIMARY KEY (`stat_id`) ,
  INDEX `device_id` (`device_id` ASC) )
ENGINE = MyISAM
AUTO_INCREMENT = 8122093
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `snmpmon`.`summary`
-- -----------------------------------------------------
CREATE  TABLE IF NOT EXISTS `snmpmon`.`summary` (
  `summary_id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT ,
  `time` DATETIME NULL DEFAULT NULL ,
  `device_count` INT(10) UNSIGNED NULL DEFAULT NULL ,
  `device_working` INT(10) UNSIGNED NULL DEFAULT NULL ,
  `average_latency` SMALLINT(5) UNSIGNED NULL DEFAULT NULL ,
  `average_level` TINYINT(4) NULL DEFAULT NULL ,
  `time_cycle` INT(5) UNSIGNED NULL DEFAULT NULL ,
  PRIMARY KEY (`summary_id`) )
ENGINE = MyISAM 
AUTO_INCREMENT = 3321
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `snmpmon`.`users`
-- -----------------------------------------------------
CREATE  TABLE IF NOT EXISTS `snmpmon`.`users` (
  `user_id` INT(11) NOT NULL AUTO_INCREMENT ,
  `username` VARCHAR(20) NOT NULL ,
  `password` CHAR(41) NOT NULL ,
  `rights`   TINYINT  NOT NULL,  
  PRIMARY KEY (`user_id`) )
ENGINE = MyISAM
AUTO_INCREMENT = 2
DEFAULT CHARACTER SET = utf8;

-- -----------------------------------------------------
-- Table `snmpmon`.`log`
-- -----------------------------------------------------

CREATE  TABLE IF NOT EXISTS `snmpmon`.`log` (  `log_id` INT NOT NULL AUTO_INCREMENT ,  `time` DATETIME NOT NULL ,  `event` VARCHAR(255) NOT NULL ,  PRIMARY KEY (`log_id`) )ENGINE = MyISAM;


-- -----------------------------------------------------
-- Table `snmpmon`.`day`
-- -----------------------------------------------------

CREATE  TABLE IF NOT EXISTS `snmpmon`.`day` (
  `day_id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT ,
  `device_id` INT(10) UNSIGNED NOT NULL DEFAULT '0' ,
  `date` DATE NULL DEFAULT NULL ,
  `availability` FLOAT(4,1) UNSIGNED NULL DEFAULT NULL ,
  `packetloss` FLOAT(4,1) UNSIGNED NULL DEFAULT NULL ,
  `level_aver` TINYINT(4) NULL DEFAULT NULL ,
  `level_min` TINYINT(4) NULL DEFAULT NULL ,
  `level_max` TINYINT(4) NULL DEFAULT NULL ,
  `latency` SMALLINT(5) UNSIGNED NULL DEFAULT NULL ,
  `numconn` SMALLINT(5) UNSIGNED NULL DEFAULT NULL ,
  `numswitch` SMALLINT(5) UNSIGNED NULL DEFAULT NULL ,
  `rx` INT(10) UNSIGNED NULL DEFAULT NULL ,
  `tx` INT(10) UNSIGNED NULL DEFAULT NULL ,
  `cell` INT(10) UNSIGNED NULL DEFAULT NULL ,
  `rx2` INT(10) UNSIGNED NULL DEFAULT NULL ,
  `tx2` INT(10) UNSIGNED NULL DEFAULT NULL ,
  `alt_used` FLOAT(4,1) UNSIGNED NULL DEFAULT NULL ,
  PRIMARY KEY (`day_id`) ,
  UNIQUE INDEX `UNIQUE` (`device_id` ASC, `date` ASC) )
ENGINE = MyISAM
AUTO_INCREMENT = 40
DEFAULT CHARACTER SET = utf8; 


-- -----------------------------------------------------
-- Table `snmpmon`.`groups`
-- -----------------------------------------------------

CREATE TABLE IF NOT EXISTS `snmpmon`.`groups` (
  `group_id` int(10) unsigned NOT NULL auto_increment,
  `description` varchar(32) default NULL,
  PRIMARY KEY  (`group_id`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 AUTO_INCREMENT=4 ;


-- -----------------------------------------------------
-- Table `snmpmon`.`user_group`
-- -----------------------------------------------------

CREATE TABLE IF NOT EXISTS `snmpmon`.`user_group` (
  `user_group_id` int(10) unsigned NOT NULL auto_increment,
  `group_id` int(10) unsigned NOT NULL,
  `user_id` int(10) unsigned NOT NULL,
  `status_email` tinyint(1) unsigned NOT NULL default '0',
  `status_sms` tinyint(1) unsigned NOT NULL default '0',
  `traffic_email` tinyint(1) unsigned NOT NULL default '0',
  `traffic_sms` tinyint(1) unsigned NOT NULL default '0',
  `level_email` tinyint(1) unsigned NOT NULL default '0',
  `level_sms` tinyint(1) unsigned NOT NULL default '0',
  `autoupdate_email` tinyint(1) unsigned NOT NULL default '0',
  `autoupdate_sms` tinyint(1) unsigned NOT NULL default '0',
  `psw_email` tinyint(1) unsigned NOT NULL default '0',
  `psw_sms` tinyint(1) unsigned NOT NULL default '0',
  `trap_poll_email` tinyint(1) unsigned default '0',
  `trap_poll_sms` tinyint(1) unsigned default '0',
  PRIMARY KEY  (`user_group_id`),
  UNIQUE (`group_id`,`user_id`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 AUTO_INCREMENT=4 ;
         
-- -----------------------------------------------------
-- Table `snmpmon`.`companies`
-- -----------------------------------------------------
CREATE  TABLE IF NOT EXISTS `snmpmon`.`companies` (
  `company_id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT ,
  `name` varchar(32) default NULL,
  `devcount` INT(10) UNSIGNED default NULL,
  `address` varchar(64) default NULL,
  `email` varchar(64) default NULL,
  `phone` varchar(32) default NULL,
  `note` varchar(64) default NULL,
  `logo` mediumblob default NULL,
  `warning_enabled` tinyint(1) default 0,
  `ident_descr` tinyint(1) unsigned NOT NULL default 1,
  `ident_location` tinyint(1) unsigned NOT NULL default 1,
  `ident_ip` tinyint(1) unsigned NOT NULL default 0,
  `ident_mac` tinyint(1) unsigned NOT NULL default 0,
  `sms_hostname` varchar(32) default NULL,
  `sms_port` int(5) default NULL,
  `smtp_hostname` varchar(32) default NULL,
  `smtp_port` int(5) default NULL,
  `smtp_from` varchar(32) default NULL,
  `smtp_sub` varchar(32) default NULL,
  `smtp_user` varchar(32) default NULL,
  `smtp_psw` varchar(32) default NULL,
  `msg_status_off` varchar(64) default NULL,
  `msg_status_on` varchar(64) default NULL,
  `msg_traffic` varchar(64) default NULL,
  `msg_level` varchar(64) default NULL,
  `msg_trap_poll` varchar(64) default NULL,
  `sms_limit` INT(10) UNSIGNED default 50,
  `email_limit` INT(10) UNSIGNED default 50,  
  PRIMARY KEY (`company_id`) )
ENGINE = MyISAM DEFAULT CHARACTER SET = utf8;

-- -----------------------------------------------------
-- Table `snmpmon`.`user_cfg`
-- -----------------------------------------------------
CREATE  TABLE IF NOT EXISTS `snmpmon`.`user_cfg` (
  `user_cfg_id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT ,
  `user_id` INT(10) UNSIGNED NOT NULL,
  `par` varchar(32) default NULL,
  `value` varchar(200) default NULL,
  PRIMARY KEY (`user_cfg_id`),
  UNIQUE KEY(`user_id`,`par`) )
ENGINE = MyISAM DEFAULT CHARACTER SET = utf8;

-- -----------------------------------------------------
-- Table `snmpmon`.`comp_cfg`
-- -----------------------------------------------------
CREATE  TABLE IF NOT EXISTS `snmpmon`.`comp_cfg` (
  `comp_cfg_id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT ,
  `comp_id` INT(10) UNSIGNED NOT NULL,
  `par` varchar(32) default NULL,
  `value` varchar(200) default NULL,
  PRIMARY KEY (`comp_cfg_id`),
  UNIQUE KEY(`comp_id`,`par`) )
ENGINE = MyISAM DEFAULT CHARACTER SET = utf8;

-- -----------------------------------------------------
-- Table `snmpmon`.`predef_sms`
-- -----------------------------------------------------
CREATE  TABLE IF NOT EXISTS `snmpmon`.`predef_sms` (
  `user_sms_id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT ,
  `user_id` INT(10) UNSIGNED NOT NULL,
  `sms` varchar(160) default NULL,
  PRIMARY KEY (`user_sms_id`))
ENGINE = MyISAM DEFAULT CHARACTER SET = utf8;



-- -----------------------------------------------------
-- Table `snmpmon`.`wd_info`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `snmpmon`.`wd_info` (
  `time` datetime NOT NULL,
  `num_poll` int(10) unsigned NOT NULL default '0',
  `num_trap` int(10) unsigned NOT NULL default '0',
  `backup` tinyint(1) unsigned NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- -----------------------------------------------------
-- Table `snmpmon`.`device_notes`
-- -----------------------------------------------------
CREATE  TABLE IF NOT EXISTS `snmpmon`.`device_notes` (
  `note_id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT ,
  `device_id` INT(10) UNSIGNED NOT NULL,
  `user_id` INT(10) UNSIGNED DEFAULT NULL,
  `time` DATETIME DEFAULT NULL,
  `note` VARCHAR(500) DEFAULT NULL,
  PRIMARY KEY (`note_id`))
ENGINE = MyISAM DEFAULT CHARACTER SET = utf8;


ALTER TABLE `snmpmon`.`summary` ADD COLUMN `availability` FLOAT(4,1) UNSIGNED NULL DEFAULT NULL  AFTER `average_level`;

ALTER TABLE `snmpmon`.`devices` ADD COLUMN `autoupdate` TINYINT(1) NOT NULL DEFAULT '1'  AFTER `last_level` ;

ALTER TABLE `snmpmon`.`devices` ADD COLUMN `health` TINYINT(2) UNSIGNED NULL DEFAULT NULL  AFTER `autoupdate` ;

ALTER TABLE `snmpmon`.`devices` ADD COLUMN `last_time_act` DATETIME DEFAULT NULL  AFTER `health` ;

ALTER TABLE `snmpmon`.`day` ADD COLUMN `numtech` SMALLINT(5) UNSIGNED NULL DEFAULT NULL  AFTER `cell`;

ALTER TABLE `snmpmon`.`fails` ADD COLUMN `fail_id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT  FIRST, ADD PRIMARY KEY (`fail_id`) ;

ALTER TABLE `snmpmon`.`devices` ADD COLUMN `note` VARCHAR(32) NULL DEFAULT NULL  AFTER `location` ;

ALTER TABLE `snmpmon`.`devices` ADD COLUMN `hostname_alt` VARCHAR(32) NULL DEFAULT NULL  AFTER `hostname` ;

ALTER TABLE `snmpmon`.`devices` ADD COLUMN `hostname_alt2` VARCHAR(32) NULL DEFAULT NULL  AFTER `hostname_alt` ;

ALTER TABLE `snmpmon`.`devices` ADD COLUMN `health_alt` TINYINT(2) UNSIGNED NULL DEFAULT NULL  AFTER `health` , ADD COLUMN `last_time_act_alt` DATETIME NULL DEFAULT NULL  AFTER `last_time_act` ;

ALTER TABLE `snmpmon`.`devices` ADD COLUMN `health_alt2` TINYINT(2) UNSIGNED NULL DEFAULT NULL  AFTER `health_alt` , ADD COLUMN `last_time_act_alt2` DATETIME NULL DEFAULT NULL  AFTER `last_time_act_alt` ;

ALTER TABLE `snmpmon`.`devices` ADD COLUMN `phone` VARCHAR(15) NULL DEFAULT NULL  AFTER `last_time_act_alt` , ADD COLUMN `phone_alt` VARCHAR(15) NULL DEFAULT NULL  AFTER `phone` ;

ALTER TABLE `snmpmon`.`summary` ENGINE = MyISAM ;

ALTER TABLE `snmpmon`.`day` ADD COLUMN `rx2` INT(10) UNSIGNED NULL DEFAULT NULL ;

ALTER TABLE `snmpmon`.`day` ADD COLUMN `tx2` INT(10) UNSIGNED NULL DEFAULT NULL ;

ALTER TABLE `snmpmon`.`day` ADD COLUMN `alt_used` FLOAT(4,1) UNSIGNED NULL DEFAULT NULL ;

ALTER TABLE `snmpmon`.`stats` ADD COLUMN `alt` TINYINT(1) UNSIGNED NULL DEFAULT NULL ;

ALTER TABLE `snmpmon`.`day` ADD COLUMN `numconn2` SMALLINT(5) UNSIGNED NULL DEFAULT NULL ;

ALTER TABLE `snmpmon`.`day` ADD COLUMN `numconn3` SMALLINT(5) UNSIGNED NULL DEFAULT NULL ;

ALTER TABLE `snmpmon`.`day` ADD COLUMN `numswitch2` SMALLINT(5) UNSIGNED NULL DEFAULT NULL ;

ALTER TABLE `snmpmon`.`day` ADD COLUMN `numswitch3` SMALLINT(5) UNSIGNED NULL DEFAULT NULL ;

ALTER TABLE `snmpmon`.`day` ADD COLUMN `numtech2` SMALLINT(5) UNSIGNED NULL DEFAULT NULL ;

ALTER TABLE `snmpmon`.`day` ADD COLUMN `numtech3` SMALLINT(5) UNSIGNED NULL DEFAULT NULL ;

ALTER TABLE `snmpmon`.`users` ADD COLUMN `rights` TINYINT(4) NOT NULL ;

ALTER TABLE `snmpmon`.`devices` ADD COLUMN `sn` INT(7) UNSIGNED NULL DEFAULT NULL  AFTER `mac` ;

ALTER TABLE `snmpmon`.`devices` ADD COLUMN `imei` VARCHAR(15) NULL DEFAULT NULL  AFTER `sn` ;

ALTER TABLE `snmpmon`.`devices` ADD COLUMN `esn` VARCHAR(8) NULL DEFAULT NULL  AFTER `imei` ;

ALTER TABLE `snmpmon`.`devices` ADD COLUMN `period` INT(5) UNSIGNED NULL DEFAULT NULL ;

ALTER TABLE `snmpmon`.`devices` ADD COLUMN `trap` TINYINT(1) NOT NULL DEFAULT '0' ;

ALTER TABLE `snmpmon`.`devices` ADD COLUMN `read_location` TINYINT(1) NOT NULL DEFAULT '0' ;

ALTER TABLE `snmpmon`.`devices` ADD COLUMN `coordinates` VARCHAR(45) NULL DEFAULT NULL AFTER `location` ;

ALTER TABLE `snmpmon`.`devices` ADD UNIQUE (`mac`);

ALTER TABLE `snmpmon`.`devices` ADD `group_id` INT(10) UNSIGNED DEFAULT NULL AFTER `device_id` ;
ALTER TABLE `snmpmon`.`devices` ADD `accounting_start` TINYINT UNSIGNED DEFAULT "1" AFTER `last_tx` ;
ALTER TABLE `snmpmon`.`devices` ADD `accounting_start_alt` TINYINT UNSIGNED DEFAULT "1" AFTER `accounting_start` ;
ALTER TABLE `snmpmon`.`devices` ADD `accounting_start_alt2` TINYINT UNSIGNED DEFAULT "1" AFTER `accounting_start_alt` ;

ALTER TABLE `snmpmon`.`log` ADD `user_id` INT(10) UNSIGNED DEFAULT NULL AFTER `event`;

ALTER TABLE `snmpmon`.`log` ADD `posted_email` TINYINT(1) UNSIGNED DEFAULT '0',
ADD `posted_sms` TINYINT(1) UNSIGNED DEFAULT '0';

UPDATE IGNORE `snmpmon`.`users` SET `rights` = 1 WHERE `user_id` = 1;

ALTER TABLE `snmpmon`.`devices` ADD `rx_account` INT(10) UNSIGNED DEFAULT NULL AFTER `last_tx` ,
ADD `tx_account` INT(10) UNSIGNED DEFAULT NULL AFTER `rx_account` ;

ALTER TABLE `snmpmon`.`devices` ADD `rx_account_alt` INT(10 ) UNSIGNED DEFAULT NULL AFTER `tx_account` ,
ADD `tx_account_alt` INT( 10 ) UNSIGNED DEFAULT NULL AFTER `rx_account_alt` ;

ALTER TABLE `snmpmon`.`devices` ADD `rx_account_alt2` INT(10 ) UNSIGNED DEFAULT NULL AFTER `tx_account_alt` ,
ADD `tx_account_alt2` INT( 10 ) UNSIGNED DEFAULT NULL AFTER `rx_account_alt2` ;

ALTER TABLE `snmpmon`.`user_group` ADD `trap_poll_email` TINYINT( 1 ) UNSIGNED DEFAULT '0',
ADD `trap_poll_sms` TINYINT( 1 ) UNSIGNED DEFAULT '0';

ALTER TABLE `snmpmon`.`users` ADD COLUMN `company_id` INT(10) UNSIGNED DEFAULT NULL AFTER `user_id`;
UPDATE `snmpmon`.`users` SET company_id = 1 WHERE company_id IS NULL;


ALTER TABLE `snmpmon`.`groups` ADD COLUMN `company_id` INT(10) UNSIGNED DEFAULT NULL AFTER `group_id`;
ALTER TABLE `snmpmon`.`groups` ADD COLUMN `level_limit` TINYINT SIGNED DEFAULT NULL AFTER `description`;
ALTER TABLE `snmpmon`.`groups` ADD COLUMN `traffic_limit` INT UNSIGNED DEFAULT NULL AFTER `level_limit`;
ALTER TABLE `snmpmon`.`groups` ADD COLUMN `traffic_limit_alt` INT UNSIGNED DEFAULT NULL AFTER `traffic_limit`;
ALTER TABLE `snmpmon`.`groups` ADD COLUMN `traffic_limit_alt2` INT UNSIGNED DEFAULT NULL AFTER `traffic_limit_alt`;
INSERT INTO `snmpmon`.`groups` (group_id, company_id, description) VALUES (1,1,"Default") ON DUPLICATE KEY UPDATE group_id = group_id;

ALTER TABLE `snmpmon`.`users` ADD COLUMN `name` VARCHAR(32) DEFAULT NULL AFTER `password`;

ALTER TABLE `snmpmon`.`users` ADD COLUMN `surname` VARCHAR(32) DEFAULT NULL AFTER `name`;

ALTER TABLE `snmpmon`.`users` ADD COLUMN `email` VARCHAR(32) DEFAULT NULL AFTER `surname`;

ALTER TABLE `snmpmon`.`users` ADD COLUMN `phone` VARCHAR(16) DEFAULT NULL AFTER `email`;

ALTER TABLE `snmpmon`.`users` ADD COLUMN `edit_device` TINYINT(1) NOT NULL DEFAULT '0';

INSERT INTO `snmpmon`.`companies` (company_id, name) VALUES (1,"Default") ON DUPLICATE KEY UPDATE company_id = company_id;

INSERT INTO `snmpmon`.`users` (user_id, company_id, username, password, rights) VALUES (1,1,"admin",PASSWORD("conel"),1) ON DUPLICATE KEY UPDATE user_id = user_id;
--INSERT INTO `snmpmon`.`users` (user_id, company_id, username, password, rights) VALUES (2,0,"root",PASSWORD("conel"),0) ON DUPLICATE KEY UPDATE user_id = user_id;

UPDATE `snmpmon`.`devices` SET group_id = 1 WHERE group_id IS NULL;
UPDATE `snmpmon`.`companies` SET devcount = 5 WHERE devcount IS NULL;

ALTER TABLE `snmpmon`.`log` ADD `company_id` INT(10) UNSIGNED AFTER `user_id`; 

ALTER TABLE `snmpmon`.`stats` ADD `availability` FLOAT( 4, 1 ) UNSIGNED DEFAULT NULL AFTER `status` ;

ALTER TABLE `snmpmon`.`summary` ADD COLUMN `group_id` INT(10) UNSIGNED DEFAULT 1 AFTER `summary_id`, ADD INDEX `group_id` (`group_id` ASC);

ALTER TABLE `snmpmon`.`groups` ADD `report_period` INT( 10 ) UNSIGNED DEFAULT '900' NOT NULL ;

ALTER TABLE `snmpmon`.`companies` ADD `default_group` INT( 10 ) UNSIGNED DEFAULT '1' NOT NULL , ADD `addtrap_en` TINYINT( 1 ) UNSIGNED DEFAULT '1' NOT NULL ;

ALTER TABLE `snmpmon`.`summary` ADD `packetloss` FLOAT( 4, 1 ) UNSIGNED NOT NULL AFTER `availability` ;

ALTER TABLE `snmpmon`.`stats` ADD `signal_quality` TINYINT( 3 ) DEFAULT NULL AFTER `level_n5` ;

ALTER TABLE `snmpmon`.`devices` ADD `read_gps` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';


ALTER TABLE `snmpmon`.`devices` ADD `read_temp_volt` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';

ALTER TABLE `snmpmon`.`devices` ADD `last_rx2` INT( 10 ) UNSIGNED DEFAULT NULL AFTER `last_tx` ,
ADD `last_tx2` INT( 10 ) UNSIGNED DEFAULT NULL AFTER `last_rx2` ,
ADD `last_rx3` INT( 10 ) UNSIGNED DEFAULT NULL AFTER `last_tx2` ,
ADD `last_tx3` INT( 10 ) UNSIGNED DEFAULT NULL AFTER `last_rx3` ;

ALTER TABLE `snmpmon`.`devices` ADD `last_connect2` INT( 10 ) UNSIGNED DEFAULT NULL AFTER `last_connect` ,
ADD `last_connect3` INT( 10 ) UNSIGNED DEFAULT NULL AFTER `last_connect2` ;

ALTER TABLE `snmpmon`.`devices` ADD `new` TINYINT( 1 ) UNSIGNED DEFAULT '0' NOT NULL ;
ALTER TABLE `snmpmon`.`devices` ADD `new_time` DATETIME DEFAULT NULL AFTER `new`;
ALTER TABLE `snmpmon`.`devices` ADD `uptime` INT( 10 ) UNSIGNED DEFAULT NULL;

ALTER TABLE `snmpmon`.`stats` ADD `temp` TINYINT( 3 ) DEFAULT NULL AFTER `signal_quality` ,
ADD `voltage` FLOAT( 6, 3 ) UNSIGNED DEFAULT NULL AFTER `temp` ;

ALTER TABLE `snmpmon`.`devices` ADD `last_quality` TINYINT( 3 ) DEFAULT NULL AFTER `last_level` ;

ALTER TABLE `snmpmon`.`devices` ADD `last_temp` TINYINT( 3 ) DEFAULT NULL AFTER `last_quality` ;
ALTER TABLE `snmpmon`.`devices` ADD `last_volt` FLOAT( 6, 3 ) DEFAULT NULL AFTER `last_temp` ;

ALTER TABLE `snmpmon`.`day` ADD `sig_qual_aver` TINYINT( 3 ) NULL DEFAULT NULL AFTER `level_max` ,
ADD `sig_qual_min` TINYINT( 3 ) NULL DEFAULT NULL AFTER `sig_qual_aver` ,
ADD `sig_qual_max` TINYINT( 3 ) NULL DEFAULT NULL AFTER `sig_qual_min` ,
ADD `temp_aver` TINYINT( 3 ) NULL DEFAULT NULL AFTER `sig_qual_max` ,
ADD `temp_min` TINYINT( 3 ) NULL DEFAULT NULL AFTER `temp_aver` ,
ADD `temp_max` TINYINT( 3 ) NULL DEFAULT NULL AFTER `temp_min` ,
ADD `volt_aver` FLOAT( 6, 3 ) NULL DEFAULT NULL AFTER `temp_max` ,
ADD `volt_min` FLOAT( 6, 3 ) NULL DEFAULT NULL AFTER `volt_aver` ,
ADD `volt_max` FLOAT( 6, 3 ) NULL DEFAULT NULL AFTER `volt_min`; 

ALTER TABLE `snmpmon`.`companies` ADD COLUMN `autologout` TINYINT(1) NOT NULL DEFAULT '1' ;

ALTER TABLE `snmpmon`.`day` ADD `rx3` INT( 10 ) UNSIGNED DEFAULT NULL AFTER `rx2` ;
ALTER TABLE `snmpmon`.`day` ADD `tx3` INT( 10 ) UNSIGNED DEFAULT NULL AFTER `tx2` ;

ALTER TABLE `snmpmon`.`companies` ADD `msg_temp_lo` VARCHAR( 64 ) DEFAULT NULL AFTER `msg_trap_poll` ,
ADD `msg_temp_hi` VARCHAR( 64 ) DEFAULT NULL AFTER `msg_temp_lo` ,
ADD `msg_volt_lo` VARCHAR( 64 ) DEFAULT NULL AFTER `msg_temp_hi` ,
ADD `msg_volt_hi` VARCHAR( 64 ) DEFAULT NULL AFTER `msg_volt_lo` ,
ADD `msg_qual_lo` VARCHAR( 64 ) DEFAULT NULL AFTER `msg_volt_hi` ;

ALTER TABLE `snmpmon`.`groups` ADD `temp_limit_lo` INT( 3 ) DEFAULT NULL AFTER `traffic_limit_alt2` ,
ADD `temp_limit_hi` INT( 3 ) DEFAULT NULL AFTER `temp_limit_lo` ,
ADD `volt_limit_lo` FLOAT( 6, 3 ) UNSIGNED DEFAULT NULL AFTER `temp_limit_hi` ,
ADD `volt_limit_hi` FLOAT( 6, 3 ) UNSIGNED DEFAULT NULL AFTER `volt_limit_lo` ,
ADD `qual_limit_lo` TINYINT( 3 ) DEFAULT NULL AFTER `volt_limit_hi` ;

ALTER TABLE `user_group` ADD `temp_email` TINYINT( 1 ) UNSIGNED DEFAULT '0',
ADD `temp_sms` TINYINT( 1 ) UNSIGNED DEFAULT '0',
ADD `volt_email` TINYINT( 1 ) UNSIGNED DEFAULT '0',
ADD `volt_sms` TINYINT( 1 ) UNSIGNED DEFAULT '0',
ADD `qual_email` TINYINT( 1 ) UNSIGNED DEFAULT '0',
ADD `qual_sms` TINYINT( 1 ) UNSIGNED DEFAULT '0';

ALTER TABLE `snmpmon`.`devices` ADD `name` VARCHAR( 32 ) DEFAULT NULL AFTER `note`;

ALTER TABLE `snmpmon`.`users` CHANGE `email` `email` VARCHAR( 128 ) CHARACTER SET utf8 COLLATE utf8_general_ci DEFAULT NULL; 

ALTER TABLE `snmpmon`.`devices` CHANGE `rx_account` `rx_account` BIGINT( 14 ) UNSIGNED NULL DEFAULT NULL ,
CHANGE `tx_account` `tx_account` BIGINT( 14 ) UNSIGNED NULL DEFAULT NULL ,
CHANGE `rx_account_alt` `rx_account_alt` BIGINT( 14 ) UNSIGNED NULL DEFAULT NULL ,
CHANGE `tx_account_alt` `tx_account_alt` BIGINT( 14 ) UNSIGNED NULL DEFAULT NULL ,
CHANGE `rx_account_alt2` `rx_account_alt2` BIGINT( 14 ) UNSIGNED NULL DEFAULT NULL ,
CHANGE `tx_account_alt2` `tx_account_alt2` BIGINT( 14 ) UNSIGNED NULL DEFAULT NULL; 

ALTER TABLE `snmpmon`.`groups` CHANGE `traffic_limit` `traffic_limit` BIGINT( 14 ) UNSIGNED NULL DEFAULT NULL ,
CHANGE `traffic_limit_alt` `traffic_limit_alt` BIGINT( 14 ) UNSIGNED NULL DEFAULT NULL ,
CHANGE `traffic_limit_alt2` `traffic_limit_alt2` BIGINT( 14 ) UNSIGNED NULL DEFAULT NULL; 

ALTER TABLE `snmpmon`.`groups` ADD `max_fails` TINYINT( 3 ) UNSIGNED DEFAULT '2';

ALTER TABLE `snmpmon`.`devices` ADD `num_send_avail` INT( 5 ) UNSIGNED DEFAULT '0' NOT NULL;

ALTER TABLE `snmpmon`.`groups` ADD `max_fails_msg` TINYINT( 3 ) UNSIGNED DEFAULT '2' NOT NULL ;

ALTER TABLE `snmpmon`.`devices` ADD `num_fails_msg` INT( 5 ) UNSIGNED DEFAULT '0' NOT NULL;

ALTER TABLE `snmpmon`.`user_group` ADD `space_email` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';

ALTER TABLE `snmpmon`.`user_group` ADD `space_sms` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';


ALTER TABLE `snmpmon`.`devices` ADD `snmp_prot` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0',
ADD `v3_username` VARCHAR( 32 ) NULL DEFAULT NULL ,
ADD `v3_authentication` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0',
ADD `v3_authpsw` VARCHAR( 32 ) NULL DEFAULT NULL ,
ADD `v3_privacy` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0',
ADD `v3_privpsw` VARCHAR( 32 ) NULL DEFAULT NULL; 

ALTER TABLE `snmpmon`.`groups` ADD `delay_msg` TINYINT( 3 ) UNSIGNED NOT NULL DEFAULT '0';

ALTER TABLE `snmpmon`.`companies` ADD `time_send` varchar( 5 ) DEFAULT NULL AFTER `smtp_psw`;

ALTER TABLE `snmpmon`.`companies` CHANGE `smtp_hostname` `smtp_hostname` VARCHAR( 64 ) NULL DEFAULT NULL;

ALTER TABLE `snmpmon`.`companies` CHANGE `sms_hostname` `sms_hostname` VARCHAR( 64 ) NULL DEFAULT NULL;

ALTER TABLE `snmpmon`.`devices` CHANGE `sn` `sn` VARCHAR( 16 ) CHARACTER SET utf8 COLLATE utf8_general_ci DEFAULT NULL;

DROP TABLE  IF EXISTS  `snmpmon`.`reports`;
 
DROP TABLE  IF EXISTS  `snmpmon`.`persons`;


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
