<?php
/***************************************************************************/
/*                                                                         */
/*  HLAVNI STRANKA        									                               */
/*                                                                         */
/***************************************************************************/

  include ("php/session.php");
  include ("php/service_comm.php");
  include ("php/log.php");
  include ("php/misc.php");
  include ("php/cfg.php");

  // vytvoreni pracovni slozky
  $temp_path = "temp/".substr(session_id(),0,8);
  
  if(!is_dir($temp_path))
  {
    umask(0000); // nulovani masky prav
    mkdir($temp_path,0777);
  }

  if(!isset($_SESSION['params_ok']) || ($_SESSION['params_ok'] == 0))
  {
    // vychozi hodnoty
    $_SESSION['Web.max_station'] = '5';
    $_SESSION['Web.last_version'] = '0.0.0';
  }

  if(!isset($_SESSION['params_ok']) || ($_SESSION['params_ok'] == 0))
  { // precist parametry ze sluzby
    $get = 'get Web.max_station;Monitoring.KeyDef;Web.last_version;'; 
 
    if(service_message($get, $reply))
    { // nastala chyba
      echo($reply);
      exit;
    }
    
    // odstranime novy radek
    $reply = str_replace("\r\n","",$reply);

    $params = explode(';',$reply);
     
    for($i = 0;$i < sizeof($params);$i++)
    {
      $param = explode(' ',$params[$i]);
      switch($param[0])
      { // zjisteni typu parametru
          
        default:  // ostatni parametry muzeme zkopirovat
          $_SESSION[$param[0]] = strlen($param[1]) > 0 ? $param[1] : '';
          break;
      }
    }
    
    $_SESSION['params_ok'] = 1;
  }

  // stranky na ktere muze guest
  $whitelist = array( 
    "device_list",
    "device_change",
    "device_status",
    "report_form",
    "login_form",
    "login_change",  
    "mysql_sp",
    "get_file",  
    "open_device",
    "options",  
    "options_change", 
    "device_select",
    "device_selection",
    "selection_execute",
    "pdf_export",
    "csv_export",
    "about_form", 
    "daily_report",
    "group_list",  
    "ping",  
    "device_graph_page",
    "device_status_graph",
    "device_map",
    "note_change",
    "device_list_csv",
    "device_tab_page" );

  if( is_admin() )
  { // pridame adminovi stranky
    array_push( $whitelist,
      "add_device_form", 
      "remove_device_form",
      "sms_form",   
      "sms_send",  
      "user_list",
      "users_change",
      "log_form",
      "log_save",
      "device_edit_form",   
      "add_group_form",
      "group_change",
      "edit_group_form",
      "edit_user_form",
      "user_change",
      "add_user_form",
      "predef_sms",
      "predef_sms_change"
    );
  }

  if( is_superadmin() )
  { // pridame superadminovi stranky
    array_push( $whitelist,
      "register",
      "online_activation",
      "offline_activation",
      "php_info",
      "company_list",
      "add_company_form",
      "company_change",
      "edit_company_form" );
  }

  if((!isset($_SESSION['Web.last_version'])) || ($_SESSION['Web.last_version'] != VERSION))
  { // nesouhlasi verze, provedeme nahrati procedur na MySQL server
    $page = "mysql_sp";
  }
  else
  {
    if (isset($_GET['page']))
    {	// otevrit stranku ziskanou z GET	
		  $page = $_GET['page'];
    }
	  elseif(isset($_POST['page']))
	  {	// otevrit stranku ziskanou z POST
		  $page = $_POST['page'];		
	  }
	  else
	  {	// otevrit vychozi stranku
	    $page = "device_list";
	  }

    if( $page != "login_change" )
    { // provedeme kontrolu prihlaseni
      if( is_guest() )
      { // nekdo je prihlasen

        if( go_from_login() )
        { // nekdo se prave prihlasil
          if( get_company_id() == 0 )
          { // prihlasil se superadmin, nechame jej vybrat firmu
            $page = "company_list";
          }
          else
          { // ostatni uvidi primo svoji firmu
            $page = "device_list";
          }
        }     
  
      }
      else if( $page != "get_file" )
      { 
        // nikdo neni prihlasen ani nestahuje konfig nebo firmware, zobrazit prihlasovaci formular
        $page = "login_form";              
      }
    }
  }  

  if(!in_array($page,$whitelist))
  {	// zadana stranka neni povolena, otevrit vychozi
    $page = "device_list";
  } 

  if( is_guest() )
  { // nekdo je prihlasen
    // precteme konfiguraci
//        error_log( print_r( $cfg,1 ) );
    user_cfg_read( get_user_id(), $cfg );
    $_SESSION['Web.timezone'] = $cfg["timezone"];
    date_default_timezone_set($cfg["timezone"]);
  }

	// sestaveni cesty k souboru
  $file = "php/".$page.".php";

  if(!file_exists($file))
  {	// soubor neexistuje, vybereme vychozi
    $file = "php/device_list.php";
  }

	// pripojeni zadane stranky
  include($file);
  
?>
