<?php
/***************************************************************************/
/*                                                                         */
/*  UZIVATELSKA KONFIGURACE         				                               */
/*                                                                         */
/***************************************************************************/

require_once "config.inc.php";
require_once "php/mysql.php";

// vychozi konfigurace
$user_defaults = array(  'device_list_cols'  => 'hostname,description,location,device,total,level,data_service,firmware,enabled,sn,mac',
  'report_list_cols'  => 'hostname,description,location,device,firmware,sn',  
  'ping_count'        => '5',
  'refresh_period'    => '0',
  'color_scheme'      => 'default',
  'timezone'          => 'Europe/London',  
  'user_link_target'  => '',
  'user_link_text'    => '',
  'default_community' => 'public',
  'daily_report_from' => '6',
  'daily_report_to'   => '18'    
);


/***************************************************************************/
/*                                                                         */
/*  CTENI KONFIGURACE Z DATABAZE                                           */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*  - $userid  = ID uzivatele                                              */
/*  - $cfg     = pole pro ulozeni nactene konfigurace                      */
/*                                                                         */
/*  VYSTUP:                                                                */
/*                                                                         */
/***************************************************************************/

function user_cfg_read( $user_id, &$cfg )
{
  global $user_defaults;
  $db_cfg = array();

  $link = db_connect( );
  $sql = "SELECT par,value FROM user_cfg WHERE user_id = ".$user_id;
  $result = db_query( $link, $sql );

  while(list($par,$value) = mysqli_fetch_row( $result ))
  {
    $db_cfg[$par] = $value;
  }

  foreach( $user_defaults as $par => $value )
  { // pres vsechny parametry
    if( isset($db_cfg[$par]) )
    { // parametr v DB nalezen, vezmeme jej
      $cfg[$par] = $db_cfg[$par];
    }
    else
    { // parametr v DB nenalezen, vezmeme vychozi hodnotu 
      $cfg[$par] = $value;    
    }
  }

  $sql = "SELECT autologout FROM companies 
          WHERE company_id = (SELECT company_id FROM users WHERE user_id = ".$user_id.")";
  $result = db_query( $link, $sql );
  list( $autologout ) = mysqli_fetch_row($result);

  $cfg['autologout'] = $autologout;
  $cfg['nologin'] = 0;
  $sql = 'SELECT * FROM companies';
  $result = db_query( $link, $sql );
  if( mysqli_num_rows( $result ) == 1 )
  { // mame pouze jednu firmu
    $sql = 'SELECT * FROM users
            WHERE username = "default"';
    $result = db_query( $link, $sql );  
    if( mysqli_num_rows( $result ) )    
    { // specialni username existuje
      $cfg['nologin'] = 1;    
    }
  }
  


}

/***************************************************************************/
/*                                                                         */
/*  ZAPIS HODNOTY PARAMETRU DO DATABAZE                                    */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*  - $userid  = ID uzivatele                                              */
/*  - $par     = jmeno parametru                                           */
/*  - $value   = hodnota parametru                                         */
/*                                                                         */
/*  VYSTUP:                                                                */
/*                                                                         */
/***************************************************************************/

function user_cfg_write( $user_id, $param, $value )
{

  $link = db_connect( );

  $sql = "INSERT INTO user_cfg (user_id, par, value) VALUES(".$user_id.",\"".$param."\",\"".$value."\") ON DUPLICATE KEY UPDATE value = \"".$value."\"";

  $result = db_query( $link, $sql );

}


?>
