<?php

/***************************************************************************/
/*                                                                         */
/*  STRANKA DENNIHO REPORTU													                       */
/*                                                                         */
/***************************************************************************/

//select * from '.DB_NAME.'.summary where (time between '2011-08-01' and '2011-09-07') and (date_format(time, '%H:%i') between '05:00' and '18:00')

  require_once "config.inc.php";
  require_once "php/mysql.php"; 

  require_once "php/report_graph.php";
  
	date_default_timezone_set($_SESSION['Web.timezone']);

  $data_src = "int";
  
	// pripojeni k DB
  $link = db_connect();
  
  $img_path = "temp_img/daily_report";  

  if(!isset($_SESSION['Monitoring.daily_report_from']) || !isset($_SESSION['Monitoring.daily_report_from']))
  {
    echo("Error: Getting time interval failed.");
    exit;
  }
  
  if(isset($_GET['from']))
  {
    $tmp_from = $_GET['from'];
  
    $from = mktime($_SESSION['Monitoring.daily_report_from'],0,0,date("n",$tmp_from),date("j",$tmp_from),date("Y",$tmp_from));
    $to   = mktime($_SESSION['Monitoring.daily_report_to'],0,0,date("n",$tmp_from),date("j",$tmp_from),date("Y",$tmp_from));  
  }
  else
  {
    $from = mktime($_SESSION['Monitoring.daily_report_from'],0,0,date("n"),date("j"),date("Y"));
    $to   = mktime($_SESSION['Monitoring.daily_report_to'],0,0,date("n"),date("j"),date("Y"));
  }
  
  // generovani grafu
  report_graph($link, $data_src, $img_path."/ploss.png", "ploss", $from, $to);
  report_graph($link, $data_src, $img_path."/latency.png", "latency", $from, $to);
  report_graph($link, $data_src, $img_path."/availability.png", "availability", $from, $to);
  report_graph($link, $data_src, $img_path."/ronline.png", "ronline", $from, $to);

  // aktualni pocet funkcnich zarizeni
  $sql = 'SELECT MIN(device_working), MAX(device_working) 
          FROM summary 
          WHERE time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'" 
          ORDER BY time DESC LIMIT 1';
  $result = db_query($link, $sql);
  list($count_min,$count_max) = mysqli_fetch_row($result);
  
	// latency ve zvolenem obdobi	
	$sql = 'SELECT AVG(average_latency) 
          FROM summary 
          WHERE time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"';
	$result = db_query($link, $sql);
	list($latency_avg) = mysqli_fetch_row($result);
	$latency_avg = round($latency_avg,0);	
	
	// availability ve zvolenem obdobi
	$sql = 'SELECT AVG(availability)
          FROM summary 
          WHERE time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"';
  $result = db_query($link, $sql);
  list($availability) = mysqli_fetch_row($result);	
	$availability = round($availability,1);

	// ztrata packetu ve zvolenem obdobi  
  $sql = 'SELECT ((1 - (device_working / device_count)) * 100) 
          FROM summary 
          WHERE time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"';
	$result = db_query($link, $sql);
  $ploss_list = array();
  $i = 0;
  while(list($ploss_list[$i]) = mysqli_fetch_row($result))
  {
    $i++;
  }
  $packet_loss = round(array_sum($ploss_list) / count($ploss_list),1);
  

?>
		<table width="900px">
			<tr align="center">
				<td align="center"><?php echo '<b>From: </b>'.date("d-m-Y H:i",$from).' <b>To: </b>'.date("d-m-Y H:i",$to); ?></td>
			</tr>
		</table>
		<table width="100%" align="center">
			<tr align="left">
				<td class="header">
					Summary values 
				</td>
			</tr>
			<tr align="center">		
				<td align="center">
					<table>
						<tr>
							<td>Online Network Access Routers</td><td>&nbsp; <?php echo($count_min == $count_max ? $count_min : 'min: '.$count_min.' max: '.$count_max)?></td>
						</tr>
						<tr>
							<td>Network Availability</td><td>&nbsp; <?php echo($availability)?> %</td>
						</tr>
						<tr>
							<td>Network Average Latency</td><td>&nbsp; <?php echo($latency_avg)?> ms</td>
						</tr>
						<tr>
							<td>Network Average Packet Loss </td><td>&nbsp; <?php echo($packet_loss)?> %</td>
						</tr>
					</table>
				</td>
			</tr>
		</table>
		<table width="100%">
			<tr align="left">
				<td class="header">
					Charts 
				</td>
			</tr>
			<tr align="center">
				<td>
					<img src="<?php echo($img_path."/ploss.png")?>" class="graph">
				</td>
			</tr>
			<tr align="center">
  			<td>
					<img src="<?php echo($img_path."/latency.png")?>" class="graph">     
				</td>
			</tr>
			<tr align="center">
				<td>
					<img src="<?php echo($img_path."/availability.png")?>" class="graph">     
				</td>
			</tr>
			<tr align="center">
				<td>
					<img src="<?php echo($img_path."/ronline.png")?>" class="graph">        
				</td>
			</tr>
    </table>
