<?php

/***************************************************************************/
/*                                                                         */
/*  SCRIPT PRO VYTVORENI XML PRO GOOGLE MAPY                               */
/*                                                                         */
/***************************************************************************/

  require_once "../config.inc.php";	
  require_once "mysql.php";
  require_once "misc.php";

	$link = db_connect();  

  $sql = 'SELECT device_id, hostname, hostname_alt, description, note, coordinates, product, firmware, last_level, health, health_alt, enabled, last_time_act
          FROM devices
          WHERE coordinates REGEXP "(-?[0-9]?[0-9]?[0-9].[0-9]{6},?){2}"';

	$result = db_query($link, $sql);

  $device_id = array();  
  $hostname = array();
  $hostname_alt = array();
  $description = array();
  $note = array();
  $coordinates = array();
  $device = array();
  $level = array();
  $firmware = array();
  $health = array();
  $health_alt = array();
  $enabled = array();
  $update_time = array();
  $plmn = array();
  $cell = array();
  $tech = array();
  $uptime = array();  
  $avail = array();

  $i = 0;

  while(list($device_id[$i], $hostname[$i], $hostname_alt[$i], $description[$i], $note[$i], $coordinates[$i], $device[$i], $firmware[$i], $level[$i], $health[$i], $health_alt[$i], $enabled[$i], $update_time[$i]) = mysqli_fetch_row($result))
  {

	// nacteni informaci o stavu zarizeni
    $sql = 'SELECT plmn, cell, status, uptime FROM stats
            WHERE device_id = "'.$device_id[$i].'"
            ORDER BY stat_id DESC LIMIT 1';

  	// vykonani SQL prikazu
	  $result1 = db_query($link, $sql);

    list($plmn[$i], $cell[$i], $tech[$i], $uptime[$i]) = mysqli_fetch_row($result1);

	// nacteni informaci o stavu zarizeni
    $sql = 'SELECT availability FROM day
            WHERE device_id = "'.$device_id[$i].'"
            ORDER BY day_id DESC LIMIT 1';

  	// vykonani SQL prikazu
	  $result2 = db_query($link, $sql);

    list($avail[$i]) = mysqli_fetch_row($result2);

    $i++;
  }


  function parseToXML($htmlStr) 
  { 
    $xmlStr=str_replace('<','&lt;',$htmlStr); 
    $xmlStr=str_replace('>','&gt;',$xmlStr); 
    $xmlStr=str_replace('"','&quot;',$xmlStr); 
    $xmlStr=str_replace("'",'&#39;',$xmlStr); 
    $xmlStr=str_replace("&",'&amp;',$xmlStr); 
    return $xmlStr; 
  }

  header("Content-type: text/xml");

  echo "<markers>\n";
  for($j = 0;$j < $i;$j++)
  {

    $split_coord = explode(",",$coordinates[$j]);

    $lat = trim($split_coord[0]);
    $lng = trim($split_coord[1]);

    if(is_null($health_alt[$j]))
    {
      $health_state = $health[$j];
    }
    else
    {
      $health_state = ($health[$j] < $health_alt[$j]) ? $health[$j] : $health_alt[$j];
    }  

    if($enabled[$j] == 1)
    {
      switch($health_state)
      {
        case "0": $status = "green"; break;
        case "1": $status = "orange"; break;
        case "2": $status = "red"; break;
        default: $status = "red"; break;                
      }
    }
    else
    {
      $status = "gray";
    }

    if(is_null($hostname[$j]) || ($hostname[$j] == ''))
    {
      $name = "---";
    }
    else
    {
      if($hostname[$j] == '0.0.0.0')
      {
        $name = "Behind NAT";      
      }
      else
      {
        $name = $hostname[$j];
      }
    }

    if(is_null($hostname_alt[$j]) || ($hostname_alt[$j] == ''))
    {
      $name = $name.", ---";
    }
    else
    {
      if($hostname_alt[$j] == '0.0.0.0')
      {
        $name = $name.", Behind NAT";      
      }
      else
      {
        $name = $name.", ".$hostname_alt[$j];
      }
    }

    if(is_null($description[$j]) || ($description[$j] == ''))
    {
      $desc = "---";      
    }
    else
    {
      $desc = $description[$j];        
    }

    if(is_null($note[$j]) || ($note[$j] == ''))
    {
      $note1 = "---";      
    }
    else
    {
      $note1 = $note[$j];        
    }    

    if(is_null($device[$j]) || ($device[$j] == ''))
    {
      $dev = "---";      
    }
    else
    {
      $dev = $device[$j];        
    }

    if(is_null($firmware[$j]) || ($firmware[$j] == ''))
    {
      $fw = "---";      
    }
    else
    {
      $fw = $firmware[$j];        
    }

    if(is_null($level[$j]) || ($level[$j] == ''))
    {
      $signal = "---";      
    }
    else
    {
      $signal = $level[$j]." dBm";        
    }

    if(is_null($update_time[$j]) || ($update_time[$j] == ''))
    {
      $updtime = "---";      
    }
    else
    {
      $updtime = $update_time[$j];        
    }

    if(is_null($plmn[$j]) || ($plmn[$j] == ''))
    {
      $dev_plmn = "---";      
    }
    else
    {
      $dev_plmn = $plmn[$j];        
    }

    if(is_null($cell[$j]) || ($cell[$j] == ''))
    {
      $dev_cell = "---";      
    }
    else
    {
      $dev_cell = dechex($cell[$j]);        
    }

    if(is_null($tech[$j]) || ($tech[$j] == ''))
    {
      $dev_tech = "---";      
    }
    else
    {
      $dev_tech = decoding_network_status($tech[$j]);        
    }

    if(is_null($uptime[$j]) || ($uptime[$j] == ''))
    {
      $dev_uptime = "---";      
    }
    else
    {
      $dev_uptime = UptimeToStr($uptime[$j]);        
    }

    if(is_null($avail[$j]) || ($avail[$j] == ''))
    {
      $dev_avail = "---";      
    }
    else
    {
      $dev_avail = $avail[$j]." %";        
    }

    echo "<marker ";
    echo "device_id=\"".$device_id[$j]."\" ";
    echo "name=\"".parseToXML($name)."\" ";
    echo "desc=\"".parseToXML($desc)."\" ";
    echo "note=\"".parseToXML($note1)."\" ";
    echo "lat=\"".$lat."\" ";
    echo "lng=\"".$lng."\" ";
    echo "device=\"".$dev."\" ";
    echo "fw=\"".$fw."\" ";
    echo "level=\"".$signal."\" ";
    echo "plmn=\"".$dev_plmn."\" ";
    echo "cell=\"".$dev_cell."\" ";
    echo "tech=\"".$dev_tech."\" ";
    echo "uptime=\"".$dev_uptime."\" ";
    echo "status=\"".$status."\" ";
    echo "updtime=\"".$updtime."\" ";
    echo "avail=\"".$dev_avail."\" ";
    echo "/>\n";

  }
  // End XML file
  echo "</markers>\n"; 
?>
