<?php

/***************************************************************************/
/*                                                                         */
/*  SKRIPT PRO EXPORT CSV								                                   */
/*                                                                         */
/***************************************************************************/

  require_once ("php/misc.php");
  include ("php/device_columns.php");


	header("Content-type: text/csv");
  header("Content-Disposition: attachment; filename=Device_list_".date("d_m_Y_H_i", time()).".csv");
  foreach( $cols_selected as $id => $cell_name )
  {
    echo ",\"".$cols[$cell_name]."\"";
  }

  echo "\n";

  $sql = "";

  if( isset( $_SESSION['sql_filters'] ) )
  {
    $sql = $_SESSION['sql_filters'];
  }

  // pripojeni k DB
  $link = db_connect();


  if( is_superadmin() && (get_company_id( ) == 0) )
  { // prihlaseny superadmin, ktery nema vybranou konkretni firmu uvidi vse
    $sql = 'call sp_GetDevicesAll(\''.$sql.'\')';
  }
  else if( is_admin() )
  {
    $sql = 'call sp_GetDevicesCompany(\''.$sql.'\',\''.get_company_id().'\')';
  }
  else
  {
    $sql = 'call sp_GetDevicesUser(\''.$sql.'\',\''.get_user_id().'\')';
  }
  // vykonani SQL prikazu
	$result = db_multi_query($link, $sql);


  // nacteni dat z odpovedi
  while (list($dev_num,$device_id,$description,$hostname, $hostname_alt, $hostname_alt2, $location, $coordinates, $note, $enabled, $product,
		  $firmware, $sn, $imei, $esn, $tx, $rx, $total, $tx_alt, $rx_alt, $total_alt, $tx_alt2, $rx_alt2, $total_alt2, $level, $network_status,
		  $autoupdate, $healh_state, $healh_state_alt, $healh_state_alt2, $last_comm_time, $last_comm_time_alt, $last_comm_time_alt2,
		  $is_trap, $mac, $group, $comp_name, $uptime, $is_new, $quality, $temperature, $voltage, $level_limit, $traffic_limit,
		  $traffic_limit_alt, $traffic_limit_alt2, $temp_limit_lo, $temp_limit_hi, $volt_limit_lo, $volt_limit_hi, $qual_limit_lo, $name,
		  $max_fails, $snmp_enabled) = mysqli_fetch_row($result))
  {
    // kontrola hodnot
    $description    = is_null($description) ? "---" : $description;
    $hostname       = is_null($hostname) || (strlen($hostname) < 3) ? "Not read" : $hostname;
    $hostname_alt   = is_null($hostname_alt) || (strlen($hostname_alt) < 3) ? "---" : $hostname_alt;
    $hostname_alt2  = is_null($hostname_alt2) || (strlen($hostname_alt2) < 3) ? "---" : $hostname_alt2;
    $location       = is_null($location) ? "---" : $location;
    $note           = is_null($note) ? "---" : $note;
    $network_status = is_null($network_status) ? "---" : decoding_network_status($network_status);
    $product        = is_null($product) ? "---" : $product;
    $firmware       = is_null($firmware) ? "---" : substr($firmware, 0, 6);
    $sn             = is_null($sn) ? "---" : $sn;
    $imei           = is_null($imei) ? "---" : $imei;
    $esn            = is_null($esn) ? "---" : $esn;
    $tx             = is_null($tx) ? "---" : ConvertNumBytes($tx);
    $rx             = is_null($rx) ? "---" : ConvertNumBytes($rx);
    $tx_alt         = is_null($tx_alt) ? "---" : ConvertNumBytes($tx_alt);
    $rx_alt         = is_null($rx_alt) ? "---" : ConvertNumBytes($rx_alt);
    $tx_alt2        = is_null($tx_alt) ? "---" : ConvertNumBytes($tx_alt2);
    $rx_alt2        = is_null($rx_alt) ? "---" : ConvertNumBytes($rx_alt2);
    $mac            = is_null($mac) ? "---" : $mac;
    $uptime         = is_null($uptime) ? "---" : UptimeToStr($uptime);
    $name           = is_null($name) ? "---" : $name;

    $cell_csv = array();

    if($hostname != "0.0.0.0")
    {
      $cell_csv["hostname"] = $hostname;
    }
    else
    {
      $cell_csv["hostname"] = "Behind NAT";
    }

    if( ($hostname_alt == '---') || ($hostname_alt == '') )
    {
      $cell_csv["hostname_alt"] = $hostname_alt;
    }
    else
    {
      if($hostname_alt != "0.0.0.0")
      {
        $cell_csv["hostname_alt"] = $hostname_alt;
      }
      else
      {
        $cell_csv["hostname_alt"] = "Behind NAT";
      }
    }


    if( ($hostname_alt2 == '---') || ($hostname_alt2 == '') )
    {
      $cell_csv["hostname_alt2"] = $hostname_alt2;
    }
    else
    {
      if($hostname_alt2 != "0.0.0.0")
      {
        $cell_csv["hostname_alt2"] = $hostname_alt2;
      }
      else
      {
        $cell_csv["hostname_alt2"] = "Behind NAT";
      }
    }

    $cell_csv["description"] = $description;

    $cell_csv["location"] = $location;

    $cell_csv["device"] = $product;

    $cell_csv["note"] = $note;

    $cell_csv["tx"] = $tx;

    $cell_csv["rx"] = $rx;

    if( is_null($total) )
    {
      $cell_csv["total"] = "---";
    }
    else
    {
      $cell_csv["total"] = $total;
    }

    $cell_csv["tx_alt"] = $tx_alt;

    $cell_csv["rx_alt"] = $rx_alt;

    if( is_null($total_alt) )
    {
      $cell_csv["total_alt"] = "---";
    }
    else
    {
      $cell_csv["total_alt"] = $total_alt;
    }

    $cell_csv["tx_alt2"] = $tx_alt2;

    $cell_csv["rx_alt2"] = $rx_alt;

    if( is_null($total_alt2) )
    {
      $cell_csv["total_alt2"] = "---";
    }
    else
    {
      $cell_csv["total_alt2"] = $total_alt2;
    }

    if( is_null($level) )
    {
      $cell_csv["level"] = "---";
    }
    else
    {
      $cell_csv["level"] = $level;
    }

    $cell_csv["data_service"] = $network_status;

    $cell_csv["firmware"] = $firmware;

    $cell_csv["enabled"] = $enabled;
    $cell_csv["autoupdate"] = $autoupdate;

    $cell_csv["report"] = "";

    $cell_csv["sn"] = $sn;

    $cell_csv["imei"] = $imei;

    $cell_csv["esn"] = $esn;

    $cell_csv["access_mode"] = ($is_trap == '0' ? 'Polling' : 'Trap');

    $cell_csv["mac"] = $mac;

    $cell_csv["group"] = $group;

    $cell_csv["company"] = $comp_name;

    $cell_csv["uptime"] = $uptime;


    if( is_null($quality) )
    {
      $cell_csv["quality"] = "---";
    }
    else
    {
      $cell_csv["quality"] = $quality;
    }

    if( is_null($temperature) )
    {
      $cell_csv["temp"] = "---";
    }
    else
    {
      $cell_csv["temp"] = $temperature;
    }

    if( is_null($voltage) )
    {
      $cell_csv["voltage"] = "---";
    }
    else
    {
      $cell_csv["voltage"] = $voltage;
    }

    $cell_csv["name"] = $name;
    $cell_csv["snmp_prot"] = $snmp_enabled == 0 ? 'SNMP V1' : 'SNMP V3';

    foreach( $cols_selected as $id => $cell_name )
    {
      echo ",\"".$cell_csv[$cell_name]."\"";
    }

    echo "\n";

  }

	if(mysqli_more_results($link))
	{	//Catch 'OK'/'ERR'
		while(mysqli_next_result($link));
	}



?>
