<?php

/***************************************************************************/
/*                                                                         */
/*  SCRIPT PRO VYTVARENI GRAFU							                               */
/*                                                                         */
/***************************************************************************/

  require_once "config.inc.php";	
  require_once "php/mysql.php";
  require_once "php/misc.php"; 

  include("pGraph/pData.class");
  include("pGraph/pChart.class");

	
	header("Content-Type: image/png");
	
  $graph_type = URI_get_string("graph");
  if( is_null( $graph_type ) )
  {
    echo "Missing or invalid graph type.";
    exit;
  }

  $device_id = URI_get_int("device_id");
  if( is_null( $device_id ) )
  {
    echo "Missing or invalid device ID.";
    exit;
  }

	$link = db_connect();
	
	$sql = 'SELECT hostname, hostname_alt, hostname_alt2 FROM devices WHERE device_id='.$device_id.'';
	
	$result = db_query($link, $sql);
			
	list($hostname, $hostname_alt, $hostname_alt2) = mysqli_fetch_row($result);  

  $has_2nd_sim = 0;
  $has_3rd_sim = 0;

  if( strstr($graph_type, "signal") || strstr($graph_type, "quality") || strstr($graph_type, "latency"))
  { // sim nas zajimaji jen u nekterych grafu
    if( !is_null( $hostname_alt ) )
    {
      $has_2nd_sim = 1;
    }

    if( !is_null( $hostname_alt2 ) )
    {
      $has_3rd_sim = 1;
    }
  }
	
	$x_data1 = array();
  $x_data2 = array();
  $x_data3 = array();
  $status2order = array();

  $y_data1 = array();	
	$y_data2 = array();	
	$y_data3 = array();	
  $y_status_sim1 = array();
  $y_status_sim2 = array();
  $y_status_sim3 = array();

	switch($graph_type)
	{	// zjisteni typu grafu
		case 'signal_tod':
		{
			$title = 'Signal Strength ('.$hostname.') - Today';
			$YAxisName = 'Signal Strength';
			$YAxisUnit = 'dBm';
			$date_format = "H:i";

      /*********************************** SIM 1 **************************************/

			$sql = 	'SELECT time,level,status 
							FROM `'.DB_NAME.'`.stats
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" 
							AND "'.date("Y-m-d H:i",time()).'" AND alt = 0 ORDER BY time;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
				list($x_data1[$i], $y_data1[$i],$y_status_sim1[$i]) = mysqli_fetch_row($result);
				$x_data1[$i] = strtotime($x_data1[$i]);
      }

      /*********************************** SIM 2 **************************************/

      if( $has_2nd_sim )
      {
			  $sql = 'SELECT time,level,status 
				   			FROM `'.DB_NAME.'`.stats
							  WHERE device_id = '.$device_id.' AND time 
							  BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" 
							  AND "'.date("Y-m-d H:i",time()).'" AND alt = 1 ORDER BY time;';

			  $result = db_query($link, $sql);
			
			  for($i = 0;$i < mysqli_num_rows($result);$i++)
			  {
				  list($x_data2[$i], $y_data2[$i],$y_status_sim2[$i]) = mysqli_fetch_row($result);
				  $x_data2[$i] = strtotime($x_data2[$i]);
			  }
      }

      /*********************************** SIM 3 **************************************/

      if( $has_3rd_sim )
      {
			  $sql = 'SELECT time,level,status 
				   			FROM `'.DB_NAME.'`.stats
							  WHERE device_id = '.$device_id.' AND time 
							  BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" 
							  AND "'.date("Y-m-d H:i",time()).'" AND alt = 2 ORDER BY time;';

			  $result = db_query($link, $sql);
			
			  for($i = 0;$i < mysqli_num_rows($result);$i++)
			  {
				  list($x_data3[$i], $y_data3[$i],$y_status_sim3[$i]) = mysqli_fetch_row($result);
				  $x_data3[$i] = strtotime($x_data3[$i]);
			  }
      }

      /******************************** data service **********************************/

      $sql = 'SELECT DISTINCT status
              FROM stats
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" 
							AND "'.date("Y-m-d H:i",time()).'" AND status IS NOT NULL ORDER BY status;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
        list($status) = mysqli_fetch_row($result);
        $status2order[$status] = $i;
			}

			$y_bottom = -120;
			$y_top = -40;
		
			break;
		}
		case 'signal_yes':
		{
			$title = 'Signal Strength ('.$hostname.') - Yesterday';
			$YAxisName = 'Signal Strength';
			$YAxisUnit = 'dBm';
			$date_format = "H:i";

      /*********************************** SIM 1 **************************************/

			$sql = 	'SELECT time,level,status 
							FROM `'.DB_NAME.'`.stats 
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d")-1, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" AND alt = 0 ORDER BY time;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
				list($x_data1[$i], $y_data1[$i],$y_status_sim1[$i]) = mysqli_fetch_row($result);
				$x_data1[$i] = strtotime($x_data1[$i]);
			}

      /*********************************** SIM 2 **************************************/
      if( $has_2nd_sim )
      {
			  $sql = 'SELECT time,level,status 
							  FROM `'.DB_NAME.'`.stats 
							  WHERE device_id = '.$device_id.' AND time 
							  BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d")-1, date("Y"))).'" 
							  AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" AND alt = 1 ORDER BY time;';

  			$result = db_query($link, $sql);
			
	  		for($i = 0;$i < mysqli_num_rows($result);$i++)
  			{
  				list($x_data2[$i], $y_data2[$i],$y_status_sim2[$i]) = mysqli_fetch_row($result);
  				$x_data2[$i] = strtotime($x_data2[$i]);
  			}
      }
  
      /*********************************** SIM 3 **************************************/
      if( $has_3rd_sim )
      {
			  $sql = 'SELECT time,level,status 
							  FROM `'.DB_NAME.'`.stats 
							  WHERE device_id = '.$device_id.' AND time 
							  BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d")-1, date("Y"))).'" 
							  AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" AND alt = 2 ORDER BY time;';

  			$result = db_query($link, $sql);
			
	  		for($i = 0;$i < mysqli_num_rows($result);$i++)
  			{
  				list($x_data3[$i], $y_data3[$i],$y_status_sim3[$i]) = mysqli_fetch_row($result);
  				$x_data3[$i] = strtotime($x_data3[$i]);
  			}
      }

      /******************************** data service **********************************/

      $sql = 'SELECT DISTINCT status
              FROM stats
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d")-1, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" AND status IS NOT NULL ORDER BY status;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
        list($status) = mysqli_fetch_row($result);
        $status2order[$status] = $i;
			}

			$y_bottom = -120;
			$y_top = -40;
		
	
			break;
		}
		case 'signal_week':
		{
			$title = 'Signal Strength ('.$hostname.') - Last 7 Days';
			$YAxisName = 'Signal Strength';
			$YAxisUnit = 'dBm';
			$date_format = "d/m";

      /*********************************** SIM 1 **************************************/      

			$sql = 	'SELECT time,level,status 
							FROM `'.DB_NAME.'`.stats 
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d")-7, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",time()).'" AND alt = 0 ORDER BY time;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
				list($x_data1[$i], $y_data1[$i],$y_status_sim1[$i]) = mysqli_fetch_row($result);
				$x_data1[$i] = strtotime($x_data1[$i]);
			}

      /*********************************** SIM 2 **************************************/      

      if( $has_2nd_sim )
      {
			  $sql = 'SELECT time,level,status 
							  FROM `'.DB_NAME.'`.stats 
							  WHERE device_id = '.$device_id.' AND time 
							  BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d")-7, date("Y"))).'" 
							  AND "'.date("Y-m-d H:i",time()).'" AND alt = 1 ORDER BY time;';

  			$result = db_query($link, $sql);
			
  			for($i = 0;$i < mysqli_num_rows($result);$i++)
  			{
  				list($x_data2[$i], $y_data2[$i],$y_status_sim2[$i]) = mysqli_fetch_row($result);
  				$x_data2[$i] = strtotime($x_data2[$i]);
  			}
      }

      /*********************************** SIM 3 **************************************/      

      if( $has_3rd_sim )
      {
			  $sql = 'SELECT time,level,status 
							  FROM `'.DB_NAME.'`.stats 
							  WHERE device_id = '.$device_id.' AND time 
							  BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d")-7, date("Y"))).'" 
							  AND "'.date("Y-m-d H:i",time()).'" AND alt = 2 ORDER BY time;';

  			$result = db_query($link, $sql);
			
  			for($i = 0;$i < mysqli_num_rows($result);$i++)
  			{
  				list($x_data3[$i], $y_data3[$i],$y_status_sim3[$i]) = mysqli_fetch_row($result);
  				$x_data3[$i] = strtotime($x_data3[$i]);
  			}
      }

      /******************************** data service **********************************/

      $sql = 'SELECT DISTINCT status
              FROM stats
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d")-7, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",time()).'" AND status IS NOT NULL ORDER BY status;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
        list($status) = mysqli_fetch_row($result);
        $status2order[$status] = $i;
			}

//  error_log(print_r($status2order, TRUE), 0);  

			$y_bottom = -120;
			$y_top = -40;
		
			break;
		}
		case 'signal_cur':
		{
			$title = 'Signal Strength ('.$hostname.') - Current Period';
			$YAxisName = 'Signal Strength';
			$YAxisUnit = 'dBm';
			$date_format = "d/m";

      /*********************************** SIM 1 **************************************/   

			$sql = 	'SELECT time,level,status 
							FROM `'.DB_NAME.'`.stats 
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 1, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",time()).'" AND alt = 0 ORDER BY time;';
			
			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
				list($x_data1[$i], $y_data1[$i],$y_status_sim1[$i]) = mysqli_fetch_row($result);
				$x_data1[$i] = strtotime($x_data1[$i]);
      }

      /*********************************** SIM 2 **************************************/   

      if( $has_2nd_sim )
      {
			  $sql = 'SELECT time,level,status 
							  FROM `'.DB_NAME.'`.stats 
							  WHERE device_id = '.$device_id.' AND time 
							  BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 1, date("Y"))).'" 
							  AND "'.date("Y-m-d H:i",time()).'" AND alt = 1 ORDER BY time;';
			
  			$result = db_query($link, $sql);
			
  			for($i = 0;$i < mysqli_num_rows($result);$i++)
  			{
  				list($x_data2[$i], $y_data2[$i],$y_status_sim2[$i]) = mysqli_fetch_row($result);
  				$x_data2[$i] = strtotime($x_data2[$i]);
  			}
      }

      /*********************************** SIM 3 **************************************/   

      if( $has_3rd_sim )
      {
			  $sql = 'SELECT time,level,status 
							  FROM `'.DB_NAME.'`.stats 
							  WHERE device_id = '.$device_id.' AND time 
							  BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 1, date("Y"))).'" 
							  AND "'.date("Y-m-d H:i",time()).'" AND alt = 2 ORDER BY time;';
			
  			$result = db_query($link, $sql);
			
  			for($i = 0;$i < mysqli_num_rows($result);$i++)
  			{
  				list($x_data3[$i], $y_data3[$i],$y_status_sim3[$i]) = mysqli_fetch_row($result);
  				$x_data3[$i] = strtotime($x_data3[$i]);
  			}
      }

      /******************************** data service **********************************/

      $sql = 'SELECT DISTINCT status
              FROM stats
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 1, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",time()).'" AND status IS NOT NULL ORDER BY status;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
        list($status) = mysqli_fetch_row($result);
        $status2order[$status] = $i;
			}

			$y_bottom = -120;
			$y_top = -40;
		
			break;
		}
		case 'signal_last':
		{
			$title = 'Signal Strength ('.$hostname.') - Last Period';
			$YAxisName = 'Signal Strength';
			$YAxisUnit = 'dBm';
			$date_format = "d/m";

      /*********************************** SIM 1 **************************************/

			$sql = 	'SELECT time,level,status 
							FROM `'.DB_NAME.'`.stats 
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") - 1, 1, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 0, date("Y"))).'" AND alt = 0 ORDER BY time;';
			
			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
				list($x_data1[$i], $y_data1[$i],$y_status_sim1[$i]) = mysqli_fetch_row($result);
				$x_data1[$i] = strtotime($x_data1[$i]);
			}

      /*********************************** SIM 2 **************************************/
      if( $has_2nd_sim )
      {
			  $sql = 'SELECT time,level,status 
    					  FROM `'.DB_NAME.'`.stats 
  							WHERE device_id = '.$device_id.' AND time 
  							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") - 1, 1, date("Y"))).'" 
  							AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 0, date("Y"))).'" AND alt = 1 ORDER BY time;';
			
  			$result = db_query($link, $sql);
			
  			for($i = 0;$i < mysqli_num_rows($result);$i++)
	  		{
  				list($x_data2[$i], $y_data2[$i],$y_status_sim2[$i]) = mysqli_fetch_row($result);
  				$x_data2[$i] = strtotime($x_data2[$i]);
  			}
      }

      /*********************************** SIM 3 **************************************/
      if( $has_3rd_sim )
      {
			  $sql = 'SELECT time,level,status 
    					  FROM `'.DB_NAME.'`.stats 
  							WHERE device_id = '.$device_id.' AND time 
  							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") - 1, 1, date("Y"))).'" 
  							AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 0, date("Y"))).'" AND alt = 2 ORDER BY time;';
			
  			$result = db_query($link, $sql);
			
  			for($i = 0;$i < mysqli_num_rows($result);$i++)
	  		{
  				list($x_data3[$i], $y_data3[$i],$y_status_sim3[$i]) = mysqli_fetch_row($result);
  				$x_data3[$i] = strtotime($x_data3[$i]);
  			}
      }

      /******************************** data service **********************************/

      $sql = 'SELECT DISTINCT status
              FROM stats
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") - 1, 1, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 0, date("Y"))).'" AND status IS NOT NULL ORDER BY status;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
        list($status) = mysqli_fetch_row($result);
        $status2order[$status] = $i;
			}

			$y_bottom = -120;
			$y_top = -40;
		
			break;
		}	

		case 'quality_tod':
		{
      $title = 'Signal Quality ('.$hostname.') - Today';
			$YAxisName = 'Signal Quality';
			$YAxisUnit = 'dB';
			$date_format = "H:i";

      /*********************************** SIM 1 **************************************/

			$sql = 	'SELECT time,signal_quality,status 
							FROM `'.DB_NAME.'`.stats
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" 
							AND "'.date("Y-m-d H:i",time()).'" AND alt = 0 ORDER BY time;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
				list($x_data1[$i], $y_data1[$i],$y_status_sim1[$i]) = mysqli_fetch_row($result);
				$x_data1[$i] = strtotime($x_data1[$i]);
      }

      /*********************************** SIM 2 **************************************/

      if( $has_2nd_sim )
      {
			  $sql = 'SELECT time,signal_quality,status 
				   			FROM `'.DB_NAME.'`.stats
							  WHERE device_id = '.$device_id.' AND time 
							  BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" 
							  AND "'.date("Y-m-d H:i",time()).'" AND alt = 1 ORDER BY time;';

			  $result = db_query($link, $sql);
			
			  for($i = 0;$i < mysqli_num_rows($result);$i++)
			  {
				  list($x_data2[$i], $y_data2[$i],$y_status_sim2[$i]) = mysqli_fetch_row($result);
				  $x_data2[$i] = strtotime($x_data2[$i]);
			  }
      }

      /*********************************** SIM 3 **************************************/

      if( $has_3rd_sim )
      {
			  $sql = 'SELECT time,signal_quality,status 
				   			FROM `'.DB_NAME.'`.stats
							  WHERE device_id = '.$device_id.' AND time 
							  BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" 
							  AND "'.date("Y-m-d H:i",time()).'" AND alt = 2 ORDER BY time;';

			  $result = db_query($link, $sql);
			
			  for($i = 0;$i < mysqli_num_rows($result);$i++)
			  {
				  list($x_data3[$i], $y_data3[$i],$y_status_sim3[$i]) = mysqli_fetch_row($result);
				  $x_data3[$i] = strtotime($x_data3[$i]);
			  }
      }

      /******************************** data service **********************************/

      $sql = 'SELECT DISTINCT status
              FROM stats
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" 
							AND "'.date("Y-m-d H:i",time()).'" AND status IS NOT NULL ORDER BY status;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
        list($status) = mysqli_fetch_row($result);
        $status2order[$status] = $i;
			}

			$y_bottom = -35;
			$y_top = 0;
		
			break;
		}
		case 'quality_yes':
		{
      $title = 'Signal Quality ('.$hostname.') - Yesterday';
      $YAxisName = 'Signal Quality';
			$YAxisUnit = 'dB';
			$date_format = "H:i";

      /*********************************** SIM 1 **************************************/

			$sql = 	'SELECT time,signal_quality,status 
							FROM `'.DB_NAME.'`.stats 
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d")-1, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" AND alt = 0 ORDER BY time;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
				list($x_data1[$i], $y_data1[$i],$y_status_sim1[$i]) = mysqli_fetch_row($result);
				$x_data1[$i] = strtotime($x_data1[$i]);
			}

      /*********************************** SIM 2 **************************************/
      if( $has_2nd_sim )
      {
			  $sql = 'SELECT time,signal_quality,status 
							  FROM `'.DB_NAME.'`.stats 
							  WHERE device_id = '.$device_id.' AND time 
							  BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d")-1, date("Y"))).'" 
							  AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" AND alt = 1 ORDER BY time;';

  			$result = db_query($link, $sql);
			
	  		for($i = 0;$i < mysqli_num_rows($result);$i++)
  			{
  				list($x_data2[$i], $y_data2[$i],$y_status_sim2[$i]) = mysqli_fetch_row($result);
  				$x_data2[$i] = strtotime($x_data2[$i]);
  			}
      }
  
      /*********************************** SIM 3 **************************************/
      if( $has_3rd_sim )
      {
			  $sql = 'SELECT time,signal_quality,status 
							  FROM `'.DB_NAME.'`.stats 
							  WHERE device_id = '.$device_id.' AND time 
							  BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d")-1, date("Y"))).'" 
							  AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" AND alt = 2 ORDER BY time;';

  			$result = db_query($link, $sql);
			
	  		for($i = 0;$i < mysqli_num_rows($result);$i++)
  			{
  				list($x_data3[$i], $y_data3[$i],$y_status_sim3[$i]) = mysqli_fetch_row($result);
  				$x_data3[$i] = strtotime($x_data3[$i]);
  			}
      }

      /******************************** data service **********************************/

      $sql = 'SELECT DISTINCT status
              FROM stats
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d")-1, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" AND status IS NOT NULL ORDER BY status;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
        list($status) = mysqli_fetch_row($result);
        $status2order[$status] = $i;
			}

			$y_bottom = -35;
			$y_top = 0;
		
	
			break;
		}
		case 'quality_week':
		{
      $title = 'Signal Quality ('.$hostname.') - Last 7 Days';
      $YAxisName = 'Signal Quality';
			$YAxisUnit = 'dB';
			$date_format = "d/m";

      /*********************************** SIM 1 **************************************/      

			$sql = 	'SELECT time,signal_quality,status 
							FROM `'.DB_NAME.'`.stats 
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d")-7, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",time()).'" AND alt = 0 ORDER BY time;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
				list($x_data1[$i], $y_data1[$i],$y_status_sim1[$i]) = mysqli_fetch_row($result);
				$x_data1[$i] = strtotime($x_data1[$i]);
			}

      /*********************************** SIM 2 **************************************/      

      if( $has_2nd_sim )
      {
			  $sql = 'SELECT time,signal_quality,status 
							  FROM `'.DB_NAME.'`.stats 
							  WHERE device_id = '.$device_id.' AND time 
							  BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d")-7, date("Y"))).'" 
							  AND "'.date("Y-m-d H:i",time()).'" AND alt = 1 ORDER BY time;';

  			$result = db_query($link, $sql);
			
  			for($i = 0;$i < mysqli_num_rows($result);$i++)
  			{
  				list($x_data2[$i], $y_data2[$i],$y_status_sim2[$i]) = mysqli_fetch_row($result);
  				$x_data2[$i] = strtotime($x_data2[$i]);
  			}
      }

      /*********************************** SIM 3 **************************************/      

      if( $has_3rd_sim )
      {
			  $sql = 'SELECT time,signal_quality,status 
							  FROM `'.DB_NAME.'`.stats 
							  WHERE device_id = '.$device_id.' AND time 
							  BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d")-7, date("Y"))).'" 
							  AND "'.date("Y-m-d H:i",time()).'" AND alt = 2 ORDER BY time;';

  			$result = db_query($link, $sql);
			
  			for($i = 0;$i < mysqli_num_rows($result);$i++)
  			{
  				list($x_data3[$i], $y_data3[$i],$y_status_sim3[$i]) = mysqli_fetch_row($result);
  				$x_data3[$i] = strtotime($x_data3[$i]);
  			}
      }

      /******************************** data service **********************************/

      $sql = 'SELECT DISTINCT status
              FROM stats
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d")-7, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",time()).'" AND status IS NOT NULL ORDER BY status;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
        list($status) = mysqli_fetch_row($result);
        $status2order[$status] = $i;
			}

//  error_log(print_r($status2order, TRUE), 0);  

			$y_bottom = -35;
			$y_top = 0;
		
			break;
		}
		case 'quality_cur':
		{
			$title = 'Signal Quality ('.$hostname.') - Current Period';
			$YAxisName = 'Signal Quality';
			$YAxisUnit = 'dB';
			$date_format = "d/m";

      /*********************************** SIM 1 **************************************/   

			$sql = 	'SELECT time,signal_quality,status 
							FROM `'.DB_NAME.'`.stats 
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 1, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",time()).'" AND alt = 0 ORDER BY time;';
			
			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
				list($x_data1[$i], $y_data1[$i],$y_status_sim1[$i]) = mysqli_fetch_row($result);
				$x_data1[$i] = strtotime($x_data1[$i]);
      }

      /*********************************** SIM 2 **************************************/   

      if( $has_2nd_sim )
      {
			  $sql = 'SELECT time,signal_quality,status 
							  FROM `'.DB_NAME.'`.stats 
							  WHERE device_id = '.$device_id.' AND time 
							  BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 1, date("Y"))).'" 
							  AND "'.date("Y-m-d H:i",time()).'" AND alt = 1 ORDER BY time;';
			
  			$result = db_query($link, $sql);
			
  			for($i = 0;$i < mysqli_num_rows($result);$i++)
  			{
  				list($x_data2[$i], $y_data2[$i],$y_status_sim2[$i]) = mysqli_fetch_row($result);
  				$x_data2[$i] = strtotime($x_data2[$i]);
  			}
      }

      /*********************************** SIM 3 **************************************/   

      if( $has_3rd_sim )
      {
			  $sql = 'SELECT time,signal_quality,status 
							  FROM `'.DB_NAME.'`.stats 
							  WHERE device_id = '.$device_id.' AND time 
							  BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 1, date("Y"))).'" 
							  AND "'.date("Y-m-d H:i",time()).'" AND alt = 2 ORDER BY time;';
			
  			$result = db_query($link, $sql);
			
  			for($i = 0;$i < mysqli_num_rows($result);$i++)
  			{
  				list($x_data3[$i], $y_data3[$i],$y_status_sim3[$i]) = mysqli_fetch_row($result);
  				$x_data3[$i] = strtotime($x_data3[$i]);
  			}
      }

      /******************************** data service **********************************/

      $sql = 'SELECT DISTINCT status
              FROM stats
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 1, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",time()).'" AND status IS NOT NULL ORDER BY status;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
        list($status) = mysqli_fetch_row($result);
        $status2order[$status] = $i;
			}

			$y_bottom = -35;
			$y_top = 0;
		
			break;
		}
		case 'quality_last':
		{
			$title = 'Signal Quality ('.$hostname.') - Last Period';
      $YAxisName = 'Signal Quality';
			$YAxisUnit = 'dB';
			$date_format = "d/m";

      /*********************************** SIM 1 **************************************/

			$sql = 	'SELECT time,signal_quality,status 
							FROM `'.DB_NAME.'`.stats 
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") - 1, 1, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 0, date("Y"))).'" AND alt = 0 ORDER BY time;';
			
			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
				list($x_data1[$i], $y_data1[$i],$y_status_sim1[$i]) = mysqli_fetch_row($result);
				$x_data1[$i] = strtotime($x_data1[$i]);
			}

      /*********************************** SIM 2 **************************************/
      if( $has_2nd_sim )
      {
			  $sql = 'SELECT time,signal_quality,status 
    					  FROM `'.DB_NAME.'`.stats 
  							WHERE device_id = '.$device_id.' AND time 
  							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") - 1, 1, date("Y"))).'" 
  							AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 0, date("Y"))).'" AND alt = 1 ORDER BY time;';
			
  			$result = db_query($link, $sql);
			
  			for($i = 0;$i < mysqli_num_rows($result);$i++)
	  		{
  				list($x_data2[$i], $y_data2[$i],$y_status_sim2[$i]) = mysqli_fetch_row($result);
  				$x_data2[$i] = strtotime($x_data2[$i]);
  			}
      }

      /*********************************** SIM 3 **************************************/
      if( $has_3rd_sim )
      {
			  $sql = 'SELECT time,signal_quality,status 
    					  FROM `'.DB_NAME.'`.stats 
  							WHERE device_id = '.$device_id.' AND time 
  							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") - 1, 1, date("Y"))).'" 
  							AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 0, date("Y"))).'" AND alt = 2 ORDER BY time;';
			
  			$result = db_query($link, $sql);
			
  			for($i = 0;$i < mysqli_num_rows($result);$i++)
	  		{
  				list($x_data3[$i], $y_data3[$i],$y_status_sim3[$i]) = mysqli_fetch_row($result);
  				$x_data3[$i] = strtotime($x_data3[$i]);
  			}
      }

      /******************************** data service **********************************/

      $sql = 'SELECT DISTINCT status
              FROM stats
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") - 1, 1, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 0, date("Y"))).'" AND status IS NOT NULL ORDER BY status;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
        list($status) = mysqli_fetch_row($result);
        $status2order[$status] = $i;
			}

			$y_bottom = -35;
			$y_top = 0;
		
			break;
		}	

		case 'latency_tod':
		{
			$title = 'Latency ('.$hostname.') - Today';
			$YAxisName = 'Latency';
			$YAxisUnit = 'ms';
			$date_format = "H:i";

      /*********************************** SIM 1 **************************************/

			$sql = 	'SELECT time,latency,status 
							FROM `'.DB_NAME.'`.stats WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" 
							AND "'.date("Y-m-d H:i",time()).'" AND alt = 0 ORDER BY time;';
			
			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
				list($x_data1[$i], $y_data1[$i],$y_status_sim1[$i]) = mysqli_fetch_row($result);
				$x_data1[$i] = strtotime($x_data1[$i]);
			}

      /*********************************** SIM 2 **************************************/

      if( $has_2nd_sim )
      {
			  $sql = 'SELECT time,latency,status 
							  FROM `'.DB_NAME.'`.stats WHERE device_id = '.$device_id.' AND time 
							  BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" 
							  AND "'.date("Y-m-d H:i",time()).'" AND alt = 1 ORDER BY time;';
			
  			$result = db_query($link, $sql);
			
  			for($i = 0;$i < mysqli_num_rows($result);$i++)
  			{
  				list($x_data2[$i], $y_data2[$i],$y_status_sim2[$i]) = mysqli_fetch_row($result);
  				$x_data2[$i] = strtotime($x_data2[$i]);
  			}
      }

      /*********************************** SIM 3 **************************************/

      if( $has_3rd_sim )
      {
			  $sql = 'SELECT time,latency,status 
							  FROM `'.DB_NAME.'`.stats WHERE device_id = '.$device_id.' AND time 
							  BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" 
							  AND "'.date("Y-m-d H:i",time()).'" AND alt = 2 ORDER BY time;';
			
  			$result = db_query($link, $sql);
			
  			for($i = 0;$i < mysqli_num_rows($result);$i++)
  			{
  				list($x_data3[$i], $y_data3[$i],$y_status_sim3[$i]) = mysqli_fetch_row($result);
  				$x_data3[$i] = strtotime($x_data3[$i]);
  			}
      }

      /******************************** data service **********************************/

      $sql = 'SELECT DISTINCT status
              FROM stats
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" 
							AND "'.date("Y-m-d H:i",time()).'" AND status IS NOT NULL ORDER BY status;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
        list($status) = mysqli_fetch_row($result);
        $status2order[$status] = $i;
			}      

			$y_bottom = 0;
			$y_top = ceil(max(max($y_data1), max($y_data2), max($y_data3))/100) * 100;

			break;
		}		
		
		case 'latency_yes':
		{
			$title = 'Latency ('.$hostname.') - Yesterday';
			$YAxisName = 'Latency';
			$YAxisUnit = 'ms';
			$date_format = "H:i";

      /*********************************** SIM 1 **************************************/

			$sql = 	'SELECT time,latency,status 
							FROM `'.DB_NAME.'`.stats WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d") - 1, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" AND alt = 0 ORDER BY time;';
			
			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
				list($x_data1[$i], $y_data1[$i],$y_status_sim1[$i]) = mysqli_fetch_row($result);
				$x_data1[$i] = strtotime($x_data1[$i]);
			}

      /*********************************** SIM 2 **************************************/
      if( $has_2nd_sim )
      {
			  $sql = 'SELECT time,latency,status 
							  FROM `'.DB_NAME.'`.stats WHERE device_id = '.$device_id.' AND time 
							  BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d") - 1, date("Y"))).'" 
							  AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" AND alt = 1 ORDER BY time;';
			
  			$result = db_query($link, $sql);
			
  			for($i = 0;$i < mysqli_num_rows($result);$i++)
  			{
  				list($x_data2[$i], $y_data2[$i],$y_status_sim2[$i]) = mysqli_fetch_row($result);
  				$x_data2[$i] = strtotime($x_data2[$i]);
  			}
      }

      /*********************************** SIM 3 **************************************/
      if( $has_3rd_sim )
      {
			  $sql = 'SELECT time,latency,status 
							  FROM `'.DB_NAME.'`.stats WHERE device_id = '.$device_id.' AND time 
							  BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d") - 1, date("Y"))).'" 
							  AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" AND alt = 2 ORDER BY time;';
			
  			$result = db_query($link, $sql);
			
  			for($i = 0;$i < mysqli_num_rows($result);$i++)
  			{
  				list($x_data3[$i], $y_data3[$i],$y_status_sim3[$i]) = mysqli_fetch_row($result);
  				$x_data3[$i] = strtotime($x_data3[$i]);
  			}
      }

      /******************************** data service **********************************/

      $sql = 'SELECT DISTINCT status
              FROM stats
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d") - 1, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" AND status IS NOT NULL ORDER BY status;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
        list($status) = mysqli_fetch_row($result);
        $status2order[$status] = $i;
			}

			$y_bottom = 0;
			$y_top = ceil(max(max($y_data1), max($y_data2), max($y_data3))/100) * 100;
		
			break;
		}		
		
		case 'latency_week':
		{
			$title = 'Latency ('.$hostname.') - Last 7 Days';
			$YAxisName = 'Latency';
			$YAxisUnit = 'ms';
			$date_format = "d/m";

      /*********************************** SIM 1 **************************************/

			$sql = 	'SELECT time,latency,status 
							FROM `'.DB_NAME.'`.stats WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d") - 7, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",time()).'" AND alt = 0 ORDER BY time;';
			
			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
				list($x_data1[$i], $y_data1[$i],$y_status_sim1[$i]) = mysqli_fetch_row($result);
				$x_data1[$i] = strtotime($x_data1[$i]);
			}

      /*********************************** SIM 2 **************************************/
      if( $has_2nd_sim )
      {
			  $sql = 'SELECT time,latency,status 
							  FROM `'.DB_NAME.'`.stats WHERE device_id = '.$device_id.' AND time 
							  BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d") - 7, date("Y"))).'" 
							  AND "'.date("Y-m-d H:i",time()).'" AND alt = 1 ORDER BY time;';
			
  			$result = db_query($link, $sql);
			
  			for($i = 0;$i < mysqli_num_rows($result);$i++)
  			{
  				list($x_data2[$i], $y_data2[$i],$y_status_sim2[$i]) = mysqli_fetch_row($result);
  				$x_data2[$i] = strtotime($x_data2[$i]);
  			}
      }

      /*********************************** SIM 3 **************************************/
      if( $has_3rd_sim )
      {
			  $sql = 'SELECT time,latency,status 
							  FROM `'.DB_NAME.'`.stats WHERE device_id = '.$device_id.' AND time 
							  BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d") - 7, date("Y"))).'" 
							  AND "'.date("Y-m-d H:i",time()).'" AND alt = 2 ORDER BY time;';
			
  			$result = db_query($link, $sql);
			
  			for($i = 0;$i < mysqli_num_rows($result);$i++)
  			{
  				list($x_data3[$i], $y_data3[$i],$y_status_sim3[$i]) = mysqli_fetch_row($result);
  				$x_data3[$i] = strtotime($x_data3[$i]);
  			}
      }

      /******************************** data service **********************************/

      $sql = 'SELECT DISTINCT status
              FROM stats
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d") - 7, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",time()).'" AND status IS NOT NULL ORDER BY status;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
        list($status) = mysqli_fetch_row($result);
        $status2order[$status] = $i;
			}

			$y_bottom = 0;
			$y_top = ceil(max(max($y_data1), max($y_data2), max($y_data3))/100) * 100;
		
			break;
		}
		case 'latency_cur':
		{
			$title = 'Latency ('.$hostname.') - Current Period';
			$YAxisName = 'Latency';
			$YAxisUnit = 'ms';
			$date_format = "d/m";

      /*********************************** SIM 1 **************************************/

			$sql = 	'SELECT time,latency,status 
							FROM `'.DB_NAME.'`.stats WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 1, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",time()).'" AND alt = 0 ORDER BY time;';
			
			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
				list($x_data1[$i], $y_data1[$i],$y_status_sim1[$i]) = mysqli_fetch_row($result);
				$x_data1[$i] = strtotime($x_data1[$i]);
			}

      /*********************************** SIM 2 **************************************/
      if( $has_2nd_sim )
      {
			  $sql = 'SELECT time,latency,status 
							  FROM `'.DB_NAME.'`.stats WHERE device_id = '.$device_id.' AND time 
							  BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 1, date("Y"))).'" 
							  AND "'.date("Y-m-d H:i",time()).'" AND alt = 1 ORDER BY time;';
			
  			$result = db_query($link, $sql);
			
  			for($i = 0;$i < mysqli_num_rows($result);$i++)
  			{
  				list($x_data2[$i], $y_data2[$i],$y_status_sim2[$i]) = mysqli_fetch_row($result);
  				$x_data2[$i] = strtotime($x_data2[$i]);
  			}
      }

      /*********************************** SIM 3 **************************************/
      if( $has_3rd_sim )
      {
			  $sql = 'SELECT time,latency,status 
							  FROM `'.DB_NAME.'`.stats WHERE device_id = '.$device_id.' AND time 
							  BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 1, date("Y"))).'" 
							  AND "'.date("Y-m-d H:i",time()).'" AND alt = 2 ORDER BY time;';
			
  			$result = db_query($link, $sql);
			
  			for($i = 0;$i < mysqli_num_rows($result);$i++)
  			{
  				list($x_data3[$i], $y_data3[$i],$y_status_sim3[$i]) = mysqli_fetch_row($result);
  				$x_data3[$i] = strtotime($x_data3[$i]);
  			}
      }

      /******************************** data service **********************************/

      $sql = 'SELECT DISTINCT status
              FROM stats
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 1, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",time()).'" AND status IS NOT NULL ORDER BY status;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
        list($status) = mysqli_fetch_row($result);
        $status2order[$status] = $i;
			}

			$y_bottom = 0;
			$y_top = ceil(max(max($y_data1), max($y_data2), max($y_data3))/100) * 100;
		
			break;
		}
		case 'latency_last':
		{
			$title = 'Latency ('.$hostname.') - Last Period';
			$YAxisName = 'Latency';
			$YAxisUnit = 'ms';
			$date_format = "d/m";

      /*********************************** SIM 1 **************************************/

			$sql = 	'SELECT time,latency,status 
							FROM `'.DB_NAME.'`.stats WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") - 1, 1, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 0, date("Y"))).'" AND alt = 0 ORDER BY time;';
			
			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
				list($x_data1[$i], $y_data1[$i],$y_status_sim1[$i]) = mysqli_fetch_row($result);
				$x_data1[$i] = strtotime($x_data1[$i]);
			}

      /*********************************** SIM 2 **************************************/
      if( $has_2nd_sim )
      {
		    $sql = 'SELECT time,latency,status 
							  FROM `'.DB_NAME.'`.stats WHERE device_id = '.$device_id.' AND time 
  							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") - 1, 1, date("Y"))).'" 
  							AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 0, date("Y"))).'" AND alt = 1 ORDER BY time;';
			
  			$result = db_query($link, $sql);
			
  			for($i = 0;$i < mysqli_num_rows($result);$i++)
  			{
  				list($x_data2[$i], $y_data2[$i],$y_status_sim2[$i]) = mysqli_fetch_row($result);
  				$x_data2[$i] = strtotime($x_data2[$i]);
  			}
      }

      /*********************************** SIM 3 **************************************/
      if( $has_3rd_sim )
      {
		    $sql = 'SELECT time,latency,status 
							  FROM `'.DB_NAME.'`.stats WHERE device_id = '.$device_id.' AND time 
  							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") - 1, 1, date("Y"))).'" 
  							AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 0, date("Y"))).'" AND alt = 2 ORDER BY time;';
			
  			$result = db_query($link, $sql);
			
  			for($i = 0;$i < mysqli_num_rows($result);$i++)
  			{
  				list($x_data3[$i], $y_data3[$i],$y_status_sim3[$i]) = mysqli_fetch_row($result);
  				$x_data3[$i] = strtotime($x_data3[$i]);
  			}
      }

      /******************************** data service **********************************/

      $sql = 'SELECT DISTINCT status
              FROM stats
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") - 1, 1, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 0, date("Y"))).'" AND status IS NOT NULL ORDER BY status;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
        list($status) = mysqli_fetch_row($result);
        $status2order[$status] = $i;
			}

			$y_bottom = 0;
			$y_top = ceil(max(max($y_data1), max($y_data2), max($y_data3))/100) * 100;
		
			break;
		}

		case 'avail_tod':
		{
			$title = 'Availability ('.$hostname.') - Today';
			$YAxisName = 'Availability';
			$YAxisUnit = '%';
			$date_format = "H:i";

			$sql = 	'SELECT time,availability,status 
							FROM `'.DB_NAME.'`.stats WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" 
							AND "'.date("Y-m-d H:i",time()).'" ORDER BY time;';
			
			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
				list($x_data1[$i], $y_data1[$i],$y_status_sim1[$i]) = mysqli_fetch_row($result);
				$x_data1[$i] = strtotime($x_data1[$i]);
			}

      $sql = 'SELECT DISTINCT status
              FROM stats
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" 
							AND "'.date("Y-m-d H:i",time()).'" AND status IS NOT NULL ORDER BY status;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
        list($status) = mysqli_fetch_row($result);
        $status2order[$status] = $i;
			}
	
			$y_bottom = 0;
			$y_top = 100;
		
			break;
		}

		case 'avail_yes':
		{
			$title = 'Availability ('.$hostname.') - Yesterday';
			$YAxisName = 'Availability';
			$YAxisUnit = '%';
			$date_format = "H:i";

			$sql = 	'SELECT time,availability,status 
							FROM `'.DB_NAME.'`.stats WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d")-1, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" ORDER BY time;';
			
			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
				list($x_data1[$i], $y_data1[$i],$y_status_sim1[$i]) = mysqli_fetch_row($result);
				$x_data1[$i] = strtotime($x_data1[$i]);
			}

      $sql = 'SELECT DISTINCT status
              FROM stats
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d")-1, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d"), date("Y"))).'" AND status IS NOT NULL ORDER BY status;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
        list($status) = mysqli_fetch_row($result);
        $status2order[$status] = $i;
			}

			$y_bottom = 0;
			$y_top = 100;
		
			break;
		}
		
		case 'avail_week':
		{
			$title = 'Availability ('.$hostname.') - Last 7 Days';
			$YAxisName = 'Availability';
			$YAxisUnit = '%';
			$date_format = "d/m";

			$sql = 	'SELECT time,availability,status 
							FROM `'.DB_NAME.'`.stats WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d")-7, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",time()).'" ORDER BY time;';
			
			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
				list($x_data1[$i], $y_data1[$i],$y_status_sim1[$i]) = mysqli_fetch_row($result);
				$x_data1[$i] = strtotime($x_data1[$i]);
			}

      $sql = 'SELECT DISTINCT status
              FROM stats
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , date("d")-7, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",time()).'" AND status IS NOT NULL ORDER BY status;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
        list($status) = mysqli_fetch_row($result);
        $status2order[$status] = $i;
			}

			$y_bottom = 0;
			$y_top = 100;
		
			break;
		}				
		
		case 'avail_cur':
		{
			$title = 'Availability ('.$hostname.') - Current Period';
			$YAxisName = 'Availability';
			$YAxisUnit = '%';
			$date_format = "d/m";

			$sql = 	'SELECT time,availability,status 
							FROM `'.DB_NAME.'`.stats WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 1, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",time()).'" ORDER BY time;';
			
			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
				list($x_data1[$i], $y_data1[$i],$y_status_sim1[$i]) = mysqli_fetch_row($result);
				$x_data1[$i] = strtotime($x_data1[$i]);
			}

      $sql = 'SELECT DISTINCT status
              FROM stats
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 1, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",time()).'" AND status IS NOT NULL ORDER BY status;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
        list($status) = mysqli_fetch_row($result);
        $status2order[$status] = $i;
			}

			$y_bottom = 0;
			$y_top = 100;
		
			break;
		}		

		case 'avail_last':
		{
			$title = 'Availability ('.$hostname.') - Last Period';
			$YAxisName = 'Availability';
			$YAxisUnit = '%';
			$date_format = "d/m";

			$sql = 	'SELECT time,availability,status 
							FROM `'.DB_NAME.'`.stats WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") - 1, 1, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 0, date("Y"))).'" ORDER BY time;';
			
			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
				list($x_data1[$i], $y_data1[$i],$y_status_sim1[$i]) = mysqli_fetch_row($result);
				$x_data1[$i] = strtotime($x_data1[$i]);
			}

      $sql = 'SELECT DISTINCT status
              FROM stats
							WHERE device_id = '.$device_id.' AND time 
							BETWEEN "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") - 1, 1, date("Y"))).'" 
							AND "'.date("Y-m-d H:i",mktime(0, 0, 0, date("m") , 0, date("Y"))).'" AND status IS NOT NULL ORDER BY status;';

			$result = db_query($link, $sql);
			
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
        list($status) = mysqli_fetch_row($result);
        $status2order[$status] = $i;
			}

			$y_bottom = 0;
			$y_top = 100;
		
			break;
		}

		
		case 'ploss_tod':
		{
			$title = 'Packet Loss ('.$hostname.') - Today';
			$YAxisName = 'Packet Loss';
			$YAxisUnit = '%';
			$date_format = "H:i";

			$from_timestamp = mktime(0, 0, 0, date("m") , date("d"), date("Y"));
			$to_timestamp = time();
			
			$sql = 'CALL sp_GetDevDayListPLoss('.$from_timestamp.','.$to_timestamp.','.$device_id.')';

			// vykonani SQL prikazu
			$result = db_multi_query($link, $sql);		
		
			$j = mysqli_num_rows($result);	
		
			for($i = 0;$i < $j;$i++)
			{
				list($temp_day,$temp_ploss) = mysqli_fetch_row($result);
				$x_data1[$i] = $temp_day;
				$y_data1[$i] = round($temp_ploss,1);
			}
		
			if(mysqli_more_results($link))
			{	//Catch 'OK'/'ERR'
				while(mysqli_next_result($link));
			}	
		
			$y_bottom = 0;
			$y_top = 100;
		
			break;
		}		
		
		case 'ploss_yes':
		{
			$title = 'Packet Loss ('.$hostname.') - Yesterday';
			$YAxisName = 'Packet Loss';
			$YAxisUnit = '%';
			$date_format = "H:i";

			$from_timestamp = mktime(0, 0, 0, date("m") , date("d")-1, date("Y"));
			$to_timestamp = mktime(0, 0, 0, date("m") , date("d"), date("Y"));
			
			$sql = 'CALL sp_GetDevDayListPLoss('.$from_timestamp.','.$to_timestamp.','.$device_id.')';

			// vykonani SQL prikazu
			$result = db_multi_query($link, $sql);		
		
			$j = mysqli_num_rows($result);	
		
			for($i = 0;$i < $j;$i++)
			{
				list($temp_day,$temp_ploss) = mysqli_fetch_row($result);
				$x_data1[$i] = $temp_day;
				$y_data1[$i] = round($temp_ploss,1);
			}
		
			if(mysqli_more_results($link))
			{	//Catch 'OK'/'ERR'
				while(mysqli_next_result($link));
			}	
		
			$y_bottom = 0;
			$y_top = 100;
		
			break;
		}		
		
		case 'ploss_week':
		{
			$title = 'Packet Loss ('.$hostname.') - Last 7 Days';
			$YAxisName = 'Packet Loss';
			$YAxisUnit = '%';
			$date_format = "d/m";

			$from_timestamp = mktime(0, 0, 0, date("m") , date("d") - 7, date("Y"));
			$to_timestamp = time();
			
			$sql = 'CALL sp_GetDevDayListPLoss('.$from_timestamp.','.$to_timestamp.','.$device_id.')';

			// vykonani SQL prikazu
			$result = db_multi_query($link, $sql);		
		
			for($i = 0;$i < mysqli_num_rows($result);$i++)
			{
				list($temp_day,$temp_ploss) = mysqli_fetch_row($result);
				$x_data1[$i] = $temp_day;
				$y_data1[$i] = round($temp_ploss,1);
			}
		
			if(mysqli_more_results($link))
			{	//Catch 'OK'/'ERR'
				while(mysqli_next_result($link));
			}	
		
			$y_bottom = 0;
			$y_top = 100;
		
			break;
		}		
		
		case 'ploss_cur':
		{
			$title = 'Packet Loss ('.$hostname.') - Current Period';
			$YAxisName = 'Packet Loss';
			$YAxisUnit = '%';
			$date_format = "d/m";

			$from_timestamp = mktime(0, 0, 0, date("m") , 1, date("Y"));
			$to_timestamp = time();
			
			$sql = 'CALL sp_GetDevDayListPLoss('.$from_timestamp.','.$to_timestamp.','.$device_id.')';

			// vykonani SQL prikazu
			$result = db_multi_query($link, $sql);		
		
			$j = mysqli_num_rows($result);	
		
			for($i = 0;$i < $j;$i++)
			{
				list($temp_day,$temp_ploss) = mysqli_fetch_row($result);
				$x_data1[$i] = $temp_day;
				$y_data1[$i] = round($temp_ploss,1);
			}
		
			if(mysqli_more_results($link))
			{	//Catch 'OK'/'ERR'
				while(mysqli_next_result($link));
			}	
		
			$y_bottom = 0;
			$y_top = 100;
		
			break;
		}		

		case 'ploss_last':
		{
			$title = 'Packet Loss ('.$hostname.') - Last Period';
			$YAxisName = 'Packet Loss';
			$YAxisUnit = '%';
			$date_format = "d/m";

			$from_timestamp = mktime(0, 0, 0, date("m") - 1, 1, date("Y"));
			$to_timestamp = mktime(0, 0, 0, date("m") , 0, date("Y"));
			
					
			$sql = 'CALL sp_GetDevDayListPLoss('.$from_timestamp.','.$to_timestamp.','.$device_id.')';

			// vykonani SQL prikazu
			$result = db_multi_query($link, $sql);		
		
			$j = mysqli_num_rows($result);	
		
			for($i = 0;$i < $j;$i++)
			{
				list($temp_day,$temp_ploss) = mysqli_fetch_row($result);
				$x_data1[$i] = $temp_day;
				$y_data1[$i] = round($temp_ploss,1);
			}
		
			if(mysqli_more_results($link))
			{	//Catch 'OK'/'ERR'
				while(mysqli_next_result($link));
			}	
		
			$y_bottom = 0;
			$y_top = 100;
		
			break;
		}
	
	}
	
  // slouceni 2 prubehu

	$x_data = array();  
  $y_data1_tuned = array();	
	$y_data2_tuned = array();
	$y_data3_tuned = array();
  $y_status_tuned = array();

  $j = 0;
  $k = 0;
  $l = 0;

//error_log("x_data1 = ".count($x_data1)."x_data2 = ".count($x_data2), 0);
//error_log(print_r($x_data1, TRUE), 0);
//error_log(print_r($x_data2, TRUE), 0);

  // serazeni hodnot za sebe podle casu

  for($m = 0;$m < (count($x_data1) + count($x_data2) + count($x_data3));$m++)
  {
    // hledani nejblizsi casti
    if( !isset( $x_data1[$j] ) )
    {
      $temp = 40000000000;
    }
    else
    {
      $temp = $x_data1[$j];
      $curve_id = 0;
    }

    if( isset($x_data2[$k]) )
    if( $temp > $x_data2[$k] )
    {
      $temp = $x_data2[$k];
      $curve_id = 1;
    }

    if( isset($x_data3[$l]) )    
    if( $temp > $x_data3[$l] )
    {
      $temp = $x_data3[$l];
      $curve_id = 2;
    }

    switch( $curve_id )
    {
      case 0: // vezmeme bod z prvni sim
        $x_data[$m] = $x_data1[$j];
        $y_data1_tuned[$m] = $y_data1[$j];
        $y_data2_tuned[$m] = NULL;
        $y_data3_tuned[$m] = NULL;
        if(count($status2order) > 0)
        {        
          $y_status_tuned[$m] = $y_status_sim1[$j];
        }
        $j++;        

        break;

      case 1: // vezmeme bod z druhe sim
        $x_data[$m] = $x_data2[$k];
        $y_data1_tuned[$m] = NULL;
        $y_data2_tuned[$m] = $y_data2[$k];
        $y_data3_tuned[$m] = NULL;
        if(count($status2order) > 0)
        {        
          $y_status_tuned[$m] = $y_status_sim2[$k];
        }
        $k++;        

        break;

      case 2: // vezmeme bod z treti sim
        $x_data[$m] = $x_data3[$l];
        $y_data1_tuned[$m] = NULL;
        $y_data2_tuned[$m] = NULL;
        $y_data3_tuned[$m] = $y_data3[$l];
        if(count($status2order) > 0)
        {        
          $y_status_tuned[$m] = $y_status_sim3[$l];
        }
        $l++;        

        break;    
    }
  }

	if(sizeof($x_data) < 3)
	{ // malo dat, vrazime tam obrazek s chybou
		$file = 'img/graph_no_data.png';
	
		if (file_exists($file)) {
			readfile($file);
		}	
		exit;
	}
  
  // zjisteni nejmensiho intervalu mezi body na X-ove ose
	$x_diff = 40000000000;
	for($i = 0;$i < (sizeof($x_data) - 2);$i++)
	{
		if((($x_data[$i + 1] - $x_data[$i]) < $x_diff) && (($x_data[$i + 1] - $x_data[$i]) > 500))
		{
			$x_diff = $x_data[$i + 1] - $x_data[$i];
		}
		//echo($x_diff.'<br>');		
	}
	
	$x_corr = array();
	$y_corr1 = array();
  $y_corr2 = array();
  $y_corr3 = array();
  $y_status_corr = array();
  $y_shadow = array();
	$i_corr = 0;
	
	for($i = 0;$i < (sizeof($x_data) - 1);$i++)
	{
		if(($x_data[$i + 1] - $x_data[$i]) > (2 * $x_diff))
		{
		  // error_log("doplnuje",0);
			$miss_count = floor(($x_data[$i + 1] - $x_data[$i]) / $x_diff);
     // $y_shadow[$i_corr - 1] = $y_top;
			for($j = 0;$j < $miss_count;$j++)
			{
				$x_corr[$i_corr] = $x_data[$i] + ($j * $x_diff);
				$y_corr1[$i_corr] = '';
				$y_corr2[$i_corr] = '';
				$y_corr3[$i_corr] = '';
        $y_shadow[$i_corr] = $y_top;

        if(count($status2order) > 0)
        {
          for($m = 0;$m < count($status2order);$m++)
          {
            $y_status_corr[$m][$i_corr] = '';
          }
        }  

				$i_corr++;				
			}
    }
		else
		{
			$x_corr[$i_corr] = $x_data[$i];
			$y_corr1[$i_corr] = is_null($y_data1_tuned[$i]) ? '' : $y_data1_tuned[$i];
			$y_corr2[$i_corr] = is_null($y_data2_tuned[$i]) ? '' : $y_data2_tuned[$i];      
			$y_corr3[$i_corr] = is_null($y_data3_tuned[$i]) ? '' : $y_data3_tuned[$i];

      if(count($status2order) > 0)
      {
        for($m = 0;$m < count($status2order);$m++)
        {
          $y_status_corr[$m][$i_corr] = '';
        }
        if(!is_null($y_status_tuned[$i]))
        {
          $y_status_corr[$status2order[$y_status_tuned[$i]]][$i_corr] = $y_top;
        }
      }  


      if(is_null($y_data1_tuned[$i]) && is_null($y_data2_tuned[$i]) && is_null($y_data3_tuned[$i]))
      {
        $y_shadow[$i_corr] = $y_top;
      }
      
      $y_shadow[$i_corr] = (is_null($y_data1_tuned[$i]) && is_null($y_data2_tuned[$i]) && is_null($y_data3_tuned[$i])) ? $y_top : '';
    /*  if(($i_corr - 1) > 0)
      {
        $y_shadow[$i_corr] = $y_corr[$i_corr - 1] == '' ? $y_top : '';      
      }  */
     
			$i_corr++;
		}
	}

/*  error_log(print_r($x_data1, TRUE), 0);

  error_log(print_r($y_corr1, TRUE), 0);*/

	$x_skip = ceil(count($x_corr) / 20);

	$DataSet = new pData;
  $DataSet->AddPoint($y_corr1,"Serie1");
  if($has_2nd_sim)
  {
    $DataSet->AddPoint($y_corr2,"Serie2");
  }  
  if($has_3rd_sim)
  {
    $DataSet->AddPoint($y_corr3,"Serie3");
  }
  $DataSet->AddPoint($y_shadow,"Serie4");
  $DataSet->AddSerie();

  $DataSet->SetAbsciseLabelSerie("Serie5");
  $DataSet->AddPoint($x_corr,"Serie5");

  if($has_2nd_sim || $has_3rd_sim)
  {
    $DataSet->SetSerieName("Sim 1","Serie1");
    
    if( $has_2nd_sim )
    {
      $DataSet->SetSerieName("Sim 2","Serie2");
    }
    if( $has_3rd_sim )
    {
      $DataSet->SetSerieName("CDMA","Serie3");
    }    
  }  
  else
  {
    $DataSet->SetSerieName($YAxisName,"Serie1");  
  }

  $DataSet->SetSerieName("Offline","Serie4");

  if(count($status2order) > 0)
  {
    foreach($status2order as $tech => $index)
    {
      $DataSet->AddPoint($y_status_corr[$index],"Serie".($index + 6));
      $DataSet->AddSerie();
      $DataSet->SetSerieName(decoding_network_status($tech),"Serie".($index + 6));
    }
  }  

  $DataSet->SetYAxisName($YAxisName);    
  $DataSet->SetYAxisUnit($YAxisUnit);
  $DataSet->SetXAxisName("Time");
  $DataSet->SetXAxisFormat("date");
  
  // Initialise the graph
  $Graph = new pChart(820,330);

  $course_id = 0;

  // barva pro prvni sim
  $Graph->setColorPalette($course_id++,208,0,0);

  if($has_2nd_sim)
  { // barva pro druhou sim
    $Graph->setColorPalette($course_id++,0,0,208);
  }

  if($has_3rd_sim)
  { // barva pro druhou sim
    $Graph->setColorPalette($course_id++,0,208,0);
  }

  // barva pro offline
  $Graph->setColorPalette($course_id++,167,167,167);

  if(count($status2order) > 0)
  { // barvy pro znazorneni pouzite prenosove technologie
    foreach($status2order as $tech => $index)
    {
      switch($tech)
      { // GPRS
        case 1: 
        case 2: 
          $Graph->setColorPalette($course_id++,255,255,0);
          break;

        // EDGE
        case 3: 
        case 4: 
          $Graph->setColorPalette($course_id++,0,255,0);
          break;
        // UMTS
        case 5:
        case 6:
          $Graph->setColorPalette($course_id++,0,0,255);
          break;
        // HSDPA
        case 7:
        case 8:
          $Graph->setColorPalette($course_id++,255,0,0);
          break;          
        // HSUPA
        case 9:
        case 10:
          $Graph->setColorPalette($course_id++,160,82,45);
          break;          
        // HSPA+
        case 11:
        case 12:
          $Graph->setColorPalette($course_id++,0,191,255);
          break;          
        // LTE
        case 13:
        case 14:
          $Graph->setColorPalette($course_id++,255,215,0);
          break;          
        // CDMA
        case 15:
        case 16:
          $Graph->setColorPalette($course_id++,0,255,127);
          break;          
        // unknow
		    default: break;
      }
    }
  }

  $Graph->setFontProperties("Fonts/tahoma.ttf",10);
  $Graph->setDateFormat($date_format);
  $Graph->setGraphArea(90,30,680,250);
  $Graph->drawGraphArea(252,252,252,FALSE);
	$Graph->setFixedScale($y_bottom,$y_top,5,0,0,5);
  $Graph->drawScale($DataSet->GetData(),$DataSet->GetDataDescription(),SCALE_NORMAL,0,0,0,TRUE,45,0,FALSE,$x_skip);
  $Graph->drawGrid(4,TRUE,230,230,230,70);

  // Draw the graph  

  $DataSet->AddSerie("Serie1");	
  $Graph->drawLineGraph($DataSet->GetData(),$DataSet->GetDataDescription());
  $Graph->drawPlotGraph($DataSet->GetData(),$DataSet->GetDataDescription(),1,0,255,255,255);
	$DataSet->RemoveSerie("Serie1");

  if($has_2nd_sim)  
  {
    $DataSet->AddSerie("Serie2");	
    $Graph->drawLineGraph($DataSet->GetData(),$DataSet->GetDataDescription());
    $Graph->drawPlotGraph($DataSet->GetData(),$DataSet->GetDataDescription(),1,0,255,255,255);
  	$DataSet->RemoveSerie("Serie2");    
  }

  if($has_3rd_sim)  
  {
    $DataSet->AddSerie("Serie3");	
    $Graph->drawLineGraph($DataSet->GetData(),$DataSet->GetDataDescription());
    $Graph->drawPlotGraph($DataSet->GetData(),$DataSet->GetDataDescription(),1,0,255,255,255);
  	$DataSet->RemoveSerie("Serie3");    
  }

  $DataSet->AddSerie("Serie4");	  
	$Graph->drawFilledLineGraph($DataSet->GetData(),$DataSet->GetDataDescription(),20,FALSE);
  $DataSet->RemoveSerie("Serie4");

  if(!is_null($status2order))
  {
    for($m = 0;$m < count($status2order);$m++)
    {
      $DataSet->AddSerie("Serie".($m + 6));	  
  	  $Graph->drawFilledLineGraph($DataSet->GetData(),$DataSet->GetDataDescription(),20,FALSE);  
      $DataSet->RemoveSerie("Serie".($m + 6));
    }
  }

  $Graph->setFontProperties("Fonts/tahoma.ttf",9);  
  $Graph->drawLegend(690,25,$DataSet->GetDataDescription(),255,255,255);

  $Graph->setFontProperties("Fonts/tahoma.ttf",12);
  $Graph->drawTitle(130,20,$title,0,0,0,585);
  $Graph->Stroke();
	
?>
