<?php
/***************************************************************************/
/*                                                                         */
/*  FORMULAR PRO PRIDAVANI FIREM  					                               */
/*                                                                         */
/***************************************************************************/

	// pripojeni hlavicky
  include ("php/head.php");
	
	// pripojeni menu
  include ("php/menu.php");
	require_once "config.inc.php";	

  include ("php/js_misc.php");

  js_begin( " 
              function CheckForm()
              {
                if( IsEmpty(document.f.add_name) ){
                  return Error( 'Missing group name.', document.f.add_name );
                }
                if( !IsInRange(document.f.add_level_limit,-120,-30 ,1) ){
                  return Error( 'Invalid Level Limit value.', document.f.add_level_limit );
                }
                if( !IsInRange(document.f.add_qual_limit_lo,-35,0 ,1) ){
                  return Error( 'Invalid Quality Limit value.', document.f.add_qual_limit_lo );
                }
                if( !IsInRange(document.f.add_traffic_limit,0,100000 ,1) ){
                  return Error( 'Invalid Traffic Limit value.', document.f.add_traffic_limit );
                }
                if( !IsInRange(document.f.add_traffic_limit_alt,0,100000 ,1) ){
                  return Error( 'Invalid Traffic Limit Alt value.', document.f.add_traffic_limit_alt );
                }
                if( !IsInRange(document.f.add_traffic_limit_alt2,0,100000 ,1) ){
                  return Error( 'Invalid Traffic Limit Alt value.', document.f.add_traffic_limit_alt2 );
                }
                if( !IsInRange(document.f.add_temp_limit_lo,-50,90 ,1) ){
                  return Error( 'Invalid Min Temp Limit value.', document.f.add_temp_limit_lo );
                }
                if( !IsInRange(document.f.add_temp_limit_hi,-50,90 ,1) ){
                  return Error( 'Invalid Max Temp Limit value.', document.f.add_temp_limit_hi );
                }
                if( !IsInRange(document.f.add_volt_limit_lo,5,60 ,1) ){
                  return Error( 'Invalid Min Voltage Limit value.', document.f.add_volt_limit_lo );
                }
                if( !IsInRange(document.f.add_volt_limit_hi,5,60 ,1) ){
                  return Error( 'Invalid Max Voltage Limit value.', document.f.add_volt_limit_hi );
                }
                if( !IsInRange(document.f.add_group_window,1,1440 ,0) ){
                  return Error( 'Invalid or missing group window value.', document.f.add_group_window );
                }
                if( !IsInRange(document.f.add_max_fails,1,255 ,1) ){
                  return Error( 'Invalid or missing Max fails for avail value.', document.f.add_max_fails );
                }
                if( !IsInRange(document.f.add_max_fails_msg,1,255 ,1) ){
                  return Error( 'Invalid or missing Max fails for msg value.', document.f.add_max_fails_msg );
                }
                if( !IsInRange(document.f.add_delay_msg,0,255 ,0) ){
                  return Error( 'Invalid or missing delay for msg value.', document.f.add_delay_msg );
                }
                return true;
              }
    " );

  if(isset( $_GET['group_id']) && is_numeric( $_GET['group_id'] ) )
  {
    $group_id = $_GET['group_id'];
  }
  else
  {
    echo "Invalid group ID";
    exit;
  }

  $link = db_connect();

  $sql = 'SELECT description, level_limit, qual_limit_lo, traffic_limit, traffic_limit_alt, traffic_limit_alt2, temp_limit_lo, temp_limit_hi, volt_limit_lo, volt_limit_hi, report_period, max_fails, max_fails_msg, delay_msg 
          FROM groups
          WHERE group_id = "'.$group_id.'"';

  $result = db_query($link, $sql);

  list($description, $level_limit, $qual_limit_lo, $traffic_limit, $traffic_limit_alt, $traffic_limit_alt2, $temp_limit_lo, $temp_limit_hi, $volt_limit_lo, $volt_limit_hi, $group_window, $max_fails, $max_fails_msg, $delay_msg) = mysqli_fetch_row( $result );

  $description        = is_null($description) ? "" : $description;
  $level_limit        = is_null($level_limit) ? "" : $level_limit;
  $qual_limit_lo        = is_null($qual_limit_lo) ? "" : $qual_limit_lo;
  $traffic_limit      = is_null($traffic_limit) ? "" : $traffic_limit / 1000000;
  $traffic_limit_alt  = is_null($traffic_limit_alt) ? "" : $traffic_limit_alt / 1000000;
  $traffic_limit_alt2  = is_null($traffic_limit_alt2) ? "" : $traffic_limit_alt2 / 1000000;
  $temp_limit_lo        = is_null($temp_limit_lo) ? "" : $temp_limit_lo;
  $temp_limit_hi        = is_null($temp_limit_hi) ? "" : $temp_limit_hi;
  $volt_limit_lo        = is_null($volt_limit_lo) ? "" : $volt_limit_lo;
  $volt_limit_hi        = is_null($volt_limit_hi) ? "" : $volt_limit_hi;
  $max_fails            = is_null($max_fails) ? "" : $max_fails;
  $max_fails_msg        = is_null($max_fails_msg) ? "" : $max_fails_msg;
  $delay_msg            = is_null($delay_msg) ? "" : $delay_msg;
  $group_window = $group_window / 60;

?>
            <tr>
              <th  colspan="3">Edit Group</td>
            </tr>
            <tr>
              <td colspan="3">
                <table width="100%">
                  <tr>
                    <td>
                      <form name="f" action="index.php" method="get">
                      <input type="hidden" name="page" value="group_change">
                      <input type="hidden" name="oper" value="edit">
                      <input type="hidden" name="group_id" value="<?php echo $group_id;?>">
                      <table>
                        <tr>
                          <td width="150px">Description</td><td><input type="text" name="add_name" value="<?php echo $description;?>"></td>
                        </tr>
                        <tr>
                          <td>Level Limit *</td><td><input type="text" name="add_level_limit" value="<?php echo $level_limit;?>"></td><td>dBm</td>
                        </tr>
                        <tr>
                          <td>Quality Limit *</td><td><input type="text" name="add_qual_limit_lo" value="<?php echo $qual_limit_lo;?>"></td><td>dB</td>
                        </tr>
                        <tr>
                          <td>Traffic Limit *</td><td><input type="text" name="add_traffic_limit" value="<?php echo $traffic_limit;?>"></td><td>MB</td>
                        </tr>
                        <tr>
                          <td>2nd Traffic Limit *</td><td><input type="text" name="add_traffic_limit_alt" value="<?php echo $traffic_limit_alt;?>"></td><td>MB</td>
                        </tr>
                        <tr>
                          <td>3rd Traffic Limit *</td><td><input type="text" name="add_traffic_limit_alt2" value="<?php echo $traffic_limit_alt2;?>"></td><td>MB</td>
                        </tr>
                        <tr>
                          <td>Min Temp Limit *</td><td><input type="text" name="add_temp_limit_lo" value="<?php echo $temp_limit_lo;?>"></td><td>&deg;C</td>
                        </tr>
                        <tr>
                          <td>Max Temp Limit *</td><td><input type="text" name="add_temp_limit_hi" value="<?php echo $temp_limit_hi;?>"></td><td>&deg;C</td>
                        </tr>
                        <tr>
                          <td>Min Voltage Limit *</td><td><input type="text" name="add_volt_limit_lo" value="<?php echo $volt_limit_lo;?>"></td><td>V</td>
                        </tr>
                        <tr>
                          <td>Max Voltage Limit *</td><td><input type="text" name="add_volt_limit_hi" value="<?php echo $volt_limit_hi;?>"></td><td>V</td>
                        </tr>
                        <tr>
                          <td>Report group window</td><td><input type="text" name="add_group_window" value="<?php echo $group_window;?>"></td><td>min</td>
                        </tr>
                        <tr>
                          <td>Max fails for avail </td><td><input type="text" name="add_max_fails" value="<?php echo $max_fails;?>"></td><td></td>
                        </tr>
                        <tr>
                          <td>Max fails for msg </td><td><input type="text" name="add_max_fails_msg" value="<?php echo $max_fails_msg;?>"></td><td></td>
                        </tr>
                        <tr>
                          <td>Delay for msg </td><td><input type="text" name="add_delay_msg" value="<?php echo $delay_msg;?>"></td><td>min</td>
                        </tr>
                        <tr>
                          <td>* <i>can be blank</i></td><td></td>
                        </tr>
                        <tr>
                          <td><input type="submit" value="Save"></td><td></td>
                        </tr>
                      </table>
                      </form>
                    </td>
                  </tr>
                </table>
              </td>
            </tr>
<?php
  js_end( "
              document.f.onsubmit = CheckForm;
              document.f.add_name.focus();
    " );

	// pripojeni paticky
  include ("php/bottom.php");

?>