<?php
/***************************************************************************/
/*                                                                         */
/*  POMOCNE FUNKCE     											                               */
/*                                                                         */
/***************************************************************************/



/***************************************************************************/
/*                                                                         */
/*  PREVOD POCTU SEKUND NA DNY, HODINY, MINUTY (UPTIME) 			             */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   - $uptime = uptime v sekundach									                       */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - vraci retezec ddd days, hh hours, mm minutes                        */
/***************************************************************************/
function UptimeToStr($uptime)
{
	$temp = $uptime;
	$days = intval($temp / 86400);
	$temp %= 86400;
	$hours = intval($temp / 3600);
	$temp %= 3600;
	$minutes = intval($temp / 60);

	return ' '.$days.' d, '.$hours.' h, '.$minutes.' m';
}


/***************************************************************************/
/*                                                                         */
/*  PREVOD PRENESTENYCH DAT S DOPLNENIM JEDNOTKY        			             */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   - $num = prenesena data v bytech 							                       */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - vraci retezec x xB                                                  */
/***************************************************************************/

function ConvertNumBytes( $num )
{
  $units = array(
    "0" => "B",
    "1" => "kB",
    "2" => "MB",
    "3" => "GB"
  );

  if( !is_numeric( $num ) )
  {
    return "#VAL#";
  }

  $i = 0;

  while( $num > 1000 )
  {
    $num /= 1000;
    $i++;
  }

  return round($num,1)." ".$units[$i];
}


/***************************************************************************/
/*                                                                         */
/*  PREVOD CISELNY KOD TYPU SITE NA RETEZEC							 			             */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   - $status = cisleny kod												                       */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - vraci retezec GPRS/EDGE/UMTS...							                       */
/***************************************************************************/

function decoding_network_status($status)
{ // prevodni funkce
  switch($status)
  { // GPRS
    case 1: return "GPRS";
    case 2: return "GPRS";
    // EDGE
    case 3: return "EDGE";
    case 4: return "EDGE";
    // UMTS
    case 5: return "UMTS";
    case 6: return "UMTS";
    // HSDPA
    case 7: return "HSDPA";
    case 8: return "HSDPA";
    // HSUPA
    case 9: return "HSUPA";
    case 10: return "HSUPA";
    // HSPA+
    case 11: return "HSPA+";
    case 12: return "HSPA+";
    // LTE
    case 13: return "LTE";
    case 14: return "LTE";
    // CDMA
    case 15: return "CDMA";
    case 16: return "CDMA";
    // EVDO
    case 18: return "EV-DO";
    // EVDO_0
    case 20: return "EV-DO Rel. 0";
    // EVDO_A
    case 22: return "EV-DO Rel. A";
    // EVDO_B
    case 24: return "EV-DO Rel. B";
    // NB_IOT
    case 26: return "NB-IoT";
    // LTE-M
    case 28: return "LTE-M";
    // LTE+NR5G
    case 30: return "LTE+NR5G";
    // NR5G
    case 32: return "NR5G";
    // unknow
    	default: return "---";
      //   default: return $status;
  }
}

/***************************************************************************/
/*                                                                         */
/*  PREVOD PRAV NA RETEZEC                							 			             */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   - $rights = cisleny kod												                       */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - vraci retezec GPRS/EDGE/UMTS...							                       */
/***************************************************************************/

function get_role_name($rights)
{ // prevodni funkce
  switch($rights)
  {
    case "0": return "Superadmin";
    case "1": return "Admin";
    default:  return "Guest";
  }
}

/***************************************************************************/
/*                                                                         */
/*  TEST ZDA JE PRIHLASEN HOST            							 			             */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   -                      												                       */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - vraci 1/0                      							                       */
/***************************************************************************/

function is_guest( )
{
  if( isset($_SESSION['logged']) && (($_SESSION['logged'] == 0) || ($_SESSION['logged'] == 1) || ($_SESSION['logged'] == 2)) )
  {
    return 1;
  }
  return 0;
}

/***************************************************************************/
/*                                                                         */
/*  TEST ZDA JE PRIHLASEN ADMIN            							 			             */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   -                      												                       */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - vraci 1/0                      							                       */
/***************************************************************************/

function is_admin( )
{
  if( isset($_SESSION['logged']) && (($_SESSION['logged'] == 0) || ($_SESSION['logged'] == 1)) )
  {
    return 1;
  }
  return 0;
}

/***************************************************************************/
/*                                                                         */
/*  TEST ZDA JE PRIHLASEN SUPERADMIN       							 			             */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   -                      												                       */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - vraci 1/0                      							                       */
/***************************************************************************/

function is_superadmin( )
{
  if( isset($_SESSION['logged']) && ($_SESSION['logged'] == 0) )
  {
    return 1;
  }
  return 0;
}

/***************************************************************************/
/*                                                                         */
/*  TEST ZDA MUZE UZIVATEL MENIT PARAMETRY ZARIZENI  		 			             */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   -                      												                       */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - vraci 1/0                      							                       */
/***************************************************************************/

function can_user_edit_device( )
{
  if( is_admin() || ($_SESSION['can_edit_device'] == 1) )
  {
    return 1;
  }
  return 0;
}

/***************************************************************************/
/*                                                                         */
/*  TEST ZDA SE UZIVATEL PRAVE PRIHLASIL   							 			             */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   -                      												                       */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - vraci 1/0                      							                       */
/***************************************************************************/

function go_from_login( )
{
  if( isset($_SESSION['from_login']) && ($_SESSION['from_login'] == 1) )
  {
    $_SESSION['from_login'] = 0;
    return 1;
  }
  return 0;
}

/***************************************************************************/
/*                                                                         */
/*  ZISKANI ID FIRMY                      							 			             */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   -                      												                       */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - vraci 1/0                      							                       */
/***************************************************************************/

function get_company_id( )
{
  if( isset($_SESSION['company_id']) )
  {
    return $_SESSION['company_id'];
  }
  else
  {
    return 0;
  }
}

/***************************************************************************/
/*                                                                         */
/*  NASTAVENI ID FIRMY                      							 			           */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   -                      												                       */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - vraci 1/0                      							                       */
/***************************************************************************/

function set_company_id( $id )
{
  $_SESSION['company_id'] = $id;
}

/***************************************************************************/
/*                                                                         */
/*  ZISKANI ID GROUPy                      							 			             */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   -                      												                       */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - vraci 1/0                      							                       */
/***************************************************************************/

function get_group_id( )
{
  if( isset($_SESSION['group_id']) )
  {
    return $_SESSION['group_id'];
  }
  else
  {
    return 0;
  }
}

/***************************************************************************/
/*                                                                         */
/*  NASTAVENI ID GROUPy                      							 			           */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   -                      												                       */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - vraci 1/0                      							                       */
/***************************************************************************/

function set_group_id( $id )
{
  $_SESSION['group_id'] = $id;
}

/***************************************************************************/
/*                                                                         */
/*  ZISKANI ID UZIVATELE                   							 			             */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   -                      												                       */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - vraci 1/0                      							                       */
/***************************************************************************/

function get_user_id( )
{
  if( isset($_SESSION['user_id']) )
  {
    return $_SESSION['user_id'];
  }
  else
  {
    return NULL;
  }
}

/***************************************************************************/
/*                                                                         */
/*  NASTAVENI ID UZIVATELE                   							 			           */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   - $id = id uzivatele    												                       */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - vraci 1/0                      							                       */
/***************************************************************************/

function set_user_id( $id )
{
  $_SESSION['user_id'] = $id;
}

/***************************************************************************/
/*                                                                         */
/*  ZISKANI HODNOTY PARAMETRU Z ADRESNIHO RADKU						 			           */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   - $str = nazev parametru												                       */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - vraci retezec nebo NULL         							                       */
/***************************************************************************/

function URI_get_string( $str )
{
  if( isset($_GET[$str]) && strlen($_GET[$str]) )
  {
    return addcslashes($_GET[$str],"\;\'\"");
  }
  else if( isset($_POST[$str]) && strlen($_POST[$str]) )
  {
    return addcslashes($_POST[$str],"\;\'\"");
  }
  else
  {
    return NULL;
  }
}

/***************************************************************************/
/*                                                                         */
/*  ZISKANI CISLA Z ADRESNIHO RADKU           						 			           */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   - $str = nazev parametru												                       */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - vraci cislo nebo NULL          							                       */
/***************************************************************************/

function URI_get_int( $str )
{
  if( isset($_GET[$str]) && is_numeric($_GET[$str]) )
  {
    return $_GET[$str];
  }
  else if( isset($_POST[$str]) && is_numeric($_POST[$str]) )
  {
    return $_POST[$str];
  }
  else
  {
    return NULL;
  }
}

/***************************************************************************/
/*                                                                         */
/*  ZISKANI HODNOTY Z INPUTu checkbox          						 			           */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   - $str = nazev parametru												                       */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - vraci cislo nebo NULL          							                       */
/***************************************************************************/

function URI_get_bool( $str )
{
  if( isset($_GET[$str]) && is_numeric($_GET[$str]) )
  {
    return 1;
  }
  else if( isset($_POST[$str]) && is_numeric($_POST[$str]) )
  {
    return 1;
  }
  else
  {
    return 0;
  }
}

/***************************************************************************/
/*                                                                         */
/*  ZISKANI CISLA Z ADRESNIHO RADKU           						 			           */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   - $str = retezec       												                       */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - vraci NULL nebo "$str"          							                       */
/***************************************************************************/

function Str4Sql( $str )
{
  return is_null( $str ) ? 'NULL' : '"'.$str.'"';
}

/***************************************************************************/
/*                                                                         */
/*  TEST MAC ADRESY                            						 			           */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   - $str = retezec       												                       */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - vraci true nebo false          							                       */
/***************************************************************************/
function is_valid_mac($mac)
{
  // 01:23:45:67:89:ab
  if (preg_match('/^([a-fA-F0-9]{2}:){5}[a-fA-F0-9]{2}$/', $mac))
    return true;
  // 01-23-45-67-89-ab
  if (preg_match('/^([a-fA-F0-9]{2}\-){5}[a-fA-F0-9]{2}$/', $mac))
    return true;
  // 0123456789ab
  else if (preg_match('/^[a-fA-F0-9]{12}$/', $mac))
    return true;
  // 0123.4567.89ab
  else if (preg_match('/^([a-fA-F0-9]{4}\.){2}[a-fA-F0-9]{4}$/', $mac))
    return true;
  else
    return false;
}

/***************************************************************************/
/*                                                                         */
/*  PREVOD MAC NA TVAR DE:AD:BE:EF:10:24       						 			           */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   - $str = retezec       												                       */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - vraci true nebo false          							                       */
/***************************************************************************/

function normalize_mac($mac)
{
  // remove any dots
  $mac =  str_replace(".", "", $mac);

  // replace dashes with colons
  $mac =  str_replace("-", ":", $mac);

  // counting colons
  $colon_count = substr_count ($mac , ":");

  // insert enough colons if none exist
  if ($colon_count == 0)
  {
    $mac =  substr_replace($mac, ":", 2, 0);
    $mac =  substr_replace($mac, ":", 5, 0);
    $mac =  substr_replace($mac, ":", 8, 0);
    $mac =  substr_replace($mac, ":", 11, 0);
    $mac =  substr_replace($mac, ":", 14, 0);
  }

  // uppercase
  $mac = strtoupper($mac);

  // DE:AD:BE:EF:10:24
  return $mac;
}

/***************************************************************************/
/*                                                                         */
/*  KONTROLA EMAILOVE ADRESY                  						 			           */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   - $e = retezec         												                       */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - vraci true nebo false          							                       */
/***************************************************************************/
function validate_email($e){
    return (bool)preg_match("`^[a-z0-9!#$%&'*+\/=?^_\`{|}~-]+(?:\.[a-z0-9!#$%&'*+\/=?^_\`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$`i", trim($e));
}

/***************************************************************************/
/*                                                                         */
/*  PREVOD SNMP Authentication NA RETEZEC                							 			             */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   - $auth_code = cisleny kod												                       */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - vraci retezec GPRS/EDGE/UMTS...							                       */
/***************************************************************************/

function snmp_auth_to_string($auth_code)
{ // prevodni funkce
  switch($auth_code)
  {
    case 1: return "MD5";
    case 2: return "SHA1";
	case 0:
    default:  return "None";
  }
}
/***************************************************************************/
/*                                                                         */
/*  PREVOD SNMP Privacy NA RETEZEC                							 			             */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   - $privacy_code = cisleny kod												                       */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - vraci retezec GPRS/EDGE/UMTS...							                       */
/***************************************************************************/

function snmp_privacy_to_string($privacy_code)
{ // prevodni funkce
  switch($privacy_code)
  {
    case 1: return "DES";
    case 2: return "AES";
	case 0:
    default:  return "None";
  }
}

/***************************************************************************/
/*                                                                         */
/*  OCHRANA PRED SQL INJECTION - libovolny text                            */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   - $text = puvodni vstup, promenna $_GET[..]                           */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - retezec zbaveny vsech znaku, ktere by mohly byt znmeuzity           */
/***************************************************************************/

function sanitize_text($text = '')
{
  // zachova alfanumericke znaky a vybrane specialni znaky
  return preg_replace('/[^a-zA-Z0-9_\.,; \-+&@#():]/','',urldecode($text));
}

/***************************************************************************/
/*                                                                         */
/*  OCHRANA PRED SQL INJECTION - prirozene cislo                           */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   - $number = puvodni vstup, promenna $_GET[..]                         */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - retezec zbaveny vsech neciselnych znaku                             */
/***************************************************************************/

function sanitize_number($number = '')
{
  // zachova alfanumericke znaky 
  return preg_replace('/[^0-9]/','',urldecode($number));
}


/***************************************************************************/
/*                                                                         */
/*  OCHRANA PRED SQL INJECTION - textovy identifikator                     */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*   - $identifier = puvodni vstup, promenna $_GET[..]                     */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - retezec zbaveny vsech neciselnych znaku                             */
/***************************************************************************/

function sanitize_identifier($identifier = '')
{
  // zachova alfanumericke znaky a podrtrzitko 
  return preg_replace('/[^a-zA-Z0-9_]/','',urldecode($identifier));
}


?>
