<?php

/***************************************************************************/
/*                                                                         */
/*  FUNKCE PRO PRACI S DB 									                               */
/*                                                                         */
/***************************************************************************/


/***************************************************************************/
/*                                                                         */
/*  PRIPOJENI K DATABAZI																 			             */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*                                                                         */
/*  VYSTUP:                                                                */
/*   - spojeni																		                         */
/***************************************************************************/

function db_connect()
{
	$link = mysqli_connect(DB_HOST,DB_USER,DB_PASS,DB_NAME);	
	
	if (mysqli_connect_errno()) {
		printf("Connect failed: %s\n", mysqli_connect_error());
		exit();
	}

	mysqli_query($link, "SET CHARACTER SET utf8");

	return $link;
}


/***************************************************************************/
/*                                                                         */
/*  VYKONANI SQL PRIKAZU																 			             */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*                                                                         */
/*   - $link - otevrene spojeni s DB							                         */
/*   - $sql	 - SQL dotaz													                         */
/*            																		                         */
/*  VYSTUP:                                                                */
/*   - data z SQL serveru													                         */
/***************************************************************************/

function db_query($link, $sql)
{

	if(($result = mysqli_query($link,$sql)) === false)
	{	// vykonani prikazu se nezdarilo
		echo "DB Error, could not query the database\n";
    echo 'MySQL Error: ' . mysqli_error($link);
    echo 'MySQL Request' . $sql;
		exit;
	}
	// vrat data
	return $result;
}

/***************************************************************************/
/*                                                                         */
/*  VYKONANI OPAKOVANEHO SQL PRIKAZU																 			 */
/*                                                                         */
/*                                                                         */
/*  VSTUP:                                                                 */
/*                                                                         */
/*   - $link - otevrene spojeni s DB							                         */
/*   - $sql	 - SQL dotaz													                         */
/*            																		                         */
/*  VYSTUP:                                                                */
/*   - data z SQL serveru													                         */
/***************************************************************************/

function db_multi_query($link, $sql)
{

	if(!mysqli_multi_query($link,$sql))
	{	// vykonani prikazu se nezdarilo
		echo "DB Error, could not query the database\n";
		echo 'MySQL Error: ' . mysqli_error($link);
		exit;
	}
	// vrat data
	return mysqli_store_result($link);
}


?>
