<?php
	// ulozene procedury MySQL

	require_once "php/mysql.php";

  header('Refresh: 2; URL = index.php');

	// pripojeni k DB
	$link = db_connect();

	$sql	= 	'DROP PROCEDURE IF EXISTS sp_GetServiceChange';
	$result = db_query($link, $sql);

	$sql	= 'CREATE PROCEDURE sp_GetServiceChange(device int(10), start_time datetime, stop_time datetime, sim int(1), get_status int(3))
					 BEGIN

						SET @temp_service = 0;

            DROP TABLE IF EXISTS service_list;
						CREATE TEMPORARY TABLE service_list engine=MEMORY SELECT @temp_service := status, status
            FROM `'.DB_NAME.'`.stats
            WHERE !(status is null) AND @temp_service != status AND device_id = device AND time >= start_time AND time < stop_time AND alt = sim;

            SELECT count(*) FROM service_list
            WHERE status = get_status;

					END';

	$result = db_query($link, $sql);

	$sql	= 	'DROP PROCEDURE IF EXISTS sp_GetDevAvail';
	$result = db_query($link, $sql);

	$sql = 'CREATE PROCEDURE sp_GetDevAvail(start_time int(10), stop_time int(10), device int(10))
						BEGIN

						DECLARE conn INT(10);
						DECLARE disconn INT(10);
						DECLARE i INT(10);
						DECLARE step_time INT(10);
            DECLARE temp_time INT(10);
            DECLARE temp_avail FLOAT;
						DECLARE temp_diff INT(10);
						DECLARE diff_type INT(3);

						DECLARE done BIT(1) DEFAULT 0;

            DECLARE valid_count_pos CURSOR FOR
              SELECT UNIX_TIMESTAMP(DATE_FORMAT(time,"%Y-%m-%d %H")),(SIGN(COUNT(*)) * 100) FROM stats
							WHERE device_id = device AND time BETWEEN FROM_UNIXTIME(start_time) AND FROM_UNIXTIME(stop_time)
              GROUP BY DATE_FORMAT(time,"%Y-%m-%d %H");

            DECLARE hour_avail_pos CURSOR FOR
							SELECT connect, disconnect, if((connect DIV 3600) = (disconnect DIV 3600),1,0) FROM `'.DB_NAME.'`.stats
							WHERE device_id = device AND !(disconnect is null) AND disconnect != 0 AND((connect BETWEEN start_time AND stop_time) or (disconnect BETWEEN start_time AND stop_time))
							GROUP BY connect,disconnect;

						DECLARE avail_pos CURSOR FOR
							SELECT (tab_conn DIV 3600) * 3600, SUM(tab_diff) FROM rec_list GROUP BY (tab_conn DIV 3600);


						DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;

						DROP TABLE IF EXISTS rec_list;

						CREATE TEMPORARY TABLE rec_list
						(
							tab_conn INT(10),
							tab_disconn INT(10),
							tab_diff INT(10)
						)ENGINE = MEMORY;

						DROP TABLE IF EXISTS avail_list;
						CREATE TEMPORARY TABLE avail_list
						(
							tab_time INT(10),
							tab_avail float
						)ENGINE = MEMORY;

            SET i = CEIL((stop_time - start_time) / 3600);
            SET step_time = start_time;

            WHILE i > 0 DO
                INSERT INTO avail_list (tab_time, tab_avail) VALUES (step_time,NULL);
                SET step_time = step_time + 3600;
                SET i = i - 1;
            END WHILE;

            OPEN valid_count_pos;

            get_valid_loop: LOOP
            FETCH valid_count_pos INTO temp_time, temp_avail;
							IF done THEN LEAVE get_valid_loop; END IF;
              UPDATE avail_list SET tab_avail = temp_avail WHERE tab_time = temp_time;
            END LOOP get_valid_loop;

            CLOSE valid_count_pos;

            SET done = 0;

						OPEN hour_avail_pos;

						get_rec_loop: LOOP
							FETCH hour_avail_pos INTO conn, disconn, diff_type;
							IF done THEN LEAVE get_rec_loop; END IF;
							IF diff_type = 1 THEN
								INSERT INTO rec_list (tab_conn,tab_disconn,tab_diff) VALUES (conn, disconn, (conn - disconn));
							ELSE
								SET temp_time = (conn DIV 3600) * 3600 - 1;
								INSERT INTO rec_list (tab_conn,tab_disconn,tab_diff) VALUES (conn, temp_time, (conn - temp_time));
								WHILE (temp_time - disconn) > 3600 DO
									INSERT INTO rec_list (tab_conn,tab_disconn,tab_diff) VALUES (temp_time, (temp_time - 3600), 3600);
									SET temp_time = temp_time - 3600;
								END WHILE;
								IF((temp_time - disconn) > 0) THEN
									INSERT INTO rec_list (tab_conn,tab_disconn,tab_diff) VALUES (temp_time, disconn, (temp_time - disconn));
								END IF;
							END IF;
						END LOOP get_rec_loop;

						CLOSE hour_avail_pos;

						SET done = 0;

						OPEN avail_pos;

						get_avail_loop: LOOP
							FETCH avail_pos INTO temp_time, temp_diff;
							IF done THEN LEAVE get_avail_loop; END IF;
                UPDATE avail_list SET tab_avail = (((3600 - temp_diff)/3600)*100) WHERE tab_time = temp_time;
						END LOOP get_avail_loop;
						CLOSE avail_pos;

						SELECT AVG(tab_avail) FROM avail_list;

					END;';

	$result = db_query($link, $sql);

	$sql	= 	'DROP FUNCTION IF EXISTS sp_GetDevPLoss';
	$result = db_query($link, $sql);


  $sql = 	'CREATE FUNCTION `sp_GetDevPLoss`(device int(10), start_time datetime, stop_time datetime) RETURNS FLOAT
          DETERMINISTIC
					BEGIN



						DECLARE count_valid int(10);

						DECLARE count_fail int(10);


						SET count_valid = (SELECT COUNT(*) FROM stats WHERE device_id = device AND time BETWEEN start_time AND stop_time);

						SET count_fail = (SELECT COUNT(*) FROM fails WHERE device_id = device AND time BETWEEN start_time AND stop_time);


            IF (count_valid is null) && (count_fail is null) THEN
                RETURN NULL;
            ELSE
                RETURN ((count_fail / (count_fail + count_valid)) * 100);
            END IF;

					END;';

	$result = db_query($link, $sql);

	$sql	= 	'DROP PROCEDURE IF EXISTS sp_GetHourListAvail';
	$result = db_query($link, $sql);


	$sql = 'CREATE PROCEDURE `sp_GetHourListAvail`(start_time int(10), stop_time int(10))
						BEGIN

    DECLARE conn INT(10);
    DECLARE disconn INT(10);
    DECLARE dev_count INT(10);
    DECLARE temp_time INT(10);
    DECLARE temp_diff INT(10);
    DECLARE diff_type INT(3);

    DECLARE done BIT(1) DEFAULT 0;
    DECLARE hour_avail_pos CURSOR FOR
        SELECT connect, disconnect, if((connect DIV 3600) = (disconnect DIV 3600),1,0) FROM temp_stats
        WHERE !(disconnect is null) AND disconnect != 0 AND((connect BETWEEN start_time AND stop_time) or (disconnect BETWEEN start_time AND stop_time))
        GROUP BY connect,disconnect;

    DECLARE avail_pos CURSOR FOR
        SELECT (tab_conn DIV 3600) * 3600, SUM(tab_diff) FROM rec_list GROUP BY (tab_conn DIV 3600);


    DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;


    DROP TABLE IF EXISTS rec_list;
    CREATE TEMPORARY TABLE rec_list
    (
        tab_conn INT(10),
        tab_disconn INT(10),
        tab_diff INT(10)
    )ENGINE = MEMORY;

    DROP TABLE IF EXISTS avail_list;
    CREATE TEMPORARY TABLE avail_list
    (
        tab_time INT(10),
        tab_avail float
    )ENGINE = MEMORY;


    OPEN hour_avail_pos;

    get_rec_loop: LOOP

        FETCH hour_avail_pos INTO conn, disconn, diff_type;
        IF done THEN LEAVE get_rec_loop; END IF;
        IF diff_type = 1 THEN
            INSERT INTO rec_list (tab_conn,tab_disconn,tab_diff) VALUES (conn, disconn, (conn - disconn));
        ELSE
            SET temp_time = (conn DIV 3600) * 3600 - 1;
            INSERT INTO rec_list (tab_conn,tab_disconn,tab_diff) VALUES (conn, temp_time, (conn - temp_time));
            WHILE (temp_time - disconn) > 3600 DO
                INSERT INTO rec_list (tab_conn,tab_disconn,tab_diff) VALUES (temp_time, (temp_time - 3600), 3600);
                SET temp_time = temp_time - 3600;
            END WHILE;
            IF((temp_time - disconn) > 0) THEN
                INSERT INTO rec_list (tab_conn,tab_disconn,tab_diff) VALUES (temp_time, disconn, (temp_time - disconn));
            END IF;

        END IF;
    END LOOP get_rec_loop;

    CLOSE hour_avail_pos;

    SET done = 0;

    OPEN avail_pos;

    get_avail_loop: LOOP

        FETCH avail_pos INTO temp_time, temp_diff;
        IF done THEN LEAVE get_avail_loop; END IF;
        SET dev_count = (SELECT COUNT(*) FROM temp_selection);
        INSERT INTO avail_list (tab_time, tab_avail) VALUES (temp_time, (((3600 * dev_count) - temp_diff)/(3600 * dev_count))*100);

    END LOOP get_avail_loop;
    CLOSE avail_pos;

    SELECT * FROM avail_list;

		END;';

	$result = db_query($link, $sql);


	$sql	= 	'DROP PROCEDURE IF EXISTS sp_GetDevHourListAvail';
	$result = db_query($link, $sql);

	$sql	= 'CREATE PROCEDURE `sp_GetDevHourListAvail`(start_time int(10), stop_time int(10), device int(10))
					BEGIN
						DECLARE conn INT(10);
						DECLARE disconn INT(10);
						DECLARE temp_time INT(10);
						DECLARE temp_diff INT(10);
						DECLARE diff_type INT(3);

						DECLARE done BIT(1) DEFAULT 0;
						DECLARE hour_avail_pos CURSOR FOR
							SELECT connect, disconnect, if((connect DIV 3600) = (disconnect DIV 3600),1,0) FROM `'.DB_NAME.'`.stats
							WHERE device_id = device AND !(disconnect is null) AND disconnect != 0 AND((connect BETWEEN start_time AND stop_time) or (disconnect BETWEEN start_time AND stop_time))
							GROUP BY connect,disconnect;

						DECLARE avail_pos CURSOR FOR
							SELECT (tab_conn DIV 3600) * 3600, SUM(tab_diff) FROM rec_list GROUP BY (tab_conn DIV 3600);

						DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;

						DROP TABLE IF EXISTS rec_list;

						CREATE TEMPORARY TABLE rec_list
						(
							tab_conn INT(10),
							tab_disconn INT(10),
							tab_diff INT(10)
						)ENGINE = MEMORY;

						DROP TABLE IF EXISTS avail_list;
						CREATE TEMPORARY TABLE avail_list
						(
							tab_time INT(10),
							tab_avail float
						)ENGINE = MEMORY;

						OPEN hour_avail_pos;

						get_rec_loop: LOOP
							FETCH hour_avail_pos INTO conn, disconn, diff_type;
							IF done THEN LEAVE get_rec_loop; END IF;
							IF diff_type = 1 THEN
								INSERT INTO rec_list (tab_conn,tab_disconn,tab_diff) VALUES (conn, disconn, (conn - disconn));
							ELSE
								SET temp_time = (conn DIV 3600) * 3600 - 1;
								INSERT INTO rec_list (tab_conn,tab_disconn,tab_diff) VALUES (conn, temp_time, (conn - temp_time));
								WHILE (temp_time - disconn) > 3600 DO
									INSERT INTO rec_list (tab_conn,tab_disconn,tab_diff) VALUES (temp_time, (temp_time - 3600), 3600);
									SET temp_time = temp_time - 3600;
								END WHILE;
								IF((temp_time - disconn) > 0) THEN
									INSERT INTO rec_list (tab_conn,tab_disconn,tab_diff) VALUES (temp_time, disconn, (temp_time - disconn));
								END IF;
							END IF;
						END LOOP get_rec_loop;

						CLOSE hour_avail_pos;

						SET done = 0;

						OPEN avail_pos;

						get_avail_loop: LOOP
							FETCH avail_pos INTO temp_time, temp_diff;
							IF done THEN LEAVE get_avail_loop; END IF;
								INSERT INTO avail_list (tab_time, tab_avail) VALUES (temp_time, ((3600 - temp_diff)/3600)*100);
						END LOOP get_avail_loop;
						CLOSE avail_pos;

						SELECT * FROM avail_list;

					END';

	$result = db_query($link, $sql);

	$sql	= 	'DROP PROCEDURE IF EXISTS sp_GetDevDayListPLoss';
	$result = db_query($link, $sql);

	$sql	= 'CREATE PROCEDURE `sp_GetDevDayListPLoss`(start_time int(10), stop_time int(10), device int(10))
					BEGIN

						DECLARE count int(10);
						DECLARE i int(10);
						DECLARE done bit(1) DEFAULT 0;
						DECLARE temp_date int(10);

						DECLARE valid_pos CURSOR FOR
							SELECT UNIX_TIMESTAMP(DATE_FORMAT(time,"%Y-%m-%d %H")), COUNT(*) FROM stats WHERE device_id = device AND time BETWEEN FROM_UNIXTIME(start_time) AND FROM_UNIXTIME(stop_time) GROUP BY DATE_FORMAT(time,"%Y-%m-%d %H");

						DECLARE fail_pos CURSOR FOR
							SELECT UNIX_TIMESTAMP(DATE_FORMAT(time,"%Y-%m-%d %H")), COUNT(*) FROM fails WHERE device_id = device AND time BETWEEN FROM_UNIXTIME(start_time) AND FROM_UNIXTIME(stop_time) GROUP BY DATE_FORMAT(time,"%Y-%m-%d %H");

						DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;


						DROP TABLE IF EXISTS rec_list;
						CREATE TEMPORARY TABLE rec_list
						(
							den int(10) NOT NULL,
							valid int(10) DEFAULT 0,
							fail int(10) DEFAULT 0
						)ENGINE = MEMORY;

						SET count = CEIL((stop_time - start_time) / 3600);

						SET i = 0;

						WHILE i < count DO
							INSERT INTO rec_list (den) VALUES (start_time + (i*3600));
							SET i = i + 1;
						END WHILE;


						OPEN valid_pos;
						get_valid_loop: LOOP
							FETCH valid_pos INTO temp_date, count;
								IF done THEN LEAVE get_valid_loop; END IF;
								UPDATE rec_list SET valid = count WHERE den BETWEEN temp_date - 60 AND temp_date + 60;
						END LOOP get_valid_loop;
						CLOSE valid_pos;

						SET done = 0;

						OPEN fail_pos;
						get_fail_loop: LOOP
							FETCH fail_pos INTO temp_date, count;
								IF done THEN LEAVE get_fail_loop; END IF;
								UPDATE rec_list SET fail = count WHERE den BETWEEN temp_date - 60 AND temp_date + 60;
						END LOOP get_fail_loop;
						CLOSE fail_pos;

						SELECT den, IF(valid + fail > 0,(fail/(valid + fail)) * 100,NULL) FROM rec_list;

					END';

	$result = db_query($link, $sql);


    $sql	= 	'DROP PROCEDURE IF EXISTS sp_GetDevDayListPLoss2';
	$result = db_query($link, $sql);

	$sql	= 'CREATE PROCEDURE `sp_GetDevDayListPLoss2`(start_time int(10), stop_time int(10), device int(10))
					BEGIN

						DECLARE count int(10);
						DECLARE i int(10);
						DECLARE done bit(1) DEFAULT 0;
						DECLARE temp_date int(10);

						DECLARE valid_pos CURSOR FOR
							SELECT UNIX_TIMESTAMP(DATE_FORMAT(time,"%Y-%m-%d %H")), COUNT(*) FROM stats WHERE device_id = device AND time BETWEEN FROM_UNIXTIME(start_time) AND FROM_UNIXTIME(stop_time) GROUP BY DATE_FORMAT(time,"%Y-%m-%d %H");

						DECLARE fail_pos CURSOR FOR
							SELECT UNIX_TIMESTAMP(DATE_FORMAT(time,"%Y-%m-%d %H")), COUNT(*) FROM fails WHERE device_id = device AND time BETWEEN FROM_UNIXTIME(start_time) AND FROM_UNIXTIME(stop_time) GROUP BY DATE_FORMAT(time,"%Y-%m-%d %H");

						DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;


						DROP TABLE IF EXISTS rec_list;
						CREATE TEMPORARY TABLE rec_list
						(
							den int(10) NOT NULL,
							valid int(10) DEFAULT 0,
							fail int(10) DEFAULT 0
						)ENGINE = MEMORY;

						SET count = CEIL((stop_time - start_time) / 900);

						SET i = 0;

						WHILE i < count DO
							INSERT INTO rec_list (den) VALUES (start_time + (i*900));
							SET i = i + 1;
						END WHILE;


						OPEN valid_pos;
						get_valid_loop: LOOP
							FETCH valid_pos INTO temp_date, count;
								IF done THEN LEAVE get_valid_loop; END IF;
								UPDATE rec_list SET valid = count WHERE den BETWEEN temp_date - 60 AND temp_date + 60;
						END LOOP get_valid_loop;
						CLOSE valid_pos;

						SET done = 0;

						OPEN fail_pos;
						get_fail_loop: LOOP
							FETCH fail_pos INTO temp_date, count;
								IF done THEN LEAVE get_fail_loop; END IF;
								UPDATE rec_list SET fail = count WHERE den BETWEEN temp_date - 60 AND temp_date + 60;
						END LOOP get_fail_loop;
						CLOSE fail_pos;

						SELECT den, IF(valid + fail > 0,(fail/(valid + fail)) * 100,NULL) FROM rec_list;

					END';

	$result = db_query($link, $sql);




  $sql	= 	'DROP PROCEDURE IF EXISTS sp_GetDayListPLoss';
	$result = db_query($link, $sql);

	$sql	= 'CREATE PROCEDURE `sp_GetDayListPLoss`(start_time int(10), stop_time int(10))
					BEGIN

						DECLARE count int(10);
						DECLARE i int(10);
						DECLARE done bit(1) DEFAULT 0;
						DECLARE temp_date int(10);

						DECLARE valid_pos CURSOR FOR
              SELECT UNIX_TIMESTAMP(DATE_FORMAT(time,"%Y-%m-%d %H")), COUNT(*)
              FROM stats
              WHERE device_id IN (SELECT device_id FROM report_src)
              AND time BETWEEN FROM_UNIXTIME(start_time) AND FROM_UNIXTIME(stop_time) GROUP BY DATE_FORMAT(time,"%Y-%m-%d %H");

						DECLARE fail_pos CURSOR FOR
              SELECT UNIX_TIMESTAMP(DATE_FORMAT(time,"%Y-%m-%d %H")), COUNT(*)
              FROM fails
              WHERE device_id IN (SELECT device_id FROM report_src)
              AND time BETWEEN FROM_UNIXTIME(start_time) AND FROM_UNIXTIME(stop_time) GROUP BY DATE_FORMAT(time,"%Y-%m-%d %H");

						DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;


						DROP TABLE IF EXISTS rec_list;
						CREATE TEMPORARY TABLE rec_list
						(
							den int(10) NOT NULL,
							valid int(10) DEFAULT 0,
							fail int(10) DEFAULT 0
						)ENGINE = MEMORY;

						SET count = CEIL((stop_time - start_time) / 3600);

						SET i = 0;

						WHILE i < count DO
							INSERT INTO rec_list (den) VALUES (start_time + (i*3600));
							SET i = i + 1;
						END WHILE;


						OPEN valid_pos;
						get_valid_loop: LOOP
							FETCH valid_pos INTO temp_date, count;
								IF done THEN LEAVE get_valid_loop; END IF;
								UPDATE rec_list SET valid = count WHERE den BETWEEN temp_date - 60 AND temp_date + 60;
						END LOOP get_valid_loop;
						CLOSE valid_pos;

						SET done = 0;

						OPEN fail_pos;
						get_fail_loop: LOOP
							FETCH fail_pos INTO temp_date, count;
								IF done THEN LEAVE get_fail_loop; END IF;
								UPDATE rec_list SET fail = count WHERE den BETWEEN temp_date - 60 AND temp_date + 60;
						END LOOP get_fail_loop;
						CLOSE fail_pos;

						SELECT den, IF(valid + fail > 0,(fail/(valid + fail)) * 100,NULL) FROM rec_list;

					END';

	$result = db_query($link, $sql);


  $sql = 'DROP PROCEDURE IF EXISTS sp_GetDevicesAll';
  $result = db_query($link, $sql);

	$sql	= 'CREATE PROCEDURE sp_GetDevicesAll(params VARCHAR(255))
					BEGIN

						SET @dev_num = 0;

						DROP TABLE IF EXISTS device_list;
            CREATE TEMPORARY TABLE device_list ENGINE=MEMORY SELECT
              @dev_num := @dev_num + 1 as dev_num,



    devices.device_id,
	devices.group_id,
	devices.enabled,
	devices.hostname,
	devices.hostname_alt,
	devices.hostname_alt2,
	devices.community,
	devices.description,
	devices.location,
	devices.coordinates,
	devices.note,
	devices.name,
	devices.product,
	devices.firmware,
	devices.mac,
	devices.sn,
	devices.imei,
	devices.esn,
	devices.last_rx,
	devices.last_tx,
	devices.last_rx2,
	devices.last_tx2,
	devices.last_rx3,
	devices.last_tx3,
	devices.accounting_start,
	devices.accounting_start_alt,
	devices.accounting_start_alt2,
	devices.rx_account,
	devices.tx_account,
	devices.rx_account_alt,
	devices.tx_account_alt,
	devices.rx_account_alt2,
	devices.tx_account_alt2,
	devices.last_connect,
	devices.last_connect2,
	devices.last_connect3,
	devices.cfg_update_time,
	devices.last_status,
	devices.last_level,
	devices.last_quality,
	devices.last_temp,
	devices.last_volt,
	devices.autoupdate,


    IF(devices.health =0,0,IF(devices.health > 0 && (devices.health < max_fails) ,1,2)) as health,
    IF(devices.health_alt =0,0,IF(devices.health_alt > 0 && (devices.health_alt < max_fails) ,1,2)) as health_alt,
    IF(devices.health_alt2 =0,0,IF(devices.health_alt2 > 0 && (devices.health_alt2 < max_fails) ,1,2)) as health_alt2,

	devices.last_time_act,
	devices.last_time_act_alt,
	devices.last_time_act_alt2,
	devices.phone,
	devices.phone_alt,
	devices.period,
	devices.trap,
	devices.read_location,
	devices.read_gps,
	devices.new,
	devices.new_time,
	devices.uptime,
	devices.read_temp_volt,
	devices.num_send_avail,
	devices.num_fails_msg,



              tx_account + rx_account as total,
              tx_account_alt + rx_account_alt as total_alt,
              tx_account_alt2 + rx_account_alt2 as total_alt2,
              groups.description as group_desc,
              companies.name as comp_name,
              groups.level_limit as level_limit,
              groups.traffic_limit as traffic_limit,
              groups.traffic_limit_alt as traffic_limit_alt,
              groups.traffic_limit_alt2 as traffic_limit_alt2,
              groups.temp_limit_lo as temp_limit_lo,
              groups.temp_limit_hi as temp_limit_hi,
              groups.volt_limit_lo as volt_limit_lo,
              groups.volt_limit_hi as volt_limit_hi,
              groups.qual_limit_lo as qual_limit_lo,
              groups.max_fails as max_fails,
			  devices.snmp_prot
            FROM devices LEFT JOIN groups ON devices.group_id = groups.group_id LEFT JOIN companies ON companies.company_id = groups.company_id ORDER BY device_id;

            SET @sql = CONCAT(\'SELECT
              dev_num,
              device_id,
              description,
              hostname,
              hostname_alt,
              hostname_alt2,
              location,
              coordinates,
              note,
              enabled,
              product,
              firmware,
              sn,
              imei,
              esn,
              tx_account,
              rx_account,
              total,
              tx_account_alt,
              rx_account_alt,
              total_alt,
              tx_account_alt2,
              rx_account_alt2,
              total_alt2,
              last_level,
              last_status,
              autoupdate,
              health,
              health_alt,
              health_alt2,
              DATE_FORMAT(last_time_act,"%d-%m-%Y %H:%i"),
              DATE_FORMAT(last_time_act_alt,"%d-%m-%Y %H:%i"),
              DATE_FORMAT(last_time_act_alt2,"%d-%m-%Y %H:%i"),
              trap,
              mac,
              group_desc,
              comp_name,
              uptime,
              new,
              last_quality,
              last_temp,
              last_volt,
              level_limit,
              traffic_limit,
              traffic_limit_alt,
              traffic_limit_alt2,
              temp_limit_lo,
              temp_limit_hi,
              volt_limit_lo,
              volt_limit_hi,
              qual_limit_lo,
              name,
              max_fails,
			  snmp_prot
            FROM device_list WHERE ""="" \',params) ;

						PREPARE stmt FROM @sql;

						EXECUTE stmt;

						DEALLOCATE PREPARE stmt;

					END';

  $result = db_query($link, $sql);

  $sql = 'DROP PROCEDURE IF EXISTS sp_GetDevicesCompany';
  $result = db_query($link, $sql);

	$sql	= 'CREATE PROCEDURE sp_GetDevicesCompany(params VARCHAR(255), id INT(5))
					BEGIN

						SET @dev_num = 0;

						DROP TABLE IF EXISTS device_list;
            CREATE TEMPORARY TABLE device_list ENGINE=MEMORY SELECT
              @dev_num := @dev_num + 1 as dev_num,

              devices.device_id,
	devices.group_id,
	devices.enabled,
	devices.hostname,
	devices.hostname_alt,
	devices.hostname_alt2,
	devices.community,
	devices.description,
	devices.location,
	devices.coordinates,
	devices.note,
	devices.name,
	devices.product,
	devices.firmware,
	devices.mac,
	devices.sn,
	devices.imei,
	devices.esn,
	devices.last_rx,
	devices.last_tx,
	devices.last_rx2,
	devices.last_tx2,
	devices.last_rx3,
	devices.last_tx3,
	devices.accounting_start,
	devices.accounting_start_alt,
	devices.accounting_start_alt2,
	devices.rx_account,
	devices.tx_account,
	devices.rx_account_alt,
	devices.tx_account_alt,
	devices.rx_account_alt2,
	devices.tx_account_alt2,
	devices.last_connect,
	devices.last_connect2,
	devices.last_connect3,
	devices.cfg_update_time,
	devices.last_status,
	devices.last_level,
	devices.last_quality,
	devices.last_temp,
	devices.last_volt,
	devices.autoupdate,


    IF(devices.health =0,0,IF(devices.health > 0 && (devices.health < max_fails) ,1,2)) as health,
    IF(devices.health_alt =0,0,IF(devices.health_alt > 0 && (devices.health_alt < max_fails) ,1,2)) as health_alt,
    IF(devices.health_alt2 =0,0,IF(devices.health_alt2 > 0 && (devices.health_alt2 < max_fails) ,1,2)) as health_alt2,

	devices.last_time_act,
	devices.last_time_act_alt,
	devices.last_time_act_alt2,
	devices.phone,
	devices.phone_alt,
	devices.period,
	devices.trap,
	devices.read_location,
	devices.read_gps,
	devices.new,
	devices.new_time,
	devices.uptime,
	devices.read_temp_volt,
	devices.num_send_avail,
	devices.num_fails_msg,




              tx_account + rx_account as total,
              tx_account_alt + rx_account_alt as total_alt,
              tx_account_alt2 + rx_account_alt2 as total_alt2,
              groups.description as group_desc,
              groups.level_limit as level_limit,
              groups.traffic_limit as traffic_limit,
              groups.traffic_limit_alt as traffic_limit_alt,
              groups.traffic_limit_alt2 as traffic_limit_alt2,
              groups.temp_limit_lo as temp_limit_lo,
              groups.temp_limit_hi as temp_limit_hi,
              groups.volt_limit_lo as volt_limit_lo,
              groups.volt_limit_hi as volt_limit_hi,
              groups.qual_limit_lo as qual_limit_lo,
              groups.max_fails as max_fails,
			  devices.snmp_prot
            FROM devices, groups WHERE devices.group_id IN (SELECT groups.group_id FROM groups WHERE groups.company_id = id) AND devices.group_id = groups.group_id ORDER BY device_id;

            SET @sql = CONCAT(\'SELECT
              dev_num,
              device_id,
              description,
              hostname,
              hostname_alt,
              hostname_alt2,
              location,
              coordinates,
              note,
              enabled,
              product,
              firmware,
              sn,
              imei,
              esn,
              tx_account,
              rx_account,
              total,
              tx_account_alt,
              rx_account_alt,
              total_alt,
              tx_account_alt2,
              rx_account_alt2,
              total_alt2,
              last_level,
              last_status,
              autoupdate,
              health,
              health_alt,
              health_alt2,
              DATE_FORMAT(last_time_act,"%d-%m-%Y %H:%i"),
              DATE_FORMAT(last_time_act_alt,"%d-%m-%Y %H:%i"),
              DATE_FORMAT(last_time_act_alt2,"%d-%m-%Y %H:%i"),
              trap,
              mac,
              group_desc,
              NULL,
              uptime,
              new,
              last_quality,
              last_temp,
              last_volt,
              level_limit,
              traffic_limit,
              traffic_limit_alt,
              traffic_limit_alt2,
              temp_limit_lo,
              temp_limit_hi,
              volt_limit_lo,
              volt_limit_hi,
              qual_limit_lo,
              name,
              max_fails,
			  snmp_prot
            FROM device_list WHERE ""="" \',params) ;

						PREPARE stmt FROM @sql;

						EXECUTE stmt;

						DEALLOCATE PREPARE stmt;

					END';

  $result = db_query($link, $sql);

  $sql = 'DROP PROCEDURE IF EXISTS sp_GetDevicesUser';
  $result = db_query($link, $sql);

	$sql	= 'CREATE PROCEDURE sp_GetDevicesUser(params VARCHAR(255), id INT(5))
					BEGIN

						SET @dev_num = 0;

						DROP TABLE IF EXISTS device_list;
            CREATE TEMPORARY TABLE device_list ENGINE=MEMORY SELECT
              @dev_num := @dev_num + 1 as dev_num,


    devices.device_id,
	devices.group_id,
	devices.enabled,
	devices.hostname,
	devices.hostname_alt,
	devices.hostname_alt2,
	devices.community,
	devices.description,
	devices.location,
	devices.coordinates,
	devices.note,
	devices.name,
	devices.product,
	devices.firmware,
	devices.mac,
	devices.sn,
	devices.imei,
	devices.esn,
	devices.last_rx,
	devices.last_tx,
	devices.last_rx2,
	devices.last_tx2,
	devices.last_rx3,
	devices.last_tx3,
	devices.accounting_start,
	devices.accounting_start_alt,
	devices.accounting_start_alt2,
	devices.rx_account,
	devices.tx_account,
	devices.rx_account_alt,
	devices.tx_account_alt,
	devices.rx_account_alt2,
	devices.tx_account_alt2,
	devices.last_connect,
	devices.last_connect2,
	devices.last_connect3,
	devices.cfg_update_time,
	devices.last_status,
	devices.last_level,
	devices.last_quality,
	devices.last_temp,
	devices.last_volt,
	devices.autoupdate,


    IF(devices.health =0,0,IF(devices.health > 0 && (devices.health < max_fails) ,1,2)) as health,
    IF(devices.health_alt =0,0,IF(devices.health_alt > 0 && (devices.health_alt < max_fails) ,1,2)) as health_alt,
    IF(devices.health_alt2 =0,0,IF(devices.health_alt2 > 0 && (devices.health_alt2 < max_fails) ,1,2)) as health_alt2,

	devices.last_time_act,
	devices.last_time_act_alt,
	devices.last_time_act_alt2,
	devices.phone,
	devices.phone_alt,
	devices.period,
	devices.trap,
	devices.read_location,
	devices.read_gps,
	devices.new,
	devices.new_time,
	devices.uptime,
	devices.read_temp_volt,
	devices.num_send_avail,
	devices.num_fails_msg,


              tx_account + rx_account as total,
              tx_account_alt + rx_account_alt as total_alt,
              tx_account_alt2 + rx_account_alt2 as total_alt2,
              groups.description as group_desc,
              groups.level_limit as level_limit,
              groups.traffic_limit as traffic_limit,
              groups.traffic_limit_alt as traffic_limit_alt,
              groups.traffic_limit_alt2 as traffic_limit_alt2,
              groups.temp_limit_lo as temp_limit_lo,
              groups.temp_limit_hi as temp_limit_hi,
              groups.volt_limit_lo as volt_limit_lo,
              groups.volt_limit_hi as volt_limit_hi,
              groups.qual_limit_lo as qual_limit_lo,
              groups.max_fails as max_fails,
			  devices.snmp_prot
            FROM devices, groups WHERE devices.group_id IN (SELECT user_group.group_id FROM user_group WHERE user_group.user_id = id) AND devices.group_id = groups.group_id ORDER BY device_id;

            SET @sql = CONCAT(\'SELECT
              dev_num,
              device_id,
              description,
              hostname,
              hostname_alt,
              hostname_alt2,
              location,
              coordinates,
              note,
              enabled,
              product,
              firmware,
              sn,
              imei,
              esn,
              tx_account,
              rx_account,
              total,
              tx_account_alt,
              rx_account_alt,
              total_alt,
              tx_account_alt2,
              rx_account_alt2,
              total_alt2,
              last_level,
              last_status,
              autoupdate,
              health,
              health_alt,
              health_alt2,
              DATE_FORMAT(last_time_act,"%d-%m-%Y %H:%i"),
              DATE_FORMAT(last_time_act_alt,"%d-%m-%Y %H:%i"),
              DATE_FORMAT(last_time_act_alt2,"%d-%m-%Y %H:%i"),
              trap,
              mac,
              group_desc,
              NULL,
              uptime,
              new,
              last_quality,
              last_temp,
              last_volt,
              level_limit,
              traffic_limit,
              traffic_limit_alt,
              traffic_limit_alt2,
              temp_limit_lo,
              temp_limit_hi,
              volt_limit_lo,
              volt_limit_hi,
              qual_limit_lo,
              name,
              max_fails,
			  snmp_prot
            FROM device_list WHERE ""="" \',params) ;

						PREPARE stmt FROM @sql;

						EXECUTE stmt;

						DEALLOCATE PREPARE stmt;

					END';

  $result = db_query($link, $sql);

  $sql = 'DROP PROCEDURE IF EXISTS sp_GetCompanies';
  $result = db_query($link, $sql);

  $sql = 'CREATE PROCEDURE sp_GetCompanies(params VARCHAR(255))
          BEGIN

            SET @comp_num = 0;

            DROP TABLE IF EXISTS company_list;
            CREATE TEMPORARY TABLE company_list ENGINE=MEMORY SELECT
              @comp_num := @comp_num + 1 as comp_num,
              company_id,
              name,
              devcount,
              address,
              email,
              phone,
              note
            FROM companies ORDER BY company_id;

            SET @sql = CONCAT(\'SELECT
              comp_num,
              company_id,
              name,
              devcount,
              address,
              email,
              phone,
              note
            FROM company_list WHERE "" = "" \',params);

            PREPARE stmt FROM @sql;
            EXECUTE stmt;
            DEALLOCATE PREPARE stmt;

          END';
  $result = db_query($link, $sql);

  $sql = 'DROP PROCEDURE IF EXISTS sp_GetGroupsAll';
  $result = db_query($link, $sql);

  $sql = 'CREATE PROCEDURE sp_GetGroupsAll(params VARCHAR(255))
          BEGIN

            SET @group_num = 0;

            DROP TABLE IF EXISTS group_list;
            CREATE TEMPORARY TABLE group_list ENGINE=MEMORY SELECT
              @group_num := @group_num + 1 as group_num,
              groups.company_id as company_id,
              companies.name as comp_name,
              group_id,
              groups.description as description,
              groups.level_limit as level_limit,
              groups.traffic_limit as traffic_limit,
              groups.traffic_limit_alt as traffic_limit_alt,
              groups.traffic_limit_alt2 as traffic_limit_alt2,
              groups.temp_limit_lo as temp_limit_lo,
              groups.temp_limit_hi as temp_limit_hi,
              groups.volt_limit_lo as volt_limit_lo,
              groups.volt_limit_hi as volt_limit_hi,
              groups.qual_limit_lo as qual_limit_lo,
              groups.max_fails as max_fails,
              groups.max_fails_msg as max_fails_msg,
              groups.delay_msg as delay_msg
            FROM groups LEFT JOIN companies ON groups.company_id = companies.company_id ORDER BY groups.description;

            SET @sql = CONCAT(\'SELECT
              group_num,
              group_id,
              comp_name,
              description,
              level_limit,
              traffic_limit,
              traffic_limit_alt,
              traffic_limit_alt2,
              temp_limit_lo,
              temp_limit_hi,
              volt_limit_lo,
              volt_limit_hi,
              qual_limit_lo,
              max_fails,
              max_fails_msg,
              delay_msg
            FROM group_list WHERE "" = "" \',params);

            PREPARE stmt FROM @sql;
            EXECUTE stmt;
            DEALLOCATE PREPARE stmt;

          END';
  $result = db_query($link, $sql);

  $sql = 'DROP PROCEDURE IF EXISTS sp_GetGroupsCompany';
  $result = db_query($link, $sql);

  $sql = 'CREATE PROCEDURE sp_GetGroupsCompany(params VARCHAR(255), id INT(5))
          BEGIN

            SET @group_num = 0;

            DROP TABLE IF EXISTS group_list;
            CREATE TEMPORARY TABLE group_list ENGINE=MEMORY SELECT
              @group_num := @group_num + 1 as group_num,
              groups.company_id as company_id,
              companies.name as comp_name,
              group_id,
              groups.description as description,
              groups.level_limit as level_limit,
              groups.traffic_limit as traffic_limit,
              groups.traffic_limit_alt as traffic_limit_alt,
              groups.traffic_limit_alt2 as traffic_limit_alt2,
              groups.temp_limit_lo as temp_limit_lo,
              groups.temp_limit_hi as temp_limit_hi,
              groups.volt_limit_lo as volt_limit_lo,
              groups.volt_limit_hi as volt_limit_hi,
              groups.qual_limit_lo as qual_limit_lo,
              groups.max_fails as max_fails,
              groups.max_fails_msg as max_fails_msg,
              groups.delay_msg as delay_msg
              
            FROM groups LEFT JOIN companies ON groups.company_id = companies.company_id WHERE groups.company_id = id ORDER BY groups.description;

            SET @sql = CONCAT(\'SELECT
              group_num,
              group_id,
              comp_name,
              description,
              level_limit,
              traffic_limit,
              traffic_limit_alt,
              traffic_limit_alt2,
              temp_limit_lo,
              temp_limit_hi,
              volt_limit_lo,
              volt_limit_hi,
              qual_limit_lo,
              max_fails,
              max_fails_msg,
              delay_msg
              
            FROM group_list WHERE "" = "" \',params);

            PREPARE stmt FROM @sql;
            EXECUTE stmt;
            DEALLOCATE PREPARE stmt;

          END';
  $result = db_query($link, $sql);

  $sql = 'DROP PROCEDURE IF EXISTS sp_GetGroupsUser';
  $result = db_query($link, $sql);

  $sql = 'CREATE PROCEDURE sp_GetGroupsUser(params VARCHAR(255), id INT(5))
          BEGIN

            SET @group_num = 0;

            DROP TABLE IF EXISTS group_list;
            CREATE TEMPORARY TABLE group_list ENGINE=MEMORY SELECT
              @group_num := @group_num + 1 as group_num,
              groups.company_id as company_id,
              companies.name as comp_name,
              group_id,
              groups.description as description,
              groups.level_limit as level_limit,
              groups.traffic_limit as traffic_limit,
              groups.traffic_limit_alt as traffic_limit_alt,
              groups.traffic_limit_alt2 as traffic_limit_alt2,
              groups.temp_limit_lo as temp_limit_lo,
              groups.temp_limit_hi as temp_limit_hi,
              groups.volt_limit_lo as volt_limit_lo,
              groups.volt_limit_hi as volt_limit_hi,
              groups.qual_limit_lo as qual_limit_lo,
              groups.max_fails as max_fails,
              groups.max_fails_msg as max_fails_msg,
              groups.delay_msg as delay_msg
            FROM groups LEFT JOIN companies ON groups.company_id = companies.company_id WHERE groups.group_id IN (SELECT user_group.group_id FROM user_group WHERE user_id = id) ORDER BY groups.description;

            SET @sql = CONCAT(\'SELECT
              group_num,
              group_id,
              comp_name,
              description,
              level_limit,
              traffic_limit,
              traffic_limit_alt,
              traffic_limit_alt2,
              temp_limit_lo,
              temp_limit_hi,
              volt_limit_lo,
              volt_limit_hi,
              qual_limit_lo,
              max_fails,
              max_fails_msg,
              delay_msg
            FROM group_list WHERE "" = "" \',params);

            PREPARE stmt FROM @sql;
            EXECUTE stmt;
            DEALLOCATE PREPARE stmt;

          END';
  $result = db_query($link, $sql);

  $sql = 'DROP PROCEDURE IF EXISTS sp_GetUsersAll';
  $result = db_query($link, $sql);

  $sql = 'CREATE PROCEDURE sp_GetUsersAll(params VARCHAR(255))
          BEGIN

            SET @user_num = 0;

            DROP TABLE IF EXISTS user_list;
            CREATE TEMPORARY TABLE user_list ENGINE=MEMORY SELECT
              @user_num := @user_num + 1 as user_num,
              user_id,
              users.company_id as company_id,
              companies.name as comp_name,
              username,
              users.name as name,
              surname,
              users.email as email,
              users.phone as phone,
              rights,
              edit_device
            FROM users LEFT JOIN companies ON users.company_id = companies.company_id ORDER BY users.username;

            SET @sql = CONCAT(\'SELECT
              user_num,
              comp_name,
              user_id,
              username,
              name,
              surname,
              email,
              phone,
              rights,
              edit_device
            FROM user_list WHERE username != "default" \',params);

            PREPARE stmt FROM @sql;
            EXECUTE stmt;
            DEALLOCATE PREPARE stmt;

          END';
  $result = db_query($link, $sql);

  $sql = 'DROP PROCEDURE IF EXISTS sp_GetUsers';
  $result = db_query($link, $sql);

  $sql = 'CREATE PROCEDURE sp_GetUsers(params VARCHAR(255), comp_id INT(10))
          BEGIN

            SET @user_num = 0;

            DROP TABLE IF EXISTS user_list;
            CREATE TEMPORARY TABLE user_list ENGINE=MEMORY SELECT
              @user_num := @user_num + 1 as user_num,
              user_id,
              users.company_id as company_id,
              companies.name as comp_name,
              username,
              users.name as name,
              surname,
              users.email as email,
              users.phone as phone,
              rights,
              edit_device
            FROM users LEFT JOIN companies ON users.company_id = companies.company_id WHERE users.company_id = comp_id AND rights != "0" ORDER BY users.username;

            SET @sql = CONCAT(\'SELECT
              user_num,
              comp_name,
              user_id,
              username,
              name,
              surname,
              email,
              phone,
              rights,
              edit_device
            FROM user_list WHERE username != "default" \',params);

            PREPARE stmt FROM @sql;
            EXECUTE stmt;
            DEALLOCATE PREPARE stmt;

          END';
  $result = db_query($link, $sql);


	$sql	= 	'DROP PROCEDURE IF EXISTS sp_MakeSelection';
	$result = db_query($link, $sql);

	$sql	= 'CREATE PROCEDURE sp_MakeSelection(IN params VARCHAR(255),IN session VARCHAR(64),IN id INT(10))
					BEGIN

            DECLARE device int(10);
            DECLARE done bit(1) DEFAULT 0;
            DECLARE sel_pos CURSOR FOR
              SELECT * FROM temp_selection;

						DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;

            DROP TABLE IF EXISTS temp_selection;
            SET @sql = CONCAT(\'CREATE TEMPORARY TABLE temp_selection ENGINE=MEMORY

                                SELECT device_id FROM devices WHERE group_id IN (SELECT group_id FROM groups WHERE company_id = ?) \', params);

            SET @company_id = id;

            PREPARE stmt FROM @sql;
            EXECUTE stmt USING @company_id;
						DEALLOCATE PREPARE stmt;

            DROP TABLE IF EXISTS temp_sel;
            CREATE TEMPORARY TABLE temp_sel ENGINE=MEMORY SELECT device_id FROM selection WHERE session_id = session;

            DELETE FROM temp_selection WHERE device_id IN (SELECT * FROM temp_sel);

						OPEN sel_pos;
						get_sel_loop: LOOP
							FETCH sel_pos INTO device;
								IF done THEN LEAVE get_sel_loop; END IF;
                INSERT INTO selection (device_id, time, session_id) VALUES (device, NOW(), session);
						END LOOP get_sel_loop;
						CLOSE sel_pos;

					END';

	$result = db_query($link, $sql);

  /***************************** TRIGGERY ***************************/

	$sql	= 	'DROP TRIGGER IF EXISTS tr_UserAdd';
	$result = db_query($link, $sql);

  $sql = 'CREATE TRIGGER tr_UserAdd
          AFTER INSERT ON users
          FOR EACH ROW
          BEGIN
            INSERT INTO predef_sms(user_id, sms)
            VALUES (new.user_id, "reboot"),
              (new.user_id, "go offline"),
              (new.user_id, "online sim 1"),
              (new.user_id, "online sim 2"),
              (new.user_id, "set profile std"),
              (new.user_id, "set profile alt1"),
              (new.user_id, "set profile alt2"),
              (new.user_id, "set profile alt3"),
              (new.user_id, "set out0=0"),
              (new.user_id, "set out0=1"),
              (new.user_id, "set out1=0"),
              (new.user_id, "set out1=1");
          END';

	$result = db_query($link, $sql);


	$sql	= 	'DROP TRIGGER IF EXISTS tr_UserRemove';
	$result = db_query($link, $sql);

  $sql = 'CREATE TRIGGER tr_UserRemove
          BEFORE DELETE ON users
          FOR EACH ROW
          BEGIN
            DELETE FROM user_cfg WHERE user_id = old.user_id;
            DELETE FROM predef_sms WHERE user_id = old.user_id;
            DELETE FROM user_group WHERE user_id = old.user_id;
  				END';

	$result = db_query($link, $sql);

	$sql	= 	'DROP TRIGGER IF EXISTS tr_DeviceRemove';
	$result = db_query($link, $sql);

  $sql = 'CREATE TRIGGER tr_DeviceRemove
          BEFORE DELETE ON devices
          FOR EACH ROW
          BEGIN
            DELETE FROM day WHERE device_id = old.device_id;
            DELETE FROM fails WHERE device_id = old.device_id;
            DELETE FROM stats WHERE device_id = old.device_id;
          END';

	$result = db_query($link, $sql);

	$sql	= 	'DROP TRIGGER IF EXISTS tr_GroupRemove';
	$result = db_query($link, $sql);

  $sql = 'CREATE TRIGGER tr_GroupRemove
          BEFORE DELETE ON groups
          FOR EACH ROW
          BEGIN
            DELETE FROM user_group WHERE group_id = old.group_id;
            DELETE FROM devices WHERE group_id = old.group_id;
            DELETE FROM summary WHERE group_id = old.group_id;
          END';

	$result = db_query($link, $sql);

	$sql	= 	'DROP TRIGGER IF EXISTS tr_CompanyRemove';
	$result = db_query($link, $sql);

  $sql = 'CREATE TRIGGER tr_CompanyRemove
          BEFORE DELETE ON companies
          FOR EACH ROW
          BEGIN
            DELETE FROM users WHERE company_id = old.company_id;
            DELETE FROM groups WHERE company_id = old.company_id;
          END';

	$result = db_query($link, $sql);


	echo('Procedures & Triggers were installed succesfully.');

  // ulozime verzi instalace procedur
  $set = 'set Web.last_version '.VERSION;

  if(service_message($set, $reply))
  { // nastala chyba
    echo($reply);
    exit;
  }

  $_SESSION['params_ok'] = 0;

?>
