<?php

  echo "                        <tr align=\"left\">\n";
  echo "                          <td nowrap class=\"header\">Availability</td>\n";
  echo "                        </tr>\n";
  echo "                        <tr align=\"center\">\n";
  echo "                          <td align=\"center\">\n";
  echo "                            <table>\n";
  echo "                              <tr>\n";
  echo "                                <td>Average availability over period</td>\n";

  switch( $data_src )
  {
    case "all":

      $sql = 'SELECT AVG(availability)
              FROM summary
              WHERE group_id IN (SELECT group_id FROM groups WHERE company_id = "'.get_company_id().'")
              AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"';

      break;

    case "group":
      $sql = 'SELECT AVG(availability)
              FROM summary
              WHERE group_id = "'.$group_id.'"
              AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"';

      break;          
    
    default:

      $sql = 'SELECT AVG(availability)
              FROM stats
              WHERE device_id = (SELECT device_id FROM devices WHERE hostname = "'.$host.'" OR hostname_alt = "'.$host.'" LIMIT 1)
              AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"';
  
  }

  $result = db_query($link, $sql);				
  list($avail) = mysqli_fetch_row($result);

  echo "                                <td>".round($avail,1)." %</td>\n";
  echo "                              </tr>\n";
  echo "                            </table>\n";  
  echo "                          </td>\n";
  echo "                        </tr>\n";        

  echo "                        <tr>\n";
  echo "                          <td>\n";
  echo "                            <table>\n";
  echo "                              <tr>\n";
  echo "                                <td><b>Average availability for network per day of period</b></td>\n";
  echo "                              </tr>\n";
  echo "                            </table>\n";  
  echo "                          </td>\n";
  echo "                        </tr>\n";      
  echo "                        <tr align=\"center\">\n";
  echo "                          <td align=\"center\">\n";
  echo "                            <table border=\"1\" style=\"border-collapse: collapse;\">\n";

  $is_one_day = (($to - $from) <= 86400) ? 1 : 0;

  switch( $data_src )
  {
    case "all":

      if( $is_one_day )
      {

        $sql = 'SELECT DATE_FORMAT(time,"%H:00") as hour, AVG(availability)
                FROM summary
                WHERE group_id IN (SELECT group_id FROM groups WHERE company_id = "'.get_company_id().'")
                AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"
                GROUP BY DATE_FORMAT(time,"%d-%m-%Y %H")
                ORDER BY hour';
        
      }
      else
      {

        $sql = 'SELECT DATE_FORMAT(time,"%Y-%m-%d") as hour, AVG(availability)
                FROM summary
                WHERE group_id IN (SELECT group_id FROM groups WHERE company_id = "'.get_company_id().'")
                AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"
                GROUP BY DATE_FORMAT(time,"%d-%m-%Y")
                ORDER BY hour';

      }

      break;

    case "group":

      if( $is_one_day )
      {

        $sql = 'SELECT DATE_FORMAT(time,"%H:%i"), availability 
                FROM summary 
                WHERE group_id = "'.$group_id.'"
                AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"
                ORDER BY time';
        
      }
      else
      {

        $sql = 'SELECT DATE_FORMAT(time,"%Y-%m-%d"), AVG(availability) 
                FROM summary 
                WHERE group_id = "'.$group_id.'"
                AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"
                GROUP BY DATE_FORMAT(time,"%d-%m-%Y")
                ORDER BY time';

      }      

      break;          
    
    default:

      if( $is_one_day )
      {

        $sql = 'SELECT DATE_FORMAT(time,"%H:%i"), availability
                FROM stats
                WHERE device_id = (SELECT device_id FROM devices WHERE hostname = "'.$host.'" OR hostname_alt = "'.$host.'" LIMIT 1)
                AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"
                ORDER BY time';
        
      }
      else
      {

        $sql = 'SELECT DATE_FORMAT(time,"%Y-%m-%d"), AVG(availability)
                FROM stats
                WHERE device_id = (SELECT device_id FROM devices WHERE hostname = "'.$host.'" OR hostname_alt = "'.$host.'" LIMIT 1)
                AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"
                GROUP BY DATE_FORMAT(time,"%d-%m-%Y")
                ORDER BY time';

      }      

  }

  $result = db_query($link, $sql);

  $count = mysqli_num_rows( $result ) ? ceil(mysqli_num_rows( $result ) / 3) * 3 : 3;

  $rows = $count / 3;
								
  $day = array();
  $day_avg_avail = array();
  for($i = 0;$i < $count;$i++)
  {
    list($temp_day ,$temp) = mysqli_fetch_row($result);
    $day[$i] = is_null($temp_day) ? '---' : $temp_day;										
    $day_avg_avail[$i] = is_null($temp) ? '---' : round($temp,0);
  }									

  echo "                              <tr>\n";
  if( $is_one_day ){
    echo "                                <th>Time</th><th>Availability</th><td></td><th>Time</th><th>Availability</th><td></td><th>Time</th><th>Availability</th>\n";
  }
  else
  {
    echo "                                <th>Day</th><th>Availability</th><td></td><th>Day</th><th>Availability</th><td></td><th>Day</th><th>Availability</th>\n";
  }
  echo "                              </tr>\n";

  for($i = 0;$i < $rows;$i++)
  {
    echo "                              <tr align=\"center\" class=\"tab_line".($i % 2)."\"><td width=\"80\">".$day[$i]."</td><td>".$day_avg_avail[$i]." %</td><td></td>\n";
    echo "                                <td width=\"80\">".$day[$i + $rows]."</td><td>".$day_avg_avail[$i + $rows]." %</td><td></td>\n";
    echo "                                <td width=\"80\">".$day[$i + 2 * $rows]."</td><td>".$day_avg_avail[$i + 2 * $rows]." %</td></tr>\n";
  }

  echo "                            </table>\n";
  echo "                          </td>\n";
  echo "                        </tr>\n";

  $filename = $temp_path."/avail.png";
  include "php/report_graph_avail.php";

  echo "                        <tr align=\"center\">\n";
  echo "                          <td><img src=\"".$filename."\" class=\"graph\"></td>\n";
  echo "                        </tr>\n";

  if( $list_err == "1" )      
  { 
    echo "                        <tr>\n";
    echo "                          <td>\n";
    echo "                            <table>\n";
    echo "                              <tr>\n";
    echo "                                <td><b>List of sites with daily availability lower then specific value (".$avail_limit." %)</b></td>\n";
    echo "                              </tr>\n";
    echo "                            </table>\n";  
    echo "                          </td>\n";
    echo "                        </tr>\n";
    echo "                        <tr align=\"center\">\n";
    echo "                          <td align=\"center\">\n";
    echo "                            <table border=\"1\" style=\"border-collapse: collapse;\">\n";
    echo "                              <tr>\n";
    echo "                                <th>Date</th>\n";
    echo "                                <th>Availability</th>\n";

    foreach( $header as $id => $col_name )
    {
      echo "                                <th>".$col_name."</th>\n";
    }

    echo "                              </tr>\n";

    /*-------------------------------------------------- CSV ---------------------------------------------*/
    fwrite($csv,"List of sites with daily availability lower then specific value (".$avail_limit." %)\n");
    fwrite($csv,", Date, Availability");    

    foreach( $header as $id => $col_name )
    {
      fwrite($csv, ",".$col_name);
    }

    fwrite($csv, "\n");
    /*-------------------------------------------------- CSV ---------------------------------------------*/

    switch( $data_src )
    {
      case "all":

        $sql = 'SELECT day.date, day.availability, devices.hostname, devices.hostname_alt, devices.description, devices.location, devices.product, devices.note, devices.mac, devices.firmware, devices.sn, devices.imei, devices.esn, devices.health, devices.health_alt, devices.trap
                FROM day
                LEFT JOIN devices ON day.device_id = devices.device_id
                WHERE day.device_id IN (SELECT device_id FROM devices WHERE group_id IN (SELECT group_id FROM groups WHERE company_id = "'.get_company_id().'"))
                AND date BETWEEN "'.date("Y-m-d", $from).'" AND "'.date("Y-m-d", $to).'"
                AND day.availability < "'.$avail_limit.'"';

        break;

      case "group":
        $sql = 'SELECT day.date, day.availability, devices.hostname, devices.hostname_alt, devices.description, devices.location, devices.product, devices.note, devices.mac, devices.firmware, devices.sn, devices.imei, devices.esn, devices.health, devices.health_alt, devices.trap
                FROM day
                LEFT JOIN devices ON day.device_id = devices.device_id
                WHERE day.device_id IN (SELECT device_id FROM devices WHERE group_id = "'.$group_id.'")
                AND date BETWEEN "'.date("Y-m-d", $from).'" AND "'.date("Y-m-d", $to).'"
                AND day.availability < "'.$avail_limit.'"';

        break;          
        
      default:

        $sql = 'SELECT day.date, day.availability, devices.hostname, devices.hostname_alt, devices.description, devices.location, devices.product, devices.note, devices.mac, devices.firmware, devices.sn, devices.imei, devices.esn, devices.health, devices.health_alt, devices.trap
                FROM day
                LEFT JOIN devices ON day.device_id = devices.device_id
                WHERE day.device_id = (SELECT device_id FROM devices WHERE hostname = "'.$host.'" OR hostname_alt = "'.$host.'" LIMIT 1)
                AND date BETWEEN "'.date("Y-m-d", $from).'" AND "'.date("Y-m-d", $to).'"
                AND day.availability < "'.$avail_limit.'"';

    }
							
    $result = db_query($link, $sql);
    $i = 0;
    $cell = array();
    if(mysqli_num_rows($result))
    {		 
      while(list($avail_date, $avail_level, $hostname, $hostname_alt, $desc, $location, $product, $note, $mac, $firmware, $sn, $imei, $esn, $health, $health_alt, $trap) = mysqli_fetch_row($result))
      {

        $cell["hostname"] = is_null($hostname) ? '---' : $hostname;
        $cell["hostname_alt"] = is_null($hostname_alt) ? '---' : $hostname_alt;
        $cell["description"] = is_null($desc) ? '---' : $desc;
        $cell["location"] = is_null($location) ? '---' : $location;
        $cell["device"] = is_null($product) ? '---' : $product;
        $cell["note"] = is_null($note) ? '---' : $note;
        $cell["firmware"] = is_null($firmware) ? '---' : $firmware;
        $cell["sn"] = is_null($sn) ? '---' : $sn;
        $cell["imei"] = is_null($imei) ? '---' : $imei;
        $cell["esn"] = is_null($esn) ? '---' : $esn;
        $cell["access_mode"] = is_null($trap) ? '---' : (($trap == 0) ? 'Polling' : 'SNMP Trap');
        $cell["router_status"] = ($health < $health_alt ? $health : $health_alt);

        if( $i <= 28 )
        {
          echo "                              <tr align=\"center\" class=\"tab_line".($i % 2)."\">\n";		
          echo "                                <td nowrap>".$avail_date."</td>\n";
          echo "                                <td nowrap>".$avail_level." %</td>\n";
      
          foreach($report_list_selected as $id => $par_name)
          {
            echo "                                <td nowrap>".$cell[$par_name]."</td>\n";      
          }

          echo "                              </tr>\n";

        }

        /*-------------------------------------------------- CSV ---------------------------------------------*/
        fwrite($csv, ",\"".$avail_date."\"");
        fwrite($csv, ",\"".$avail_level."\"");

        foreach($report_list_selected as $id => $par_name)
        {
          fwrite($csv, ",\"".$cell[$par_name]."\"");
        }

        fwrite($csv, "\n");
        /*-------------------------------------------------- CSV ---------------------------------------------*/

        $i++;
      }
    }
    else
    {
      echo "                              <tr align=\"center\" class=\"tab_line0\">\n";
      echo "                                <td>---</td>\n<td>---</td>\n";

      foreach($report_list_selected as $id => $par_name)
      {
        echo "                                <td>---</td>\n";
      }    

      echo "                              </tr>\n";
    }																
    echo "                            </table>\n";

    if($i > 28)
    {
      echo('List was limited. All data are available in a CSV file...');
    }

    echo "                          </td>\n";
    echo "                        </tr>\n";
  }

?>
