<?php

  echo "                        <tr align=\"left\">\n";
  echo "                          <td nowrap class=\"header\">Signal Strength</td>\n";
  echo "                        </tr>\n";
  echo "                        <tr align=\"center\">\n";
  echo "                          <td align=\"center\">\n";
  echo "                            <table>\n";
  echo "                              <tr>\n";
  echo "                                <td>% with signal strength better than ".$signal_limit." dBm over period:</td>\n";
  echo "                                <td>\n";


  switch( $data_src )
  {
    case "all":

      $sql = 'CREATE TEMPORARY TABLE report_src
              ENGINE=MEMORY
              SELECT device_id
              FROM devices
              WHERE group_id IN (SELECT group_id FROM groups WHERE company_id = "'.get_company_id().'")';

      break;

    case "group":
      $sql = 'CREATE TEMPORARY TABLE report_src
              ENGINE=MEMORY
              SELECT device_id
              FROM devices
              WHERE group_id = "'.$group_id.'"';

      break;          
        
    default:

      $sql = 'CREATE TEMPORARY TABLE report_src
              ENGINE=MEMORY
              SELECT device_id
              FROM devices
              WHERE device_id = (SELECT device_id FROM devices WHERE hostname = "'.$host.'" OR hostname_alt = "'.$host.'" LIMIT 1)';
      
  }

  $result = db_query($link, $sql);      

  $sql = 'SELECT (COUNT(IF(level_aver > "'.$signal_limit.'",1,NULL))/COUNT(*))*100
          FROM day 
          WHERE level_aver IS NOT NULL 
          AND device_id IN (SELECT device_id FROM report_src) 
          AND date BETWEEN "'.date("Y-m-d", $from).'" AND "'.date("Y-m-d", $to).'"';

  $result = db_query($link, $sql);				
  list($percents) = mysqli_fetch_row($result);

  echo "                                ".round($percents,1)." %";      
  echo "                                </td>\n";
  echo "                              </tr>\n";
  echo "                            </table>\n";  
  echo "                          </td>\n";
  echo "                        </tr>\n";      

  $is_one_day = (($to - $from) <= 86400) ? 1 : 0;

  if( !$is_one_day )
  {

    echo "                        <tr>\n";
    echo "                          <td>\n";
    echo "                            <table>\n";
    echo "                              <tr>\n";
    echo "                                <td><b>% with signal strength better than ".$signal_limit." dBm per day of period:</b></td>\n";
    echo "                              </tr>\n";
    echo "                            </table>\n";  
    echo "                          </td>\n";
    echo "                        </tr>\n";      

    echo "                        <tr align=\"center\">\n";
    echo "                          <td align=\"center\">\n";
    echo "                            <table border=\"1\" style=\"border-collapse: collapse;\">\n";
  
    $sql = 'SELECT DATE_FORMAT(date,"%Y-%m-%d"),(COUNT(IF(level_aver > "'.$signal_limit.'",1,NULL))/COUNT(*))*100  
            FROM day 
            WHERE date > DATE_SUB(NOW(),INTERVAL 30 DAY) 
            AND level_aver IS NOT NULL
            AND device_id IN (SELECT device_id FROM report_src)
            GROUP BY date
            ORDER BY date';
    $result = db_query($link, $sql);

    $count = mysqli_num_rows( $result ) ? ceil(mysqli_num_rows( $result ) / 3) * 3 : 3;

    $rows = $count / 3;  
										
    $day = array();
    $day_signal_level = array();
    for($i = 0;$i < $count;$i++)
    {
      list($temp_day ,$temp) = mysqli_fetch_row($result);
      $day[$i] = is_null($temp_day) ? '---' : $temp_day;										
      $day_signal_level[$i] = is_null($temp) ? '---' : round($temp,1);
    }

    echo "                              <tr>\n";
    echo "                                <th>Day</th><th>signal strength<br> > ".$signal_limit." dBm</th>\n";
    echo "                                <td></td>\n";
    echo "                                <th>Day</th><th>signal strength<br> > ".$signal_limit." dBm</th>\n";
    echo "                                <td></td>\n";
    echo "                                <th>Day</th><th>signal strength<br> > ".$signal_limit." dBm</th>\n";
    echo "                              </tr>\n";

    for($i = 0;$i < $rows;$i++)
    {
      echo "                              <tr align=\"center\" class=\"tab_line".($i % 2)."\">\n";
      echo "                                <td width=\"80px\">".$day[$i]."</td><td>".$day_signal_level[$i]." %</td><td></td>\n";
      echo "                                <td width=\"80px\">".$day[$i + $rows]."</td><td>".$day_signal_level[$i + $rows]." %</td><td></td>\n";
      echo "                                <td width=\"80px\">".$day[$i + 2 * $rows]."</td><td>".$day_signal_level[$i + 2 * $rows]." %</td>\n";
      echo "                              </tr>\n";
    }

    echo "                            </table>\n";
    echo "                          </td>\n";
    echo "                        </tr>\n";      
  }

  if( $list_err == "1" )    
  {
    echo "                        <tr>\n";
    echo "                          <td>\n";
    echo "                            <table>\n";
    echo "                              <tr>\n";
    echo "                                <td><b>List of sites with daily signal strength worse then ".$signal_limit." dBm:</b></td>\n";
    echo "                              </tr>\n";
    echo "                            </table>\n";  
    echo "                          </td>\n";
    echo "                        </tr>\n";
    echo "                        <tr align=\"center\">\n";
    echo "                          <td align=\"center\">\n";
    echo "                            <table border=\"1\" style=\"border-collapse: collapse;\">\n";
    echo "                              <tr>\n";
    echo "                                <th>Date</th><th>Signal Strength</th>\n";

    foreach( $header as $id => $col_name )
    {
      echo "                                <th>".$col_name."</th>\n";
    }

    echo "                              </tr>\n";

    /*-------------------------------------------------- CSV ---------------------------------------------*/
    fwrite($csv,"List of sites with daily signal strength worse then (".$signal_limit." dBm)\n");
    fwrite($csv,", Date, Signal level");    

    foreach( $header as $id => $col_name )
    {
      fwrite($csv, ",".$col_name);
    }

    fwrite($csv, "\n");
    /*-------------------------------------------------- CSV ---------------------------------------------*/

    $sql = 'SELECT DATE_FORMAT(day.date,"%d-%m-%Y"), day.level_aver, devices.hostname, devices.hostname_alt, devices.description, devices.location, devices.product, devices.note, devices.mac, devices.firmware, devices.sn, devices.imei, devices.esn, devices.health, devices.health_alt, devices.trap										
            FROM day, devices 
            WHERE level_aver < "'.$signal_limit.'"
            AND day.device_id IN (SELECT device_id FROM report_src) 
            AND date BETWEEN "'.date("Y-m-d", $from).'" AND "'.date("Y-m-d", $to).'" 
            AND day.device_id = devices.device_id';
						
    $result = db_query($link, $sql);
    $i = 0;
												
    if(mysqli_num_rows($result))
    {
      while(list($ss_date, $ss_level, $hostname, $hostname_alt, $desc, $location, $product, $note, $mac, $firmware, $sn, $imei, $esn, $health, $health_alt, $trap) = mysqli_fetch_row($result))    
        {

        $cell["hostname"] = is_null($hostname) ? '---' : $hostname;
        $cell["hostname_alt"] = is_null($hostname_alt) ? '---' : $hostname_alt;
        $cell["description"] = is_null($desc) ? '---' : $desc;
        $cell["location"] = is_null($location) ? '---' : $location;
        $cell["device"] = is_null($product) ? '---' : $product;
        $cell["note"] = is_null($note) ? '---' : $note;
        $cell["firmware"] = is_null($firmware) ? '---' : $firmware;
        $cell["sn"] = is_null($sn) ? '---' : $sn;
        $cell["imei"] = is_null($imei) ? '---' : $imei;
        $cell["esn"] = is_null($esn) ? '---' : $esn;
        $cell["access_mode"] = is_null($trap) ? '---' : (($trap == 0) ? 'Polling' : 'SNMP Trap');
        $cell["router_status"] = ($health < $health_alt ? $health : $health_alt);

        if( $i <= 28 )
        {

          echo "                              <tr align=\"center\" class=\"tab_line".($i % 2)."\">\n";		
          echo "                                <td nowrap>".$ss_date."</td>\n";
          echo "                                <td nowrap>".$ss_level." dBm</td>\n";

          foreach($report_list_selected as $id => $par_name)
          {
            echo "                                <td nowrap>".$cell[$par_name]."</td>\n";      
          }

          echo "                              </tr>\n";
        }

        /*-------------------------------------------------- CSV ---------------------------------------------*/
        fwrite($csv, ",\"".$ss_date."\"");
        fwrite($csv, ",\"".$ss_level."\"");

        foreach($report_list_selected as $id => $par_name)
        {
          fwrite($csv, ",\"".$cell[$par_name]."\"");
        }

        fwrite($csv, "\n");
        /*-------------------------------------------------- CSV ---------------------------------------------*/

        $i++;
      }
    }
    else
    {
      echo "                              <tr align=\"center\" class=\"tab_line0\">\n";
      echo "                                <td>---</td>\n<td>---</td>\n";

      foreach($report_list_selected as $id => $par_name)
      {
        echo "                                <td>---</td>\n";
      }

      echo "                              </tr>\n";
    }
												
    echo "                            </table>\n";

    if($i > 28)
    {
      echo "List was limited. All data are available in a CSV file...\n";
    }

    echo "                          </td>\n";
    echo "                        </tr>\n";
  }

?>
