<?php

  // spusteni session
  session_start();

  class Telnet
  {
    protected $socket;
    private $hostname;

    private function connect_again()
    {
      $this->socket = pfsockopen($this->hostname, 23, $errno, $errstr, 20);
    }

    public function connect()
    {
      $this->socket = pfsockopen($this->hostname, 23, $errno, $errstr, 20);
      if(!$this->socket)
      {
        error_log("Socket is not created. Error: ".$errstr."\n");
        return false;
      }
      if(ftell($this->socket) == 0)
      {
        error_log("Socket is created\n");

        $header1=chr(0xFF).chr(0xFB).chr(0x1F).chr(0xFF).chr(0xFB).
          chr(0x20).chr(0xFF).chr(0xFB).chr(0x18).chr(0xFF).chr(0xFB).
          chr(0x27).chr(0xFF).chr(0xFD).chr(0x01).chr(0xFF).chr(0xFB).
          chr(0x03).chr(0xFF).chr(0xFD).chr(0x03).chr(0xFF).chr(0xFC).
          chr(0x23).chr(0xFF).chr(0xFC).chr(0x24).chr(0xFF).chr(0xFA).
          chr(0x1F).chr(0x00).chr(0x50).chr(0x00).chr(0x18).chr(0xFF).
          chr(0xF0).chr(0xFF).chr(0xFA).chr(0x20).chr(0x00).chr(0x33).
          chr(0x38).chr(0x34).chr(0x30).chr(0x30).chr(0x2C).chr(0x33).
          chr(0x38).chr(0x34).chr(0x30).chr(0x30).chr(0xFF).chr(0xF0).
          chr(0xFF).chr(0xFA).chr(0x27).chr(0x00).chr(0xFF).chr(0xF0).
          chr(0xFF).chr(0xFA).chr(0x18).chr(0x00).chr(0x58).chr(0x54).
          chr(0x45).chr(0x52).chr(0x4D).chr(0xFF).chr(0xF0);

        $header2=chr(0xFF).chr(0xFC).chr(0x01).chr(0xFF).chr(0xFC).
          chr(0x22).chr(0xFF).chr(0xFE).chr(0x05).chr(0xFF).chr(0xFC).chr(0x21); 

        fwrite($this->socket,$header1);
        fread($this->socket, 1024);
  		 // usleep(125000);
        fwrite($this->socket,$header2);
      }  
      return true;      
    }

    public function disconnect()
    {
      if(!$this->socket)
      {
        error_log("Error: Socket is not exists\n");
        return "Error: Socket is not exists\n";
      }
      fclose($this->socket);
      return "Disconnected\n";
    }  
  
    public function write($data)
    {
      if(!$this->socket)
      {
        error_log("Write error: Socket is not exists\n");
        return "Write error: Socket is not exists\n";
      }
      if(!fwrite($this->socket, $data."\r\n"))
      {
        return "Error in writing to socket";
      }
      return "";
    }
    
    public function read()
    {
      if(!$this->socket)
      {
        error_log("Read error: Socket is not exists\n");
        return "Read error: Socket is not exists\n";
      }
      $reply = '';
/*      $read = array($this->socket);
      $write = array();
      $except = array();
      if(socket_select($read,$write,$except,0) > 0)
      {
        while (!feof($this->socket)) {*/
          stream_set_timeout($this->socket, 0);
          $reply .= fread($this->socket, 256);
/*        }
      }  */
      return $reply;
    }

    public function __construct($hostname)
    {
      $this->hostname = $hostname;
      $this->connect();
      error_log("construct");
    }

    public function __destruct()
    {
      $_SESSION['telnet_connection'] = serialize($this);      
      error_log("destruct");
    }

    public function __sleep()
    {
      error_log("sleep");
      return array('hostname');
    }

    public function __wakeup()
    {
      error_log("wakeup");      
      $this->connect();
    }

  }
  
  if(isset($_SESSION['telnet_connection']) === TRUE)
  {
    $telnet = unserialize($_SESSION['telnet_connection']);
  }
  else
  {
    $telnet = new Telnet("192.168.2.231"/*$_GET['hostname']*/);
  }

  error_log("Operace: ".$_GET['oper']);

  switch($_GET['oper'])
  { // pripojeni k hostu
    case "connect":
    {
      error_log("Pripojeni k: ".$_GET['hostname']);
      $reply = $telnet->read();
      error_log($reply);
      echo $reply;    
      break;
    }

    case "disconnect":
    {
      error_log("Odpojeni");
      $telnet->disconnect();
      unset($GLOBALS[_SESSION]['telnet_connection']);
      break;
    }

    case "cmd_send":
    {
      $cmd = $_GET['cmd'];

      error_log("Command: ".$cmd);

      $telnet->write($cmd);

      $reply = $telnet->read();
//      error_log($reply);
      echo $reply;    
      break;
    }

    case "read":
    {
      $reply = $telnet->read();
      error_log("Poll: ".$reply);
      echo $reply;    
      break;
    }

    default:
    {
      echo "Error: Unknown operation\n";
      break;
    }
  }

?>
